#include "TPol3D.h"
#include "TString.h"
#include <iostream>
#include "ropecmds.h"

extern "C" { void strnam_( int * n, char * c );}
extern "C" { void odpblk_( const char * c,  int * n );}
extern "C" { void odpsum_( const char * c,  int * n,   Float_t *x, Float_t *y, Float_t *z);}

extern int gODpbSwitch;
//extern  const int gMaxIntOD;
//extern  const int gMaxRealOD;
extern TString gBlockName;
extern Int_t gBlockNumber;

ClassImp(TPol3D)

TPol3D::TPol3D(Int_t n, Float_t *x, Float_t *y, Float_t *z)
				:  TPolyLine3D(n,x,y,z) 
{
	fStrNr = -1;
	fElmId = -1;
}
;
TPol3D::~TPol3D()
{}
;
void TPol3D::PrintDataDocumented()
{
	std::cout << "fStrNr " << fStrNr << " fElmId " << fElmId 
	<< " Name " << fName << " Title " << fTitle << std::endl;
	TString blockname = fName(4,4);
	gRC->printod_withdoc(blockname, fElmId);
	
}
void TPol3D::PrintData()
{
	std::cout << "PrintData: fStrNr " << fStrNr << " fElmId " << fElmId 
	<< " Name " << fName << " Title " << fTitle << std::endl;
	TString det = fName(4,4);
	gODpbSwitch = 0;
	odpblk_(det.Data(), &fElmId);
}
;
void TPol3D::PrintDataTerse()
{
	std::cout << "PrintData terse: fStrNr " << fStrNr << " fElmId " << fElmId 
	<< " Name " << fName << " Title " << fTitle << std::endl;
	TString det = fName(4,4);
	Float_t x=0, y=0, z=0;
	odpsum_(det.Data(), &fElmId, &x, &y, &z);
}
;
