#!/bin/bash
#
# Initialize paths for grope running with ROOT and OPENGL
# The debian/ ubuntu package ia32-libs must be install on x86_64 systems
# ROOTSYS and CERN must point to 32 bit installations
# The needed 32bit libftgl.so.2 and libgfortran.so.3 are in $GROPE/lib
#
# if you dont use the module package (http://modules.sourceforge.net/)
# remove these lines and make otherwise sure that no other installations
# of ROOT are in your PATHs
#

module unload marabou
module unload root

if [ -z "$GROPE" ] 
then
#  find out where iniRopePath.sh is located and set
#  GROPE to this directory
	INVOCATION=${BASH_ARGV[0]}
	if [ -z "$INVOCATION" ]
	then
		echo "This script must be sourced"
		exit -1
	fi
	MYLOCATION="${PWD}/${BASH_ARGV[0]}"
		#GROPE=`pwd`
	MYLOCATION="${MYLOCATION%/*}"
	cd $MYLOCATION
	export GROPE=$PWD
	TEMP=`ls $GROPE/iniRopePath.sh`
	if [ -z "$TEMP" ]
	then
		echo "Something is wrong with: " $GROPE
	else
		echo "Setting GROPE to: " $GROPE
	fi
	cd $OLDPWD
fi
export ROOTSYS=$GROPE/root32
export CERN=$GROPE/cernlib32
export PATH=$ROOTSYS/bin:$GROPE/bin:$PATH
export LD_LIBRARY_PATH=$ROOTSYS/lib:$CERN/lib:$LD_LIBRARY_PATH
NEEDJPEG=`ldd $ROOTSYS/lib/libASImage.so | grep jpeg | grep "not found"`
if [ -n "$NEEDJPEG" ]
then
	echo "Add our copy of libjpeg.so to LD_LIBRARY_PATH"
# 	export LD_LIBRARY_PATH=$GROPE/lib:$LD_LIBRARY_PATH
fi
NEEDFTGL=`ldd $ROOTSYS/lib/libRGL.so | grep ftgl | grep "not found"`
if [ -n "$NEEDFTGL" ]
then
	echo "Add our copy of libftgl.so to LD_LIBRARY_PATH"
# 	export LD_LIBRARY_PATH=$GROPE/lib:$LD_LIBRARY_PATH
fi
NEEDGFORTRAN=`ldd $GROPE/bin/grope.exe | grep libgfortran | grep "not found"`
if [ -n "$NEEDGFORTRAN" ]
then
	echo "Add our copy of libgfortran.so to LD_LIBRARY_PATH"
# 	export LD_LIBRARY_PATH=$GROPE/lib:$LD_LIBRARY_PATH
fi

if [ -n "$NEEDFTGL"  -o -n "$NEEDJPEG" -o -n "$NEEDGFORTRAN" ]
then
	export LD_LIBRARY_PATH=$GROPE/lib:$LD_LIBRARY_PATH
fi