CDECK  ID>, RMAINI.
      PROGRAM RMAINI
*.
*...RMAINI Main program for interactive running
*.
*.         The size of GEANT and ROPE stores are defined here with
*.         parameters cards.The size of the blank common is also set.
*.
*. COMMON  : GCBANK PAWC BLANK
*. CALLS   : RCNTLI
*.
*. AUTHOR  : S.Weisz
*. VERSION : 1.01
*. CREATED : 18-May-87
*. LAST MOD: 18-May-92
*.
*. Modification Log.
*. 18-May-92  O.Schaile      put back OPEN(UNIT= 4 for Apollo
*. 13-Feb-92  O.Schaile      remove OPEN(UNIT= 4 for Apollo
*. 29-Nov-91  O.Schaile      Add HPUX error handling
*. 10-Nov-91  A.Lee          Add SGI error handling; only traceback.
*. 10-Nov-91  A.Lee          Add VAX error handler - ROTRAP (like IBM).
*. 23-Jan-91  S.Weisz        Open GKS error file in GRGKSI.
*. 11-Oct-90  S.Weisz        Modify error recovery on Apollo.
*. 16-Mar-90  S.Weisz        Inplement error recovery on Apollo.
*.  8-Sep-89  S.Weisz        Size of REPORT store defined here.
*. 15-Feb-89  S.Weisz        Optionnal run time error recovery on VAX.
*.                           Open FFREAD (unit=4) and GKS error (unit=37)
*.  6-Apr-88  S.Weisz        HBOOK4 only; set KUIP size in NKMEM.
*. 14-Mar-88  S.Weisz        Set size ZEBRA in NZMEM.
*. 27-Oct-87  S.Weisz        Set size of common PAWC.
*.
*.**********************************************************************
      IMPLICIT NONE
*
      EXTERNAL ZTELUS,QNEXT,ZEND
      INTEGER NZMEM,NHMEM,NKMEM,NRMEM
      INTEGER IGEANT,MEMOR,IREPOR
      PARAMETER (NZMEM=5 000 000)
      PARAMETER (NHMEM=200000)
      PARAMETER (NKMEM=10000)
      PARAMETER (NRMEM=41000)
      COMMON/GCBANK/IGEANT(NZMEM)
      COMMON/PAWC/MEMOR(NHMEM)
      COMMON/REBANK/IREPOR(NRMEM)
*--         Size of GEANT store.
      IGEANT(1)=NZMEM-1000
*--         Size of HBOOK common block.
      MEMOR(1)=NHMEM
      MEMOR(2)=NKMEM
*--         Size of REPORT store.
      IREPOR(1)=NRMEM-100
      CALL RCNTLI
*
      END
*
      SUBROUTINE QNEXT
*.
*...QNEXT    Get control in case of recoverable ZEBRA troubles.
*.
*. CALLS   : ROPINT ZEND
*. CALLED  : QNEXTE
*.
*. AUTHOR  : S.Weisz
*. VERSION : 1.01
*. CREATED : 11-Feb-88
*. LAST MOD: 30-Mar-94
*.
*. Modification Log.
*. 30-Mar-94 O.Schaile       Move call to KUINIM to RCNTLI
*.  1-Feb-94  O.Schaile      Add KUIP Motif
*. 13-Jun-89  S.Weisz        Call KUWHAG if Patchy selected.
*.  6-Apr-88  S.Weisz        Call KUWHAT.
*.
*.**********************************************************************
      IMPLICIT NONE
*      CALL KUINIM('GRope++')
      CALL KUEXEC('exec grope_panel')
      CALL KUWHAM('GRope++')
      CALL ZEND
      END
CDECK  ID>, RCNTLI.
      SUBROUTINE RCNTLI
*.
*...RCNTLI  Interactive ROPE control routine
*.
*. SEQUENCE: CRO RCNTRL RCREP RCLINE CRVER QFTITLE
*. COMMON  : PAWC
*. CALLS   : QNEXTE ROPPAK ROPINI ROPSET ROPIKU ROPFIN KUINIT FFGO
*.           TIMEX RPRTVS ZPHASE
*. CALLED  : RMAINI
*.
*. AUTHOR  : S.Weisz
*. VERSION : 1.01
*. CREATED : 18-May-87
*. LAST MOD: 31-Mar-94
*.
*. Modification Log.
*. 31-Mar-94 M.Redmond   Move KUEXEC call
*. 30-Mar-94 O.Schaile   Call KUINIM early, add CLOSE(6) for VMS
*.                       move exec ROPE from ROPIKU to here
*. 27-Mar-91 S.Weisz     Call RDUMLD to help the linker.
*.  7-Apr-88 S.Weisz     KUIP initialisation.
*. 11-Feb-88 S.Weisz     ZEBRA trouble recovery;calls QNEXTE.
*.
*.**********************************************************************
      IMPLICIT NONE
*
      INTEGER MEMOR,NKMEM,IV1,IV2
      INTEGER IDUM, NCHDUG, NFIRST
      INTEGER      NUHMAX
      PARAMETER   (NUHMAX=64)
      INTEGER      IRDATE,IRTIME,IVGOPA,IRBEAM,IRINTR,
     +             LRIN  ,LROUT ,
     +             IREVNT,IRDEXP,IRDRUN,IRDEVT,IRDEBU,
     +             NUHEAD,IOHEAD,IUHEAD
      REAL         RUHEAD
      DIMENSION    RUHEAD(NUHMAX)
      COMMON/CRO/  IRDATE,IRTIME,IVGOPA,IRBEAM,IRINTR,
     +             LRIN  ,LROUT ,
     +             IREVNT,IRDEXP,IRDRUN,IRDEVT,IRDEBU,
     +             NUHEAD,IOHEAD(2),IUHEAD(NUHMAX)
      EQUIVALENCE (IUHEAD,RUHEAD)
      INTEGER      NHEADR
      REAL         RHEADR(NUHMAX)
      COMMON/RONHDE/NHEADR(NUHMAX)
      EQUIVALENCE (NHEADR,RHEADR)
      INTEGER    IREVPR,IRSTOP,IRTRIG,IRDEBG,IODPBL,IMONIT,IZVERI,
     +           IZLOGL,IRUFST,IEVFST,IRULST,IEVLST,ITRYMX,
     +           NCENT ,NECAL ,NHCAL ,NMUON ,NFORW ,NPACK ,NODBLK,
     +           LCENT ,LECAL ,LHCAL ,LMUON ,LFORW ,LPACK ,LODBLK,
     +           NRERUN,LRERUN,LEVKEY,LREKEY,LGEKEY,LCALRD,LCALWT,
     +           ICMAIN,NEVTRP,NTOTRP,ITTBAT,ITRBAT,IFIBAT,ISCBAT,
     +           IDDBAT,IDUBAT,IFCNST,IFSCAN,IFBOOK,IFDROP,IFUPDT,
     +           INDROP,ICDATE,ICTIME,NSTOP ,KEEPJU,ILLBAT,ILABAT,
     +           ISDATE,ISTIME,IFODSI,IFNOEU,NOWRIT
      INTEGER    NSLCMI,NSLCMA,NSLMMI,NSLMMA,ISLRUN,ISLEVT,IFSLON
      INTEGER    NPFILE,NPFATF,NAMLEN,NAMLWO,NPAFIL,NPAFAT,NPACAT,
     +           NPCATA,NPCFIL,NPACFI,NPGDEV,NPAGDE,NPADAD,NPDADL,
     +           LFITYP,LFIDIR,LFIUNI,LFILRE,LFIFCH,LFIDCH,LFINAM,
     +           LCFTYP,LCFDIR,LCFUNI,LCFLRE,LCFFCH,LCFDCH,LCFNAM,
     +           LFATYP,LFADIR,LFAUNI,LFADCH,LFANAM,LCAUNI,LCANAM,
     +           LDATYP,LDADIR,LDAUN1,LDAUN2,LDAOPT,LDANAM,
     +           LFATLU,LFATLO,LFATLW,LFATL1,LFATL2,
     +           LNADIR,LNAUN1,LNAUN2,LNAOPT,LNANAM,NPANAN,NPNANO,
     +           LEVDIR,LEVUN1,LEVUN2,LEVUN3,LEVOPT,LEVNAM,
     +           NPAEVT,NPEVTL,
     +           LMNDIR,LMNUNI,LMNOPT,LMNNAM,NPAMAS,NPMAST,
     +           LNDEVI,LTYPDE,LDEVNA,
     +           IPHONE,NPHONE,LUFONE,LFOOPT,IUNITU,NUNITU, MAXSEL
      INTEGER    MSHDSL, MSANYS,ISEKEY
      INTEGER NTRYMX,  MSHDVE
      REAL       ESLEMI,ESLEMA,ESLHMI,ESLHMA
      REAL       RTIMST,RTIMSF,RFZLIM,RTIMSI,RTIMSE
      LOGICAL    FATFIL,FFERRO,LMEMIN,LMEMOU
      PARAMETER (NAMLEN = 80,NAMLWO = NAMLEN/4,
     +           NPAFIL =  6,NPFILE = NPAFIL+NAMLWO,
     +           NPACFI =  6,NPCFIL = NPACFI+NAMLWO,
     +           NPAFAT =  4,NPFATF = NPAFAT+NAMLWO,
     +           NPADAD =  5,NPDADL = NPADAD+NAMLWO,
     +           NPACAT =  1,NPCATA = NPACAT+NAMLWO,
     +           NPAGDE =  2,NPGDEV = NPAGDE+NAMLWO,
     +           NPANAN =  4,NPNANO = NPANAN+NAMLWO,
     +           NPAEVT =  5,NPEVTL = NPAEVT+NAMLWO,
     +           NPAMAS =  3,NPMAST = NPAMAS+NAMLWO,
     +           NPHONE = 10,NUNITU = 10, MAXSEL=10)
      COMMON/RCNTRL/IREVPR,IRSTOP,IRTRIG(3),IRDEBG(4),IODPBL(3),
     +       IMONIT,IZVERI,IZLOGL,IRUFST,IEVFST,IRULST,IEVLST,ITRYMX,
     +       NCENT ,NECAL ,NHCAL ,NMUON ,NFORW ,NPACK ,NODBLK,
     +       LCENT(20),LECAL(20),LHCAL(20),LMUON(20),LFORW(20),
     +       LPACK(20),LODBLK(20),NRERUN,LRERUN(20),LEVKEY(4),
     +       LREKEY(3),LGEKEY(2),LCALRD(46),LCALWT(46),ICMAIN,
     +       RTIMST,RTIMSF,RFZLIM,RTIMSI,RTIMSE,NEVTRP,NTOTRP,ITTBAT,
     +       ITRBAT,IFIBAT,ISCBAT,IDDBAT,IDUBAT,IFCNST,IFSCAN,IFBOOK,
     +       IFDROP,IFUPDT,INDROP,NSLCMI,NSLCMA,ESLEMI,ESLEMA,ESLHMI,
     +       ESLHMA,NSLMMI,NSLMMA,ISLRUN,ISLEVT,IFSLON,ICDATE,ICTIME,
     +       NSTOP,FATFIL,FFERRO,LMEMIN,LMEMOU,LFITYP,LFIDIR,LFIUNI,
     +       LFILRE,LFIFCH,LFIDCH,LFINAM(NAMLWO),LCFTYP,LCFDIR,LCFUNI,
     +       LCFLRE,LCFFCH,LCFDCH,LCFNAM(NAMLWO),LFATYP,LFADIR,LFAUNI,
     +       LFADCH,LFANAM(NAMLWO),LDATYP,LDADIR,LDAUN1,LDAUN2,LDAOPT,
     +       LDANAM(NAMLWO),LCAUNI,LCANAM(NAMLWO),LFATLU,LFATLO,
     +       LFATLW,LFATL1,LFATL2,LNADIR,LNAUN1,LNAUN2,LNAOPT,
     +       LNANAM(NAMLWO),LEVDIR,LEVUN1,LEVUN2,LEVUN3,LEVOPT,
     +       LEVNAM(NAMLWO),LMNDIR,LMNUNI,LMNOPT,LMNNAM(NAMLWO),
     +       LNDEVI,LTYPDE,LDEVNA(NAMLWO),IPHONE(NPHONE),LUFONE,LFOOPT,
     +       IUNITU(NUNITU),KEEPJU,ILLBAT,ILABAT,ISDATE,ISTIME,IFODSI
      COMMON/RCNTRL/NTRYMX(2),
     +              MSHDSL(MAXSEL) ,MSANYS, ISEKEY(3), MSHDVE(MAXSEL),
     +              IFNOEU,NOWRIT

      CHARACTER*132 CHREP
      COMMON/RCREP/CHREP
      CHARACTER*132 CHLINE
      COMMON/RCLINE/CHLINE
      INTEGER       NPRTMX,IFREPO,IORWDS,NCHDUM
      CHARACTER*256 CHDUMM
      COMMON/RECNTL/NPRTMX(6),IFREPO,IORWDS(2),NCHDUM
      COMMON/RCDUMM/CHDUMM
      INTEGER     IVRO,ISVRO,IDACRO,IDAMRO,IVGR,ISVGR,IDACGR,IDAMGR,
     +            IVUS,ISVUS,IDACUS,IDAMUS,IVCV,ISVCV,IDACCV,IDAMCV,
     +            IVCJ,ISVCJ,IDACCJ,IDAMCJ,IVCZ,ISVCZ,IDACCZ,IDAMCZ,
     +            IVCT,ISVCT,IDACCT,IDAMCT,IVCX,ISVCX,IDACCX,IDAMCX,
     +            IVCE,ISVCE,IDACCE,IDAMCE,IVTB,ISVTB,IDACTB,IDAMTB,
     +            IVPB,ISVPB,IDACPB,IDAMPB,IVEB,ISVEB,IDACEB,IDAMEB,
     +            IVPE,ISVPE,IDACPE,IDAMPE,IVEE,ISVEE,IDACEE,IDAMEE,
     +            IVEM,ISVEM,IDACEM,IDAMEM,IVHB,ISVHB,IDACHB,IDAMHB,
     +            IVHE,ISVHE,IDACHE,IDAMHE,IVHP,ISVHP,IDACHP,IDAMHP,
     +            IVHM,ISVHM,IDACHM,IDAMHM,IVMB,ISVMB,IDACMB,IDAMMB,
     +            IVME,ISVME,IDACME,IDAMME,IVMM,ISVMM,IDACMM,IDAMMM,
     +            IVFD,ISVFD,IDACFD,IDAMFD,IVDD,ISVDD,IDACDD,IDAMDD,
     +            IVOD,ISVOD,IDACOD,IDAMOD,IVOU,ISVOU,IDACOU,IDAMOU,
     +            IVOC,ISVOC,IDACOC,IDAMOC,IVTT,ISVTT,IDACTT,IDAMTT,
     +            IVTR,ISVTR,IDACTR,IDAMTR,IVFI,ISVFI,IDACFI,IDAMFI,
     +            IVON,ISVON,IDACON,IDAMON,IVJC,ISVJC,IDACJC,IDAMJC,
     +            IVSU,ISVSU,IDACSU,IDAMSU,IVOP,ISVOP,IDACOP,IDAMOP,
     +            IVDX,ISVDX,IDACDX,IDAMDX,IVSI,ISVSI,IDACSI,IDAMSI,
     +            IVCS,ISVCS,IDACCS,IDAMCS,IVLL,ISVLL,IDACLL,IDAMLL,
     +            IVLA,ISVLA,IDACLA,IDAMLA,IVBT,ISVBT,IDACBT,IDAMBT
      INTEGER     IVID,ISVID,IDACID,IDAMID,IVLM,ISVLM,IDACLM,IDAMLM,
     +            IVDC,ISVDC,IDACDC,IDAMDC,IVSW,ISVSW,IDACSW,IDAMSW,
     +            IVCU,ISVCU,IDACCU,IDAMCU,IVHI,ISVHI,IDACHI,IDAMHI,
     +            IVGC,ISVGC,IDACGC,IDAMGC,IVSQ,ISVSQ,IDACSQ,IDAMSQ,
     +            IVPX,ISVPX,IDACPX,IDAMPX,IVTE,ISVTE,IDACTE,IDAMTE,
     +            IVWW,ISVWW,IDACWW,IDAMWW,IVMT,ISVMT,IDACMT,IDAMMT
      COMMON/CRVER/IVRO,ISVRO,IDACRO,IDAMRO,IVGR,ISVGR,IDACGR,IDAMGR,
     +            IVUS,ISVUS,IDACUS,IDAMUS,IVCV,ISVCV,IDACCV,IDAMCV,
     +            IVCJ,ISVCJ,IDACCJ,IDAMCJ,IVCZ,ISVCZ,IDACCZ,IDAMCZ,
     +            IVCT,ISVCT,IDACCT,IDAMCT,IVCX,ISVCX,IDACCX,IDAMCX,
     +            IVCE,ISVCE,IDACCE,IDAMCE,IVTB,ISVTB,IDACTB,IDAMTB,
     +            IVPB,ISVPB,IDACPB,IDAMPB,IVEB,ISVEB,IDACEB,IDAMEB,
     +            IVPE,ISVPE,IDACPE,IDAMPE,IVEE,ISVEE,IDACEE,IDAMEE,
     +            IVEM,ISVEM,IDACEM,IDAMEM,IVHB,ISVHB,IDACHB,IDAMHB,
     +            IVHE,ISVHE,IDACHE,IDAMHE,IVHP,ISVHP,IDACHP,IDAMHP,
     +            IVHM,ISVHM,IDACHM,IDAMHM,IVMB,ISVMB,IDACMB,IDAMMB,
     +            IVME,ISVME,IDACME,IDAMME,IVMM,ISVMM,IDACMM,IDAMMM,
     +            IVFD,ISVFD,IDACFD,IDAMFD,IVDD,ISVDD,IDACDD,IDAMDD,
     +            IVOD,ISVOD,IDACOD,IDAMOD,IVOU,ISVOU,IDACOU,IDAMOU,
     +            IVOC,ISVOC,IDACOC,IDAMOC,IVTT,ISVTT,IDACTT,IDAMTT,
     +            IVTR,ISVTR,IDACTR,IDAMTR,IVFI,ISVFI,IDACFI,IDAMFI,
     +            IVON,ISVON,IDACON,IDAMON,IVJC,ISVJC,IDACJC,IDAMJC,
     +            IVSU,ISVSU,IDACSU,IDAMSU,IVOP,ISVOP,IDACOP,IDAMOP,
     +            IVDX,ISVDX,IDACDX,IDAMDX,IVSI,ISVSI,IDACSI,IDAMSI,
     +            IVCS,ISVCS,IDACCS,IDAMCS,IVLL,ISVLL,IDACLL,IDAMLL,
     +            IVLA,ISVLA,IDACLA,IDAMLA,IVBT,ISVBT,IDACBT,IDAMBT
      COMMON/CRVER/IVID,ISVID,IDACID,IDAMID,IVLM,ISVLM,IDACLM,IDAMLM,
     +            IVDC,ISVDC,IDACDC,IDAMDC,IVSW,ISVSW,IDACSW,IDAMSW,
     +            IVCU,ISVCU,IDACCU,IDAMCU,IVHI,ISVHI,IDACHI,IDAMHI,
     +            IVGC,ISVGC,IDACGC,IDAMGC,IVSQ,ISVSQ,IDACSQ,IDAMSQ,
     +            IVPX,ISVPX,IDACPX,IDAMPX,IVTE,ISVTE,IDACTE,IDAMTE,
     +            IVWW,ISVWW,IDACWW,IDAMWW,IVMT,ISVMT,IDACMT,IDAMMT
      COMMON/PAWC/MEMOR(2)
      NKMEM=MEMOR(2)
*-- Try to avoid linking problems.
      IDUM   = 0
      CALL RDUMLD(IDUM)
*-- Set interactive flag IRINTR <ON>.
      IRINTR = 1
*-- Initializes ZEBRA,HBOOK and FFREAD.
      CALL ROPPAK
*-- Initializes KUIP.
      CALL KUINIT(NKMEM)
      CALL VECDEF
*-- Initializes KUIP commands.
      CALL ROPIKU
      CALL KUINIM('GRope++')
*     print list of dummies accumulated by GRIKU and ROPIKU
      IF (NCHDUM .GT. 1) THEN
         NCHDUG=INDEX(CHDUMM,'RO:')-1
         IF(NCHDUG.GE.3)THEN
            CHLINE='Dummies called from GRIKU:'
            CALL RMAIL(0,0)
            NFIRST=1
10          CONTINUE
            CHLINE=CHDUMM(NFIRST:MIN(NFIRST+59,NCHDUG))
            CALL RMAIL(0,0)
            IF (NFIRST+60 .LT. NCHDUG) THEN
               NFIRST=NFIRST+60
               GOTO 10
            ENDIF
         ENDIF
         NFIRST=NCHDUG+4
         IF(NCHDUM.GE.NFIRST+3)THEN
            CHLINE='Dummies called from ROPIKU:'
            CALL RMAIL(0,0)
20          CONTINUE
            CHLINE=CHDUMM(NFIRST:MIN(NFIRST+59,NCHDUM))
            CALL RMAIL(0,0)
            IF (NFIRST+60 .LT. NCHDUM) THEN
               NFIRST=NFIRST+60
               GOTO 20
            ENDIF
         ENDIF
      ENDIF
      WRITE(CHLINE,1000)
      CALL RMAIL(2,0)
      WRITE(CHLINE,1010)
      CALL RMAIL(0,0)
      WRITE(CHLINE,1020)
      CALL RMAIL(0,0)
      WRITE(CHLINE,1010)
      CALL RMAIL(0,0)
      WRITE(CHLINE,1030)
      CALL RMAIL(0,0)
*-- Get ROPE version from Patchy title card.
      WRITE(CHREP,1040)
      READ(CHREP,1050) IV1,IV2,ISVRO
      IVRO = 100*IV1 + IV2
*-- Get date of last modification of the cradle.
      IDAMRO = 990413
*
      WRITE(CHLINE,1070) IVRO,ISVRO,IDAMRO
      CALL RMAIL(0,0)
      WRITE(CHLINE,1010)
      CALL RMAIL(0,0)
      WRITE(CHLINE,1000)
      CALL RMAIL(0,2)
*-- Initialize and set default values for ROPE processors.
      CALL ROPINI
*-- Read data cards.
      WRITE(CHLINE,1080)
      CALL RMAIL(1,0)
      WRITE(CHLINE,1090)
      CALL RMAIL(0,1)
      CALL FFGO
*-- Set RUN parameters.
      CALL ROPSET
*-- Initializes KUIP commands. move up
*      CALL ROPIKU
*-- User set up
      CALL KUEXEC('EXEC ROPE')
*-- Set ZEBRA phase to Zero to enable exit to QNEXT.
      CALL ZPHASE(0)
*-- Now ready for the GO step.
      CALL TIMEX(RTIMST)
      WRITE(CHLINE,1100)
      CALL RMAIL(1,1)
*
      CALL QNEXTE
*
 1000 FORMAT(5X,'***************************************************')
 1010 FORMAT(5X,'*                                                 *')
 1020 FORMAT(5X,'*          W E L C O M E  to  R O P E             *')
 1030 FORMAT(5X,'*       The OPAL reconstruction program           *')
 1040 FORMAT(
     + 24HROPE    4.20/03 020626 1                                          HOLD
     +            )
 1050 FORMAT(8X,I1,1X,I2,1X,I2)
 1060 FORMAT(18X,I6)
 1070 FORMAT(5X,'*      Version ',I3,'/',I2, ' Modified on ',I6,
     +'          *')
 1080 FORMAT(5X,' ==> Type your FFREAD data cards (LIST,TRIG,..)')
 1090 FORMAT(5X,' ==> Last data card must be STOP')
 1100 FORMAT(5X,' ==> ROPE now ready , You can type your commands')
      END
CDECK  ID>, ROPIKU.
      SUBROUTINE ROPIKU
*.
*...ROPIKU   ROPE routine to initialize KUIP commands
*.
*. CALLS   : ROIKU GRIKU USIKU ODIKU
*.           CVIKU JCIKU CJIKU CZIKU CTIKU SIIKU CSIKU CXIKU CEIKU
*.           TBIKU PBIKU EBIKU PEIKU EEIKU EMIKU
*.           HBIKU HEIKU HPIKU MBIKU MEIKU SWIKU FDIKU
*.
*. CALLED  : RCNTLI
*.
*. AUTHOR  : S.Weisz
*. VERSION : 1.01
*. CREATED : 18-May-87
*. LAST MOD: 28-Mar-96
*.
*. Modification Log.
*. 28-Mar-96  O.Schaile       Introduce TE process.
*. 21-Mar-96 O.Schaile   Put ZBRDEF etc always in
*.  3-Feb-95 O.Schaile   Add CALL GRBROW
*.  1-Feb-94 O.Schaile   Add KUIP Motif stuff, REPORT=>RMAIL
*.  6-May-93 D.Wagner    Avoid blank line when printing dummies (35=>36)
*. 26-Apr-93 O.Schaile   Add SWIKU
*. 13-Feb-92 A.Buijs     Modify printout of dummy routines.
*. 17-Jul-89 S.Weisz     Call KUEXEC of ROPE KUMAC file
*. 13-Apr-91 S.Weisz     Add SIIKU, CSIKU
*.
*.**********************************************************************
      IMPLICIT NONE
C      INTEGER NFIRST
C  +SEQ,RCREP.
C  +SEQ,RCLINE.
      INTEGER       NPRTMX,IFREPO,IORWDS,NCHDUM
      CHARACTER*256 CHDUMM
      COMMON/RECNTL/NPRTMX(6),IFREPO,IORWDS(2),NCHDUM
      COMMON/RCDUMM/CHDUMM
*
      CHDUMM=' '
      NCHDUM=1
      CALL ROIKU
      CHDUMM=' '
      NCHDUM=1
      CALL GRIKU
      IF(NCHDUM.LE.LEN(CHDUMM)-5)THEN
         CHDUMM(NCHDUM:)='RO:'
         NCHDUM=NCHDUM+3
      ENDIF
      CALL CEIKU
      CALL CVIKU
      CALL JCIKU
      CALL CJIKU
      CALL CZIKU
      CALL CTIKU
      CALL SIIKU
      CALL CSIKU
      CALL CXIKU
      CALL PBIKU
      CALL EBIKU
      CALL EEIKU
      CALL EMIKU
      CALL HBIKU
      CALL HEIKU
      CALL HPIKU
      CALL MBIKU
      CALL MEIKU
      CALL TBIKU
      CALL TEIKU
      CALL PEIKU
      CALL FDIKU
      CALL SWIKU
      CALL ODIKU
      CALL USIKU
C +SELF,IF=KUWHAM.
      CALL KUIDFM
      CALL ZBRDEF
      CALL GRBROW
C +SELF.
      RETURN
      END
CDECK  ID>, DUMMY.
      SUBROUTINE USINIT
		CHARACTER(len=128) :: grosys
		CHARACTER(len=255) :: f4name
		LOGICAL OK
		
		CALL FFSET('LINP',4)
		INQUIRE(FILE='fort.4',exist=OK)
		IF ( OK ) THEN
C			WRITE(*,*) 'fort.4 ok'
			f4name = 'fort.4'
		ELSE
			CALL get_environment_variable("GROPE", grosys)
			f4name = trim(grosys)//'/data/fort.4'
			INQUIRE(FILE=f4name,exist=OK)
			IF ( .NOT. OK ) THEN
				f4name = trim(grosys)//'/runit/fort.4'
				INQUIRE(FILE=f4name,exist=OK)
			ENDIF
		ENDIF
		IF ( .NOT. OK ) THEN
			WRITE(*,*)'Cant find fort.4 with FFREAD cards'
			WRITE(*,*)'grope will not run'
		ELSE
			OPEN(UNIT=4,FILE=f4name,  STATUS='OLD')
			WRITE(*,*)'Take FFREAD cards from: ', f4name
		ENDIF
100   FORMAT(A)
      END
CDECK  ID>, GRCS.
      SUBROUTINE GRCS
*.
*...GRCS       To initialize the COMIS package
*.             To declare addresses of FORTRAN routines and COMMONs
*.             which may be invoked from COMIS routines
*.
*.
*. SEQUENCE  : DECLAR
*. CALLS     :
*. CALLED    : GRFORT
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : D.R.Ward
*. VERSION   : 1.00
*. CREATED   : 10-Jun-94
*. LAST MOD  : 22-Apr-1998
*.
*. Modification Log.
*. 22-Apr-1998 NKW        Update for WW again
*. 30-Jul-97   NKW        Update for WW again
*.  5-Aug-96   DRW/NKW    Update for WW etc
*.
*.**********************************************************************
*.
      INTEGER IQ,LQ,NZEBRA,IXSTOR,IXDIV,IXCONS,LMAIN,LR1,JCG
      INTEGER KWBANK,KWWORK,IWS
      REAL GVERSN,ZVERSN,FENDQ,WS,Q
C
      PARAMETER (KWBANK=69000,KWWORK=5200)
      COMMON/GCBANK/NZEBRA,GVERSN,ZVERSN,IXSTOR,IXDIV,IXCONS,FENDQ(16)
     +             ,LMAIN,LR1,WS(KWBANK)
      DIMENSION IQ(2),Q(2),LQ(8000),IWS(2)
      EQUIVALENCE (Q(1),IQ(1),LQ(9)),(LQ(1),LMAIN),(IWS(1),WS(1))
      EQUIVALENCE (JCG,JGSTAT)
      INTEGER       JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
C
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
C
      CHARACTER*132 CHLINE
      COMMON/RCLINE/CHLINE
      CHARACTER*132 CHREP
      COMMON/RCREP/CHREP
      INTEGER      NUHMAX
      PARAMETER   (NUHMAX=64)
      INTEGER      IRDATE,IRTIME,IVGOPA,IRBEAM,IRINTR,
     +             LRIN  ,LROUT ,
     +             IREVNT,IRDEXP,IRDRUN,IRDEVT,IRDEBU,
     +             NUHEAD,IOHEAD,IUHEAD
      REAL         RUHEAD
      DIMENSION    RUHEAD(NUHMAX)
      COMMON/CRO/  IRDATE,IRTIME,IVGOPA,IRBEAM,IRINTR,
     +             LRIN  ,LROUT ,
     +             IREVNT,IRDEXP,IRDRUN,IRDEVT,IRDEBU,
     +             NUHEAD,IOHEAD(2),IUHEAD(NUHMAX)
      EQUIVALENCE (IUHEAD,RUHEAD)
      INTEGER      NHEADR
      REAL         RHEADR(NUHMAX)
      COMMON/RONHDE/NHEADR(NUHMAX)
      EQUIVALENCE (NHEADR,RHEADR)
* Number of blocks:
      INTEGER   NUMBLK
      PARAMETER(NUMBLK=13)
* General block:
      INTEGER NIBMAX,NRBMAX,NWBMAX
      INTEGER NIGNRL,NRGNRL,NWGNRL,MIGNRL,MRGNRL
      INTEGER JGDTYP,JGDSTY,JGIEXP,JGIRUN,JGIFIL,JGIEVT
      INTEGER JGPVER,JGITAP,JGIBUN,JGDETS,JGTRGS,JGEVTY
      INTEGER JGFITY,JGDATE,JGTIME,JGNCTR,JGNPRE,JGNECA
      INTEGER JGNTOF,JGNHCA,JGNMUO,JGNFDE,JGNVTX,JGNATR
      INTEGER JGTRM1,JGTRM2,JGTRM3,JGTRM4,JGNFCL,JGNTBR
      INTEGER JGNTBC,JGNJET,JGTPT1,JGTPT2,JGTPT3,JGTPT4
      INTEGER JGTPT5,JGTPT6,JGTPOB,JGTPE1,JGTPE2,JGTPE3
      INTEGER JGTPE4,JGTPE5,JGTPE6,JGTPH1,JGTPH2,JGTPH3
      INTEGER JGTPH4,JGTPH5,JGTPH6,JGTPM1,JGTPM2,JGTPMB
      INTEGER JGTPM5,JGTPM6,JGNCT ,JGNEB ,JGNEE ,JGNHBT
      INTEGER JGNHET,JGNHPT,JGTRES,JGDAQS,JGFIDD,JGFIST
      INTEGER JGROST,JGEVT2,JGLEPQ,JGCDP1,JGCDP2,JGCDP3
      INTEGER JGCDP4,JGCDP5,JGCDP6,JGCDP7,JGPTR1,JGPTR2
      INTEGER JGPTP1,JGPTP2,JGPTP3,JGPTP4,JGNSIW,JGTETR
      INTEGER JGTENC,JGTPD1,JGTPD2,JGTRPU
*
      INTEGER JGBZ,  JGEBEA,JGDEBE,JGEVIS,JGPOL1,JGPOL2
      INTEGER JGVX,  JGVY,  JGVZ,  JGVE11,JGVE21,JGVE22
      INTEGER JGVE31,JGVE32,JGVE33,JGVWXY,JGVW3D,JGSPHE
      INTEGER JGSPCT,JGSECA,JGSHCA,JGAPLA,JGCSPH,JGTHRU
      INTEGER JGOBLA,JGCTHR,JGT0AV,JGDT0A,JGDT0M,JGPSPH
      INTEGER JGPTHR,JGMEPX,JGMEPY,JGMEPZ,JGBX  ,JGBXCJ
      INTEGER JGBXCV,JGDECV,JGSCT ,JGSEB ,JGSEE ,JGSHBS
      INTEGER JGSHES,JGSHPS,JGSHBT,JGSHET,JGSHPT,JGSFE
      INTEGER JGSFK, JGLEPX,JGLEPY,JGBXDI,JGSTCN,JGOPMX
      INTEGER JGBTZ
* Charged track block:
      INTEGER NICTRK,NRCTRK,NWCTRK,MICTRK,MRCTRK
      INTEGER JCNHCV,JCNHCJ,JCNHCZ,JCFTYP,JCPTYP,JCIMCT
      INTEGER JCMMSK,JCIVT1,JCDXBT,JCVPAT,JCIPRE,JCIECA
      INTEGER JCITOF,JCIHCA,JCIMUO,JCIJET,JCCVHT,JCNHDE
      INTEGER JCNBEC,JCMLLH,JCSIH1,JCSIH2
*
      INTEGER JCPX,  JCPY,  JCPZ,  JCQ,   JCKAPP,JCPHI0
      INTEGER JCD0,  JCTLAM,JCZ0,  JCCHIR,JCCHI3,JCEM11
      INTEGER JCEM21,JCEM22,JCEM31,JCEM32,JCEM33,JCEM44
      INTEGER JCEM54,JCEM55,JCR1,  JCR2,  JCDEDX,JCDDED
      INTEGER JCWDE, JCWDMU,JCWDPI,JCWDK, JCWDP, JCTLEN
      INTEGER JCBETA,JCDBET,JCWPRE,JCWECA,JCWTOF,JCWHCA
      INTEGER JCWMUO,JCTHEC,JCDTHE,JCPHEC,JCDPHE,JCTHHC
      INTEGER JCDTHH,JCPHHC,JCDPHH,JCTHMU,JCDTHM,JCPHMU
      INTEGER JCDPHM,JCP,   JCDP,  JCEM41,JCEM42,JCEM43
      INTEGER JCEM51,JCEM52,JCEM53,JCRECA,JCRHCA,JCRMUO
      INTEGER JCTHDM,JCPHDM,JCVTMU,JCVPMU,JCTPMU,JCECON
      INTEGER JCECO2,JCEPZ, JCEPDZ,JCFMOM,JCDIST,JCRUNT
      INTEGER JCECOR,JCZ0CJ,JCTLCJ,JCQEFF,JCMWD1,JCMWD2
      INTEGER JCMWD3
* Presampler block:
      INTEGER NIPRES,NRPRES,NWPRES,MIPRES,MRPRES
      INTEGER JPSOUR,JPNCTR,JPIECA
*
      INTEGER JPMULT,JPDMUL,JPTHET,JPDTHE,JPPHI, JPDPHI
      INTEGER JPSIZU,JPSIZV,JPWECA
* Electro magnetic block:
      INTEGER NIECAL,NRECAL,NWECAL,MIECAL,MRECAL
      INTEGER JESOUR,JEITOF,JENBLO,JENB90,JENCTR,JENPRE
      INTEGER JENMUO,JEIHCA
*
      INTEGER JEE,   JEDE,  JEERAW,JEDERA,JETHET,JEDTHE
      INTEGER JEPHI, JEDPHI,JETHE1,JETHE2,JEPHI1,JEPHI2
      INTEGER JEFMOM,JECDST,JEFRMX,JEWHCA,JEFSMX,JEDFSB
      INTEGER JEINVM
* Time-of-Flight block:
      INTEGER NITOF,NRTOF,NWTOF   ,MITOF,MRTOF
      INTEGER JTFLAG
*
      INTEGER JTMULT,JTDMUL,JTTHET,JTDTHE,JTPHI, JTTOF
      INTEGER JTDTOF,JTDTHT
* Hadron Block:
      INTEGER NIHCAL,NRHCAL,NWHCAL,MIHCAL,MRHCAL
      INTEGER JHSOUR,JHNSTR,JHNTOW,JHTWBT,JHNCTR,JHNECA
      INTEGER JHNMUO,JHNL14,JHNL58,JHNL90
*
      INTEGER JHE,   JHDE,  JHTHET,JHDTHE,JHPHI, JHDPHI
      INTEGER JHTHE1,JHTHE2,JHPHI1,JHPHI2,JHFIN1,JHET
      INTEGER JHES,  JHEUNC,JHDYSC,JHDXSC
* Muon Block:
      INTEGER NIMUON,NRMUON,NWMUON,MIMUON,MRMUON
      INTEGER JMSOUR,JMNCTR,JMNPRE,JMIMCT,JMCASE,JMIECA
      INTEGER JMITOF,JMIHCA,JMKODE,JMNMBH,JMNEXZ,JMNEYZ
      INTEGER JMNHST,JMNSEX,JMNSEY,JMNDOF,JMHNBY,JMFITZ
*
      INTEGER JMX,   JMY,   JMZ,   JMDX,  JMDY,  JMDZ
      INTEGER JMCHMB,JMCIXZ,JMCIYZ,JMPHI, JMDPHI,JMMTHE
      INTEGER JMDCOT,JMCOXY,JMWECA,JMWTOF,JMWHCA,JMCHHB
      INTEGER JMJUNK
* Forward detector block:
      INTEGER NIFDET,NRFDET,NWFDET,MIFDET,MRFDET
      INTEGER JFSOUR,JFDTI1,JFDTI2,JFPAD1,JFPAD2
*
      INTEGER JFE,   JFDE,  JFTHET,JFDTHE,JFPHI, JFDPHI
      INTEGER JFEPRE,JFEFK, JFTFK, JFPHFK,JFBKM
* Vertex Block:
      INTEGER NIVRTX,NRVRTX,NWVRTX,MIVRTX,MRVRTX
      INTEGER JVTYPE,JVALGO,JVNCTR
*
      INTEGER JVCSRP,JVD0,  JVFLEN,JVSD0, JVCSVP,JVDXY
      INTEGER JVDZ,  JVPSC2,JVMEE, JVMPP, JVMPRP,JVMPPR
* Alias track block:
      INTEGER NIATRK,NRATRK,NWATRK,MIATRK,MRATRK
      INTEGER JAIVT1,JAIVT2,JAICTR
*
      INTEGER JAPX,  JAPY,  JAPZ,  JAQ,   JAKAPP,JAPHI0
      INTEGER JAD0,  JATLAM,JAZ0,  JACHIR,JACHIZ,JAEM11
      INTEGER JAEM21,JAEM22,JAEM31,JAEM32,JAEM33,JAEM44
      INTEGER JAEM54,JAEM55,JAVX,  JAVY,  JAVZ
* Silicon tungsten calorimeter block:
      INTEGER NISIW, NRSIW, NWSIW, MISIW, MRSIW
      INTEGER JSSOUR
*
      INTEGER JSE   ,JSTHET,JSPHI ,JSR   ,JSDR  ,JSLSHD
* Detector Tile Endcap block (only integers so far)
      INTEGER NIDTE, NRDTE, NWDTE, MIDTE, MRDTE
      INTEGER JDITH, JDIPH, JDICAP, JDIADC, JDITD0, JDITDW, JDNOTP
*
* Detector masks:
      INTEGER MSKCV, MSKCJ, MSKCZ, MSKCD, MSKEB, MSKEE, MSKPB
      INTEGER MSKPE, MSKTB, MSKEC, MSKHB, MSKHE, MSKHP, MSKHC
      INTEGER MSKMB, MSKME, MSKMU, MSKFD, MSKSW
*
* The following are now the COMMON blocks which contain the
* offsets. They can be CHANGED, now.
* General Block:
      COMMON/ODGIPA/MIGNRL,
     + JGDTYP,JGDSTY,JGIEXP,JGIRUN,JGIFIL,JGIEVT,
     + JGPVER,JGITAP,JGIBUN,JGDETS,JGTRGS,JGEVTY,
     + JGFITY,JGDATE,JGTIME,JGNCTR,JGNPRE,JGNECA,
     + JGNTOF,JGNHCA,JGNMUO,JGNFDE,JGNVTX,JGNATR,
     + JGTRM1,JGTRM2,JGTRM3,JGTRM4,JGNFCL,JGNTBR,
     + JGNTBC,JGNJET,JGTPT1,JGTPT2,JGTPT3,JGTPT4,
     + JGTPT5,JGTPT6,JGTPOB,JGTPE1,JGTPE2,JGTPE3,
     + JGTPE4,JGTPE5,JGTPE6,JGTPH1,JGTPH2,JGTPH3,
     + JGTPH4,JGTPH5,JGTPH6,JGTPM1,JGTPM2,JGTPMB,
     + JGTPM5,JGTPM6,JGNCT ,JGNEB ,JGNEE ,JGNHBT,
     + JGNHET,JGNHPT,JGTRES,JGDAQS,JGFIDD,JGFIST,
     + JGROST,JGEVT2,JGLEPQ,JGCDP1,JGCDP2,JGCDP3,
     + JGCDP4,JGCDP5,JGCDP6,JGCDP7,JGPTR1,JGPTR2,
     + JGPTP1,JGPTP2,JGPTP3,JGPTP4,JGNSIW,JGTETR,
     + JGTENC,JGTPD1,JGTPD2,JGTRPU
      COMMON/ODGRPA/MRGNRL,
     + JGBZ  ,JGEBEA,JGDEBE,JGEVIS,JGPOL1,JGPOL2,
     + JGVX  ,JGVY  ,JGVZ  ,JGVE11,JGVE21,JGVE22,
     + JGVE31,JGVE32,JGVE33,JGVWXY,JGVW3D,JGSPHE,
     + JGSPCT,JGSECA,JGSHCA,JGAPLA,JGCSPH,JGTHRU,
     + JGOBLA,JGCTHR,JGT0AV,JGDT0A,JGDT0M,JGPSPH,
     + JGPTHR,JGMEPX,JGMEPY,JGMEPZ,JGBX  ,JGBXCJ,
     + JGBXCV,JGDECV,JGSCT ,JGSEB ,JGSEE ,JGSHBS,
     + JGSHES,JGSHPS,JGSHBT,JGSHET,JGSHPT,JGSFE ,
     + JGSFK ,JGLEPX,JGLEPY,JGBXDI,JGSTCN,JGOPMX,
     + JGBTZ
      PARAMETER(NIGNRL=88,NRGNRL=55,NWGNRL=88)
      INTEGER IGIPAR(NIGNRL),IGRPAR(NRGNRL)
      EQUIVALENCE(IGIPAR(1),JGDTYP),(IGRPAR(1),JGBZ)
      SAVE /ODGIPA/,/ODGRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Charged track block:
      COMMON /ODCIPA/MICTRK,
     + JCNHCV,JCNHCJ,JCNHCZ,JCFTYP,JCPTYP,JCIMCT,
     + JCMMSK,JCIVT1,JCDXBT,JCVPAT,JCIPRE,JCIECA,
     + JCITOF,JCIHCA,JCIMUO,JCIJET,JCCVHT,JCNHDE,
     + JCNBEC,JCMLLH,JCSIH1,JCSIH2
      COMMON /ODCRPA/MRCTRK,
     + JCPX  ,JCPY  ,JCPZ  ,JCQ   ,JCKAPP,JCPHI0,
     + JCD0  ,JCTLAM,JCZ0  ,JCCHIR,JCCHI3,JCEM11,
     + JCEM21,JCEM22,JCEM31,JCEM32,JCEM33,JCEM44,
     + JCEM54,JCEM55,JCR1  ,JCR2  ,JCDEDX,JCDDED,
     + JCWDE ,JCWDMU,JCWDPI,JCWDK ,JCWDP ,JCTLEN,
     + JCBETA,JCDBET,JCWPRE,JCWECA,JCWTOF,JCWHCA,
     + JCWMUO,JCTHEC,JCDTHE,JCPHEC,JCDPHE,JCTHHC,
     + JCDTHH,JCPHHC,JCDPHH,JCTHMU,JCDTHM,JCPHMU,
     + JCDPHM,JCP   ,JCDP  ,JCEM41,JCEM42,JCEM43,
     + JCEM51,JCEM52,JCEM53,JCRECA,JCRHCA,JCRMUO,
     + JCTHDM,JCPHDM,JCVTMU,JCVPMU,JCTPMU,JCECON,
     + JCECO2,JCEPZ ,JCEPDZ,JCFMOM,JCDIST,JCRUNT,
     + JCECOR,JCZ0CJ,JCTLCJ,JCQEFF,JCMWD1,JCMWD2,
     + JCMWD3
      PARAMETER(NICTRK=22,NRCTRK=79,NWCTRK=79)
      INTEGER ICIPAR(NICTRK),ICRPAR(NRCTRK)
      EQUIVALENCE(ICIPAR(1),JCNHCV),(ICRPAR(1),JCPX)
      SAVE /ODCIPA/,/ODCRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Presampler block:
      COMMON /ODPIPA/MIPRES,
     + JPSOUR,JPNCTR,JPIECA
      COMMON /ODPRPA/MRPRES,
     + JPMULT,JPDMUL,JPTHET,JPDTHE,JPPHI ,JPDPHI,
     + JPSIZU,JPSIZV,JPWECA
      PARAMETER(NIPRES=3,NRPRES=9,NWPRES=9)
      INTEGER IPIPAR(NIPRES),IPRPAR(NRPRES)
      EQUIVALENCE(IPIPAR(1),JPSOUR),(IPRPAR(1),JPMULT)
      SAVE /ODPIPA/,/ODPRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Electromagnetic Block:
      COMMON /ODEIPA/MIECAL,
     + JESOUR,JEITOF,JENBLO,JENB90,JENCTR,JENPRE,
     + JENMUO,JEIHCA
      COMMON /ODERPA/MRECAL,
     + JEE   ,JEDE  ,JEERAW,JEDERA,JETHET,JEDTHE,
     + JEPHI ,JEDPHI,JETHE1,JETHE2,JEPHI1,JEPHI2,
     + JEFMOM,JECDST,JEFRMX,JEWHCA,JEFSMX,JEDFSB,
     + JEINVM
      PARAMETER(NIECAL=8,NRECAL=19,NWECAL=19)
      INTEGER IEIPAR(NIECAL),IERPAR(NRECAL)
      EQUIVALENCE(IEIPAR(1),JESOUR),(IERPAR(1),JEE)
      SAVE /ODEIPA/,/ODERPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Time-of-Flight block:
      COMMON /ODTIPA/MITOF,
     + JTFLAG
      COMMON /ODTRPA/MRTOF,
     + JTMULT,JTDMUL,JTTHET,JTDTHE,JTPHI ,  JTTOF ,
     + JTDTOF,JTDTHT
      PARAMETER(NITOF=1,NRTOF=8,NWTOF=8)
      INTEGER ITIPAR(NITOF),ITRPAR(NRTOF)
      EQUIVALENCE(ITIPAR(1),JTFLAG),(ITRPAR(1),JTMULT)
      SAVE /ODTIPA/,/ODTRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Hadron calorimeter Block:
      COMMON /ODHIPA/MIHCAL,
     + JHSOUR,JHNSTR,JHNTOW,JHTWBT,JHNCTR,JHNECA,
     + JHNMUO,JHNL14,JHNL58,JHNL90
      COMMON /ODHRPA/MRHCAL,
     + JHE   ,JHDE  ,JHTHET,JHDTHE,JHPHI ,JHDPHI,
     + JHTHE1,JHTHE2,JHPHI1,JHPHI2,JHFIN1,JHET  ,
     + JHES  ,JHEUNC,JHDYSC,JHDXSC
      PARAMETER(NIHCAL=10,NRHCAL=16,NWHCAL=16)
      INTEGER IHIPAR(NIHCAL),IHRPAR(NRHCAL)
      EQUIVALENCE(IHIPAR(1),JHSOUR),(IHRPAR(1),JHE)
      SAVE /ODHIPA/,/ODHRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Muon Block:
      COMMON /ODMIPA/ MIMUON,
     + JMSOUR,JMNCTR,JMNPRE,JMIMCT,JMCASE,JMIECA,
     + JMITOF,JMIHCA,JMKODE,JMNMBH,JMNEXZ,JMNEYZ,
     + JMNHST,JMNSEX,JMNSEY,JMNDOF,JMHNBY,JMFITZ
      COMMON /ODMRPA/ MRMUON,
     + JMX   ,JMY   ,JMZ   ,JMDX  ,JMDY  ,JMDZ  ,
     + JMCHMB,JMCIXZ,JMCIYZ,JMPHI ,JMDPHI,JMMTHE,
     + JMDCOT,JMCOXY,JMWECA,JMWTOF,JMWHCA,JMCHHB,
     + JMJUNK
      PARAMETER(NIMUON=18,NRMUON=19,NWMUON=19)
      INTEGER IMIPAR(NIMUON),IMRPAR(NRMUON)
      EQUIVALENCE(IMIPAR(1),JMSOUR),(IMRPAR(1),JMX)
      SAVE /ODMIPA/,/ODMRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Forward detector block:
      COMMON /ODFIPA/ MIFDET,
     + JFSOUR,JFDTI1,JFDTI2,JFPAD1,JFPAD2
      COMMON /ODFRPA/ MRFDET,
     + JFE   ,JFDE  ,JFTHET,JFDTHE,JFPHI ,JFDPHI,
     + JFEPRE,JFEFK ,JFTFK ,JFPHFK,JFBKM
      PARAMETER(NIFDET= 5, NRFDET=11,NWFDET=11)
      INTEGER IFIPAR(NIFDET),IFRPAR(NRFDET)
      EQUIVALENCE(IFIPAR(1),JFSOUR),(IFRPAR(1),JFE)
      SAVE /ODFIPA/,/ODFRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Vertex Block:
      COMMON /ODVIPA/ MIVRTX,
     + JVTYPE,JVALGO,JVNCTR
      COMMON /ODVRPA/ MRVRTX,
     + JVCSRP,JVD0  ,JVFLEN,JVSD0 ,JVCSVP,JVDXY ,
     + JVDZ  ,JVPSC2,JVMEE ,JVMPP ,JVMPRP,JVMPPR
      PARAMETER(NIVRTX=3,NRVRTX=12,NWVRTX=12)
      INTEGER IVIPAR(NIVRTX),IVRPAR(NRVRTX)
      EQUIVALENCE(IVIPAR(1),JVTYPE),(IVRPAR(1),JVCSRP)
      SAVE /ODVIPA/,/ODVRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Alias track block:
      COMMON /ODAIPA/ MIATRK,
     + JAIVT1,JAIVT2,JAICTR
      COMMON /ODARPA/ MRATRK,
     + JAPX  ,JAPY  ,JAPZ  ,JAQ   ,JAKAPP,JAPHI0,
     + JAD0  ,JATLAM,JAZ0  ,JACHIR,JACHIZ,JAEM11,
     + JAEM21,JAEM22,JAEM31,JAEM32,JAEM33,JAEM44,
     + JAEM54,JAEM55,JAVX  ,JAVY  ,JAVZ
      PARAMETER(NIATRK=3,NRATRK=23,NWATRK=23)
      INTEGER IAIPAR(NIATRK),IARPAR(NRATRK)
      EQUIVALENCE(IAIPAR(1),JAIVT1),(IARPAR(1),JAPX)
      SAVE /ODAIPA/,/ODARPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Silicon tungsten calorimeter block:
      COMMON /ODSIPA/ MISIW,
     + JSSOUR
      COMMON /ODSRPA/ MRSIW,
     + JSE   ,JSTHET,JSPHI ,JSR   ,JSDR  ,JSLSHD
      PARAMETER(NISIW= 1, NRSIW= 6,NWSIW= 6)
      INTEGER ISIPAR(NISIW),ISRPAR(NRSIW)
      EQUIVALENCE(ISIPAR(1),JSSOUR),(ISRPAR(1),JSE)
      SAVE /ODSIPA/,/ODSRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Detector Tile Endcap block (only integers so far)
      COMMON /ODDIPA/ MIDTE,
     + JDITH, JDIPH, JDICAP, JDIADC, JDITD0, JDITDW, JDNOTP
      PARAMETER(NIDTE= 7, NRDTE= 0, NWDTE= 7)
* This reserves the variable name but avoids the 'unused' warnings
      PARAMETER(MRDTE= 0)
      INTEGER IDIPAR(NIDTE)
      EQUIVALENCE(IDIPAR(1),JDITH)
      SAVE /ODDIPA/
* Largest possible block dimensions:
      PARAMETER(NIBMAX=88,NRBMAX=79,NWBMAX=88)
* Detector masks:
      PARAMETER(
     + MSKCV=    1,MSKCJ=    2,MSKCZ=    4,
     + MSKCD=MSKCV+MSKCJ+MSKCZ,
     + MSKTB=    8,MSKPB=   16,MSKPE=   32,MSKEB=  128,MSKEE=  256,
     + MSKEC=MSKTB+MSKPB+MSKPE+MSKEB+MSKEE,
     + MSKHB=  512,MSKHE= 1024,MSKHP= 2048,
     + MSKHC=MSKHB+MSKHE+MSKHP,
     + MSKMB= 8192,MSKME= 16384,
     + MSKMU=MSKMB+MSKME,MSKFD=65536,MSKSW=524288)
* Link to ODCS, ODSI and ODCE banks from ODGNRL
      INTEGER LLODCS,LLODCE,LLODSI,LLODSL,LLODTR
      PARAMETER    (LLODCS=1,LLODCE=2,LLODSI=3,LLODSL=4,LLODTR=5)
      REAL            CHTRQU(9) ,CHECQU(3) ,CHSEL1(10),CHSET1(10),
     +                CHSEL2(13),CHSET2(13),CHSEL3(9) ,CHSET3(9)
      COMMON /ROCHCU/ CHTRQU    ,CHECQU    ,CHSEL1    ,CHSET1    ,
     +                CHSEL2    ,CHSET2    ,CHSEL3    ,CHSET3
*     View index numbers
      INTEGER JVWIEV,JVWIAX,JVWIHD
      PARAMETER (JVWIEV=4,JVWIAX=2,JVWIHD=0)
      INTEGER JVWIV1,JVWIV2,JVWIV3
      PARAMETER (JVWIV1=4,JVWIV2=5,JVWIV3=3)
*
*     Transformation numbers
      INTEGER JTNREV,JTNRAX,JTNRHD
      PARAMETER (JTNREV=4,JTNRAX=5,JTNRHD=3)
*
*     Workstation types.  (MetaFile O/p)
      INTEGER KWTMFO
      PARAMETER (KWTMFO=10201)
*
*     KWTYPE (screen) set by data card/KUIP
*     MFSTAT tells whether Metafile open
*     COLOUR flags whether screen in colour or not
      INTEGER KWTYPE,MFSTAT
      LOGICAL COLOUR
*     Workstation IDs  (GRope, MetaFile, DZdoc etc.)
*             KWIDGR,KWIDMF, etc.
*     Connection  IDs  (GRope, MetaFile)
*             KONIGR,KONIMF
*
      INTEGER KWTYGR,KWTYDZ,KWTYKU,
     + KWIDGR,KWIDMF,KWIDDZ,KWIDLE,KWIDDX,KWIDSI,KWIDSW,KWIDTF,
     + KONIGR,KONIMF,
     + IPPERS
      REAL DPRP
      EQUIVALENCE (KWTYGR,KWTYPE)
      COMMON/GRDATA/KWTYGR,KWTYDZ,KWTYKU,
     +KWIDGR,KWIDMF,KWIDDZ,KWIDLE,KWIDDX,KWIDSI,KWIDSW,KWIDTF,
     +KONIGR,KONIMF,
     +MFSTAT,COLOUR,IPPERS,DPRP
      INTEGER IGRLN , IGRPLC, IGRMK , IGRMKC, IGRTXF, IGRTXP, IGRTXC,
     +IGRFIS, IGRFSI, IGRFAC
      REAL    GRLWSC, GRMKSC, GRTXXP, GRTXSP, GRTXCH
      COMMON/GRATTR/IGRLN,GRLWSC,IGRPLC, IGRMK,GRMKSC,IGRMKC, IGRTXF,
     +IGRTXP,IGRTXC,GRTXXP,GRTXSP,GRTXCH, IGRFIS,IGRFSI,IGRFAC
*
*     Attributes currently set through GRAMP calls
*
*     Cutoffs in OD display.
CNKW.  Add LWWCUT.
      REAL GRTHMN,GRTHMX,GRPMIN,GRDMAX,GRZMAX
      INTEGER IGRNCJ
      LOGICAL LPCOUT,LTCOUT,LWWCUT
      COMMON/GRCUTS/GRTHMN,GRTHMX,LTCOUT,GRPMIN,LPCOUT, GRDMAX,GRZMAX,
     +IGRNCJ,LWWCUT
*
      INTEGER IJMODE,NJREQD
      REAL    RCONE,ECONE,YCUT
      COMMON/GRJETS/IJMODE,RCONE,ECONE,YCUT,NJREQD
*
      LOGICAL LIDE,LIDMU,LIDGC,LIDK,LIDL
      COMMON/GRLIDL/LIDE,LIDMU,LIDGC,LIDK,LIDL
      CHARACTER*80 CHMETA
      INTEGER IMFOP
      COMMON/GRMETC/CHMETA
      COMMON/GRMETI/IMFOP
      INTEGER IFODCD,IFODEC,IFODHC,IFODMU,IFODPS,IFODTB,IFODFD,IFODVX,
     +IODCOL,ITCXY,ITCSZ,IFODSW,IFODTE
      COMMON/GROD/IFODCD,IFODEC,IFODHC,IFODMU,IFODPS,IFODTB,IFODFD,
     +IFODVX,IODCOL,ITCXY,ITCSZ,IFODSW,IFODTE
*     Receive the content of DGEO, DHIT, DREC data cards - defining the
*     default drawing options for the run.
      INTEGER NDGEO,LDGEO,NDHIT,LDHIT,NDREC,LDREC,MODE,FSTPAS,IGRFIL,
     +IGRISI,IGRFED,IPVTX
      REAL    DSCALE
      LOGICAL GOFLAG
      LOGICAL LBOX,LHSTAT,LHAXES,LHHEAD,LHLOGO,LHSCAL,LHFILE,LHHEAB
      LOGICAL LAUTDZ,LAUTDX,LAUTTF,LAUTSI,LAUTSW,LAUTLE,LHXY,LHSIDE
      CHARACTER*4 CVIEW1,CVIEW2,CVIEW3
      COMMON/GRODAT/NDGEO,LDGEO(40),NDHIT,LDHIT(40),NDREC,LDREC(40),
     +GOFLAG,DSCALE,MODE,FSTPAS,LBOX,LHSTAT,IGRFIL,IGRISI,IGRFED,
     +LHAXES,LHHEAD,LHLOGO,LHSCAL,LHFILE,IPVTX,
     +LAUTDZ,LAUTDX,LAUTTF,LAUTSI,LAUTSW,LAUTLE,LHHEAB,LHXY,LHSIDE
      COMMON/GRODAC/CVIEW1,CVIEW2,CVIEW3
*.----------------------------------------------------------------------
*.-
*.-....   IDALVR : Common identification variables common block
*.-
*.-   Author   : R. Van Kooten
*.-   Version  : 1.01
*.-   Created  : 11-NOV-1991
*.-   Last mod : 13-May-1999
*.- 
*.- Modification Log
*.- 13-May-1999 M.Schroder increase IDNEXP from 10 to 15
*.-
*.----------------------------------------------------------------------
C
C..Parameters
C.. Number of subdetectors for status word
      INTEGER   IDNSUB
      PARAMETER (IDNSUB = 15)
C.. Number of experimental configurations (i.e. 1=1990, 2=1991, 3=1992,
C.. 4=1993, 5=1994 upto p67, 6=1994 p68, 7=1995, 8-10 not yet!)
      INTEGER             IDNEXP
      PARAMETER          (IDNEXP = 15)
C
C..Common block
      COMMON /IDALVR/   IDDETS(IDNSUB)
      SAVE /IDALVR/
C
C..Variable
C.. Status number for each subdetector IDDETS(i)
C.. The order of the entries is:
C.. i=  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
C..    CV CJ CZ TB PB EB PE EE HT HS HP MB ME FD SI
C
      INTEGER   IDDETS
C
C.. --- End of common block ---
*.-
*.-....   IDELCT : Electron identification cuts common block.
*.-                Needs +SEQ,IDALVR.
*.-
*.-                Cuts are low (L), high (H) or masks (M):
*.-                  var >= varL        ELvar .GE. ELvarL
*.-                  var < varH         ELvar .LT. ELvarH
*.-                  var & varM <> 0    IAND(ELvar, ELvarM) .NE. 0.
*.-
*.-   Author   : R. Van Kooten
*.-   Version  : 1.08
*.-   Created  : 17-SEP-1991
*.-   Modified : 04-Dec-1995
*.- Modification Log
*.-   23-Mar-98   O.Cooke   Added ELNNNB variable for Nblock fix-up.
*.-   12-Feb-98   C.Jones   Added NN6 and NN7 cut variables. 
*.-                         Changed eID default Net to 7
*.-   04-Dec-95   P.Wells   Extra NN selection
*.-   01-Oct-93   P.Wells   Make ELACCM selection dependent. Add ELEBTW
*.-
*.-        ELSEL - default selection of electron selection cuts
*.-                See IDELCU or IDPART for definition.
*.-
*.-        ELACCM - mask for acceptance, see IDELAC for definition.
*.-                 MODIFIED to be selection dependent V108
*.-
*.-     'Clean' Acceptance Cuts
*.-        ELEBTH - cut on cos(theta) acceptance for EB
*.-        ELEBTW - wide cut on cos(theta) acceptance for EB, ELEBSESI
*.-        ELPBTH - cut on cos(theta) acceptance for PB
*.-        ELEETL, ELEETH - cuts on cos(theta) acceptance for EE
*.-        ELPETL, ELPETH - cuts on cos(theta) acceptance for PE
*.-
*.-     Barrel Electron Identification Cuts:
*.-        ELNCZL - cut on number of CZ hits
*.-        ELNDXL - cut on number of dE/dx hits
*.-        ELDXNL, ELDXNH - cuts on normalized dE/dx
*.-        ELISOS - switch to demand E(cone) non-zero and pass cut below
*.-        ELISOL - cut on isolation variable
*.-        ELEPBS - switch to demand E(cone) non-zero and pass cut below
*.-        ELEPBL, ELEPBH - cuts on E(cone)/p
*.-        ELPSBS - switch to demand barrel presampler info available
*.-                 and pass cut below
*.-        ELPSBL, ELPSBM - lower and maximum cut on barrel
*.-                         presampler multiplicity.
*.-        ELCDFH - cut on difference of E(cone) and E(cone2)
*.-        ELSTBS - switch to demand status cuts given by ELSTAT.
*.-        ELCLSS - switch to demand whether E(cone) and E(cone2) blocks
*.-                 have to belong to a cluster.
*.-
*.-     ELEBSESI Barrel cuts (TN147):
*.-        ELMCZL - cut on number of CZ hits
*.-        ELMCZS - switch to cut on ELMCZ
*.-        ELMDXL - cut on number of dE/dx samples
*.-        ELMDXS - switch to cut on ELMDX
*.-        ELDXML, ELDXMH - cut on normalized dE/dx
*.-        ELDXMS - switch to cut on ELDXM
*.-        ELEPNL, ELEPNH - cut on normalized Econe/p
*.-        ELEPNS - switch to cut on ELEPN
*.-        ELEPNF - Flag for smearing Econe in MC:  see IDELEN.
*.-        ELSTSS - switch to demand SESI status cuts given by ELSTAT.
*.-
*.-     Endcap Electron Identification Cuts:
*.-        ELFDXL - cut on fraction of possible no. of dE/dx samples
*.-        ELDDXL, ELDDXH - cuts on dE/dx [keV/cm]
*.-        ELDPHi - parameters for cut on abs(phi(trk)-phi(cls))
*.-        ELDTHH - cut on abs(theta(trk)-theta(cls)) [deg]
*.-        ELEPEL, ELEPEH - cuts on E(cls)/p
*.-        ELPSES - switch to demand associated presampler cluser and
*.-                 pass cut below
*.-        ELPSEL, ELPSEM - lower and maximum cut on endcap
*.-                         presampler multiplicity
*.-        ELSTES - switch to demand status cuts given by ELSTAT.
*.-
*.-     Western Canadian Endcap Electron Identification Cuts (TN095)
*.-        ELEDNL - cut on number of dE/dx hits
*.-        ELFRCL - cut on fraction No. dE/dx hits/No. CJ hits
*.-        ELENDS - switch to demand CJ endpoint on track
*.-        ELDTWH - cut on ABSOLUTE value of difference in theta
*.-                 between cluster and track [rad]
*.-        ELNBLH - cut on number of blocks in endcap cluster
*.-        ELWDXL - cut on normalized dE/dx in endcap
*.-        ELECPL, ELECPH - cuts on Ecorr/p
*.-        ELSTWS - switch to demand status cuts given by ELSTAT.
*.-
*.-     Neural Net output Cut
*.-        ELNN3L - cut on output of NN number 3
*.-        ELNN5L - cut on output of NN number 5
*.-        ELSTNN - switch to demand status cuts given by ELSTAT.
*.-        ELINN  - which net to call... default currently 7
*.-        ELNNNB - Parameter to control Nblock fixup.
*.-
*.-     Electron Status Cuts
*.-        ELSTAT(i,j)
*.-        Status demanded (>=)for each subdetector i and
*.-        group of cuts j.
*.-        The order of the entries is:
*.-        i=  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
*.-           CV CJ CZ TB PB EB PE EE HT HS HP MB ME FD SI
*.----------------------------------------------------------------------
C..Parameters
C.. Number of Electron cut groups
      INTEGER             MBITEL
      PARAMETER          (MBITEL = 9)
C
      COMMON /IDELCT/   ELSEL,  ELACCM(0:MBITEL),
     +                  ELEBTH, ELEBTW, ELPBTH,
     +                  ELEETL, ELEETH, ELPETL, ELPETH,
     +                  ELNDXL, ELNCZL, ELDXNL, ELDXNH,
     +                  ELISOS, ELISOL, ELEPBS, ELEPBL, ELEPBH,
     +                  ELPSBS, ELPSBL, ELPSBM, ELCDFH,
     +                  ELFDXL, ELDDXL, ELDDXH,
     +                  ELDPH1, ELDPH2, ELDPH3, ELDPH4, ELDTHH,
     +                  ELEPEL, ELEPEH, ELPSES, ELPSEL, ELPSEM,
     +                  ELSTBS, ELSTES,
     +                  ELSTAT(IDNSUB, 0:MBITEL),
     +                  ELRLST(IDNSUB, 0:MBITEL),
     +                  ELSTST(IDNSUB, 0:MBITEL, IDNEXP),
     +                  ELCLSS, ELMCZL, ELMCZS, ELMDXL, ELMDXS,
     +                  ELDXML, ELDXMH, ELDXMS,
     +                  ELEPNL, ELEPNH, ELEPNS, ELEPNF,
     +                  ELSTSS, ELEDNL, ELFRCL, ELENDS, ELDTWH,
     +                  ELNBLH, ELWDXL, ELECPL, ELECPH, ELSTWS,
     +                  ELNN3L, ELNN5L, ELSTNN, ELINN,  ELNNNB, ELNN6L,
     +                  ELNN7L(2), ELNN8L(2), ELCVNN
      SAVE /IDELCT/
C
C..
      INTEGER   ELSEL
      INTEGER   ELACCM
C
      REAL      ELEBTH, ELEBTW, ELPBTH
      REAL      ELEETL, ELEETH, ELPETL, ELPETH
C
      INTEGER   ELNCZL
      REAL      ELNDXL, ELDXNL, ELDXNH
      LOGICAL   ELISOS
      REAL      ELISOL
      LOGICAL   ELEPBS
      REAL      ELEPBL, ELEPBH
      LOGICAL   ELPSBS
      REAL      ELPSBL, ELPSBM
      REAL      ELCDFH
C
      REAL      ELFDXL
      REAL      ELDDXL, ELDDXH
      REAL      ELDPH1, ELDPH2, ELDPH3, ELDPH4, ELDTHH
      REAL      ELEPEL, ELEPEH
      LOGICAL   ELPSES
      REAL      ELPSEL, ELPSEM
      LOGICAL   ELSTBS, ELSTES
      INTEGER   ELSTAT
      REAL      ELRLST
      INTEGER   ELSTST
C
      LOGICAL   ELCLSS
C
      INTEGER   ELMCZL
      LOGICAL   ELMCZS
      INTEGER   ELMDXL
      LOGICAL   ELMDXS
      REAL      ELDXML
      REAL      ELDXMH
      LOGICAL   ELDXMS
      REAL      ELEPNL
      REAL      ELEPNH
      LOGICAL   ELEPNS
      INTEGER   ELEPNF
      LOGICAL   ELSTSS
C
      REAL      ELEDNL
      REAL      ELFRCL
      LOGICAL   ELENDS
      REAL      ELDTWH
      INTEGER   ELNBLH
      REAL      ELWDXL
      REAL      ELECPL
      REAL      ELECPH
      LOGICAL   ELSTWS
C
      REAL      ELNN3L
      REAL      ELNN5L
      REAL      ELNN6L
      REAL      ELNN7L
      REAL      ELNN8L
      LOGICAL   ELSTNN
      INTEGER   ELINN
      INTEGER   ELCVNN
      REAL      ELNNNB
C.. --- End of common block ---
*.----------------------------------------------------------------------
*.-
*.-....   IDELVR : Electron identification variables common block
*.-
*.-   Author   : R. Van Kooten
*.-   Version  : 1.07
*.-   Created  : 17-SEP-1991
*.-
*.- Modification Log
*.-   03-Apr-98   A.Turcot  Added ELNN6, ELNN7, ELNN8
*.-   25-Mar-98   C.Jones   Added ELNNTY variable for Net number used.
*.-   12-Feb-98   C.Jones   Added ELCOST variable for electron Nets 7/8
*.-
*.----------------------------------------------------------------------
      COMMON /IDELVR/   ELACC,
     +                  ELNCZ,  ELDXN,  ELNDX,
     +                  ELPSL,  ELECL,  ELISO, ELEPB, ELPSB, ELMOM,
     +                  ELECON, ELECN2, ELCDF, ELCLS, ELDDX, ELEDX,
     +                  ELFDX,  ELEEL,  ELDPH,  ELDTH,
     +                  ELPEL,  ELPSE,  ELEPE,
     +                  ELBARL, ELECAP, ELNNET, ELPEAC,
     +                  ELQEFF, ELERAW, ELNBEC, ELTHEC,
     +                  ELMCZ,  ELSCZ,  ELCHH,  ELCHP,  ELMDX, ELECS,
     +                  ELEPN,
     +                  ELFRC,  ELENDP, ELNBLO, ELWDX, ELECOR, ELECP,
     +                  ELRUN,  ELEVT,  ELCTR,
     +                  ELNN3,  ELNP3,  ELNN5,  ELNT5, ELNU5,
     +                  ELNN6,  ELNN7,  ELNN8,
     +                  ELPTY,  ELCOST, ELNNTY
C
      SAVE /IDELVR/
C
C..Electron Identification acceptance word (see IDELAC)
C
      INTEGER      ELACC
C
C.. General Electron Identification
C
C..dE/dx track density (effective charge)    [keV]
      REAL         ELQEFF
C
C..Raw cluster energy [GeV]
      REAL         ELERAW
C
C..Theta at EB EE entrance
      REAL         ELTHEC
C
C.. Barrel Electron Identification
C
C..IDELEC Number of CZ hits
      INTEGER      ELNCZ
C..IDELEC Normalized dE/dx
      REAL         ELDXN
C..IDELEC Number of dE/dx samples
      REAL         ELNDX
C..Is presampler barrel information available (pointer non-zero)?
      LOGICAL      ELPSL
C..Is E(cone) and E(cone2) available (i.e. non-zero)?
      LOGICAL      ELECL
C..IDELEC Isolation Variable
      REAL         ELISO
C..IDELEC E(cone)/p
      REAL         ELEPB
C..IDELEC Barrel Presampler Multiplicity
      REAL         ELPSB
C..IDELEC Electron candidate momentum
      REAL         ELMOM
C..IDELEC E(cone) energy in blocks contained in a 30 mrad cone around track.
      REAL         ELECON
C..IDELEC E(cone2) above PLUS energy of the touching neighbouring blocks.
      REAL         ELECN2
C..Compound index of number of blocks used for ECONE
C..*10000 + number of possible blocks inside cone
C..*100   + number of blocks used for ECONE2
      INTEGER      ELNBEC
C..IDELEC - New selection - Difference between E(cone2) and E(cone).
      REAL         ELCDF
C..dE/dx [keV/cm]
      REAL         ELDDX
C..Error on dE/dx
      REAL         ELEDX
C
C.. Endcap Electron Identification
C
C..IDEEEL Fraction of possible number of dE/dx samples
C..       (NOTE: also filled for the barrel)
      REAL         ELFDX
C..Is there associated ECAL energy?
      LOGICAL      ELEEL
C..IDEEEL ABS(Phi Difference) between track and ECAL cluster [deg]
      REAL         ELDPH
C..IDEEEL Theta Difference between track and ECAL cluster [deg]
      REAL         ELDTH
C..Is there an associated presampler cluster?
      LOGICAL      ELPEL
C..IDEEEL Sum of presampler multiplicity in clusters within
C         d(theta) of 18 mrad and d(phi) of 60 mrad of track
      REAL         ELPSE
C..IDEEEL Cluster Energy associated to track
      REAL         ELCLS
C..IDEEEL Cluster Energy/p
      REAL         ELEPE
C..Passes barrel electron id selection including fiducial cuts
      LOGICAL      ELBARL
C..Passes endcap electron id selection including fiducial cuts
      LOGICAL      ELECAP
C..Passes NNET selection
      LOGICAL      ELNNET
C..Passes Lutz Kopke's IDPEAC
      LOGICAL      ELPEAC
C..Number of CZ hits (MC modified)
      INTEGER ELMCZ
C..Status for CZ (MC simulated)
      INTEGER ELSCZ
C..CZ chamber numbers (theta half-chamber and phi chamber)
      INTEGER ELCHH
      INTEGER ELCHP
C..Number of dE/dx samples (MC modified)
      INTEGER ELMDX
C..Econe (MC smeared for electrons)
      REAL ELECS
C..Normalized Econe/p (MC smeared for electrons)
      REAL ELEPN
C..Number of dE/dx hits divided by number of CJ hits
      REAL ELFRC
C..Does this track have an CJ endpoint measurement?
      LOGICAL ELENDP
C..Number of blocks in ecal cluster
      INTEGER ELNBLO
C..Western Canadian normalized dE/dx
      REAL ELWDX
C..Western Canadian corrected ecal cluster energy
      REAL ELECOR
C..Western Canadian Ecor/p
      REAL ELECP
C..Remember which run/evt/trk is stored
      INTEGER ELRUN,ELEVT,ELCTR
C..Output of NN number 3 with preselection cuts
      REAL ELNN3
C..Output of NN number 3 without preselection cuts
      REAL ELNP3
C..Output of NN number 5 (preselection cuts always on)
      REAL ELNN5
C..Output of NN number 5 for tuned/untuned MC
      REAL ELNT5, ELNU5
C..Output of NN number 6 (preselection cuts always on)
      REAL ELNN6
C..Output of NN number 7 (preselection cuts always on)
      REAL ELNN7
C..Output of NN number 8 (preselection cuts always on)
      REAL ELNN8
C..Output of BTDKTY (packed particle ID)
      INTEGER ELPTY
C. Cos(theta) of track (used by NN7 to decide between barrel/endcap)
      REAL ELCOST
C. Network number used for this track
      INTEGER ELNNTY
C.. --- End of common block ---
*.----------------------------------------------------------------------
*.-
*.-....   IDMUVR : Muon identification variables common block
*.-
*.-   Author   : J. Frederic Kral
*.-   Version  : 1.01
*.-   Created  :  3-SEP-1991
*.-   Modif    :  25-Sep-1993  P.Wells    add run/evt/trk
*.-                            D.Charlton Add more IDMUMB vars
*.-
*.----------------------------------------------------------------------
      COMMON /IDMUVR/   MUMAC,
     +                  MUI90, MUC90, MUE90,
     +                  MUNHC, MULHC, MUNHB, MUNMB, MUNME,
     +                  MUCHI, MUCPH,
     +                  MUDEL(4), MUERR(4), MUNRM(4),
     +                  MUIER,
     +                  MUJFZ,
     +                  MUWRK, MUNDX,
     +                  MURNT, MULRT,
     +                  MUMWT, MUEWT,
     +                  MUMUL,
     +                  MUHOL,
     +                  MUCBS, MUBES, MUSEP, MUSEC, MUMIS, MUSEG, MUEBS,
     +                  MUBDE(4),MUBER(4),MUBNR(4),
     +                  MUHCA,
     +                  MURUN,MUEVT,MUCTR
      SAVE /IDMUVR/
C
C..IDMUAC Mask for acceptance
      INTEGER   MUMAC
C
C..IDMUOL (IDMU90) Code = 1000*best + 300*gold + 20*silver-MU +
C..                       10*silver-HC + 2*bronze-MU + 1*bronze-HC
      INTEGER   MUI90
C..IDMUOL Matching chi-squared/dof
      REAL      MUC90
C..IDMUOL Error code for the event
      INTEGER   MUE90
C
C..Number of HCAL layers used in HCAL segment (inside IDMUOL code)
      INTEGER   MUNHC
C..Last HCAL layer used in HCAL segment (inside IDMUOL code)
      INTEGER   MULHC
C..Number of HB layers hit in a wide road (inside IDMUOL code)
      INTEGER   MUNHB
C..Number of MB layers hit in a wide road (inside IDMUOL code)
      INTEGER   MUNMB
C..Number of ME layers hit in a wide road (inside IDMUOL code)
      INTEGER   MUNME
C
C..IDMUMA Chi for position (phi and theta position)
      REAL      MUCHI
C..IDMUMA Chi for phi only (phi position and phi angle)
      REAL      MUCPH
C..IDMUMA Deviations (phi position, theta position, phi angle, theta angle)
      REAL      MUDEL
C..IDMUMA Errors on MUDEL (phi pos, theta pos, phi angle, theta angle)
      REAL      MUERR
C..IDMUMA Normalized MUDEL/MUERR (phi pos, theta pos, phi angle, theta angle)
      REAL      MUNRM
C..IDMUMA Status integer error code
      INTEGER   MUIER
C..DST flag for segments which fail z fit
      INTEGER   MUJFZ
C
C..CJ dE/dx Muon weight to reject Kaons (unsigned) and min num dE/dx hits
      REAL      MUWRK
C..  No cut is applied if MUNDX is below MUNDXL cut
      INTEGER   MUNDX
C
C..CJ Run test to reject decays
      REAL      MURNT
C..CJ Run test existence flag (run test not available for all data)
      LOGICAL   MULRT
C
C..IDMUWT Weight for muon match to charged track
      REAL      MUMWT
C..IDMUWT Status error code
      INTEGER   MUEWT
C
C..IDMUML Number of multiple segments close in angle to candidate muon
      INTEGER   MUMUL
C
C..IDHOLE True if the track went through the hole without leaving HCAL segment
      LOGICAL   MUHOL
C
C..IDMUMB Best match Chi for position (phi and theta position)
      REAL      MUCBS
C..IDMUMB Best match existence flag (=1 if best match)
      INTEGER   MUBES
C..IDMUMB Best solid angle separation
      REAL      MUSEP
C..IDMUMB Second best solid angle separation
      REAL      MUSEC
C..IDMUMB Mis-association ratio MUSEP/MUSEC (small values are good)
      REAL      MUMIS
C..IDMUMB Best muon segment
      INTEGER   MUSEG
C..IDMUMB Error code (=0 if OK)
      INTEGER   MUEBS
C..IDMUMB deviations, errors and normalised deviations
      REAL      MUBDE,MUBER,MUBNR
C..IDMUHC HCAL selection flags (10*tight+loose)
      INTEGER   MUHCA
C..Remember which run/evt/trk is stored
      INTEGER MURUN,MUEVT,MUCTR
C.. --- End of common block ---
*.----------------------------------------------------------------------
*.-
*.-....   IDMUCT : Muon identification cuts common block.
*.-                See IDMUCU for the use of cuts.
*.-                Needs +SEQ,IDALVR.
*.-
*.-   Author   : J. Frederic Kral
*.-   Version  : 1.01
*.-   Created  :  5-SEP-1991
*.-
*.-     Muon Status Cuts
*.-        MUSTAT(i,j)
*.-        Status demanded (>=)for each subdetector i and
*.-        group of cuts j.
*.-        The order of the entries is:
*.-        i=  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
*.-           CV CJ CZ TB PB EB PE EE HT HS HP MB ME FD SI
*.----------------------------------------------------------------------
C..Parameters
C.. Number of muon cut groups.
      INTEGER           MBITMU
      PARAMETER        (MBITMU = 11)
C
      COMMON /IDMUCT/   MUSEL,
     +                  MUMACM,
     +                  MUI90L, MUI90H, MUE90S,
     +                  MUNHCL, MULHCL, MUNMBL,
     +                  MUCHIH, MUCPHH, MUJFZS, MUIERS,
     +                  MUWRKL, MUNDXL,
     +                  MURNTL,
     +                  MUMWTL, MUMWTF, MUEWTS,
     +                  MUMULH, MUMULF,
     +                  MUHOLS,
     +                  MUCBSH, MUBESS, MUMISH, MUMISS, MUEBSS,
     +                  MUHCAL,
     +                  MUSTAT(IDNSUB, 0:MBITMU),
     +                  MURLST(IDNSUB, 0:MBITMU),
     +                  MUSTST(IDNSUB, 0:MBITMU, IDNEXP),
     +                  MUST1S, MUST2S, MUST3S, MUST4S, MUST5S,
     +                  MUST6S, MUST7S, MUST8S, MUST9S, MUSTAS,
     +                  MUSTBS
      SAVE /IDMUCT/
C
C..Selection of groups of cuts:  this is a mask used in IDMUCU
      INTEGER   MUSEL
C
C..All the cuts
      INTEGER   MUMACM
      INTEGER   MUI90L
      INTEGER   MUI90H
      LOGICAL   MUE90S
      INTEGER   MUNHCL
      INTEGER   MULHCL
      INTEGER   MUNMBL
      REAL      MUCHIH
      REAL      MUCPHH
      LOGICAL   MUJFZS
      LOGICAL   MUIERS
      REAL      MUWRKL
      INTEGER   MUNDXL
      REAL      MURNTL
      REAL      MUMWTL
      INTEGER   MUMWTF
      LOGICAL   MUEWTS
      INTEGER   MUMULH
      REAL      MUMULF
      LOGICAL   MUHOLS
      REAL      MUCBSH
      LOGICAL   MUBESS
      REAL      MUMISH
      LOGICAL   MUMISS
      LOGICAL   MUEBSS
      INTEGER   MUHCAL
C
      INTEGER   MUSTAT, MUSTST
      REAL      MURLST
      LOGICAL   MUST1S, MUST2S, MUST3S, MUST4S, MUST5S
      LOGICAL   MUST6S, MUST7S, MUST8S, MUST9S, MUSTAS
      LOGICAL   MUSTBS
C
C.. --- End of common block ---
*  Contains all BT FFREAD sequences
      INTEGER ICXDBG
      COMMON/BT3DBG/ICXDBG
      INTEGER LBT3D,LBTSVH
      COMMON/BT2D3D/LBT3D,LBTSVH
      REAL            QMUL1,QMUL2,QMUL3
      COMMON /BTFMUR/ QMUL1,QMUL2,QMUL3
      SAVE   /BTFMUR/
      REAL             BTPETE(5)
      COMMON /BTPDEF/ BTPETE
      SAVE   /BTPDEF/
*  Contains params for BTGVFT vertex finding
      REAL    QGVFT1
      COMMON /BTGVFC/ QGVFT1
      SAVE   /BTGVFC/
*  Contains pars for impact parameter joint probability B tag
      REAL    BTJPXC, BTJPAN, BTJPV0, BTJPSI
      COMMON /BTJPFF/ BTJPXC, BTJPAN, BTJPV0, BTJPSI
      SAVE   /BTJPFF/
*  Contains pars for user defined d0 resolution function
      INTEGER NPAR
      PARAMETER (NPAR=8)
      REAL    BTJPFN(NPAR)
      COMMON /BTJPRF/ BTJPFN
*  Mode to run rapidity based inclusive hadron finder
      INTEGER BTRMOD
      REAL    BTRCUT, BTMCUT
      COMMON /BTRFFR/ BTRMOD, BTRCUT, BTMCUT
      SAVE /BTRFFR/
      REAL            QZMUL1,QZMUL2,QZMUL3
      COMMON /BTZMUR/ QZMUL1,QZMUL2,QZMUL3
      SAVE   /BTZMUR/
*  Contains params for separated vertex search & B tagging
*PV 20-06-96 Add QSVX10
      REAL    QSVX1, QSVX2, QSVX3, QSVX4, QSVX5, QSVX6, QSVX7
     +      , QSVX8, QSVX9, QSVX10
      REAL    QSVT1, QSVT2, QSVT3
      COMMON /BTSVTC/ QSVX1,QSVX2,QSVX3,QSVX4,QSVX5,QSVX6,QSVX7,QSVX8,
     +          QSVX9,QSVX10,QSVT1,QSVT2,QSVT3
      SAVE   /BTSVTC/
*  Contains cuts for selecting 'vertex-quality' tracks for vtx routines
      REAL    QVXT1, QVXT2, QVXT3, QVXT4, QVXT5, QVXT6, QVXT7, QVXT8,
     +        QVXT9, QVXT10
      INTEGER IQVXT1,IQVXT2
      COMMON /BTVXCT/ QVXT1,QVXT2,QVXT3,QVXT4,QVXT5,QVXT6,QVXT7,QVXT8,
     +                QVXT9,QVXT10
      COMMON /BTVXCI/ IQVXT1,IQVXT2
      SAVE   /BTVXCT/
      SAVE   /BTVXCI/
      INTEGER BTVNNO
      COMMON/BTVNET/BTVNNO
      INTEGER NBTTQA,NBTEQA
*
*PV the dimension for NBTTQA extended by 1
*RK the dimension for NBTTQA extended by another 1
*
      PARAMETER(NBTTQA=14,NBTEQA=3)
      REAL BTYCUT, BTCONE(2), BTTHCS, BTTQAL(NBTTQA), BTEQAL(NBTEQA)
      REAL BTPRCU(3)
      INTEGER BTJTOP, BTJUSE, BTJXMN, BTDSTA(15)
      INTEGER BTTKMN, BTPRCH, BTTKYO, BTNJET
      COMMON /BTFFDR/ BTYCUT, BTCONE, BTTHCS, BTPRCU
      COMMON /BTFFDI/ BTJTOP, BTJUSE, BTJXMN, BTTKMN, BTDSTA, BTPRCH
     +               ,BTTKYO, BTNJET
      COMMON /BTFFCX/ BTTQAL
      COMMON /BTFFEC/ BTEQAL
      SAVE /BTFFDR/
      SAVE /BTFFDI/
      SAVE /BTFFCX/
      SAVE /BTFFEC/
      INTEGER  MXJET, MXTKJT, MXCLJT
      PARAMETER(MXJET=15,MXTKJT=200,MXCLJT=200)
      INTEGER  IODJT, IODJT0, IODJTV, IJTKOD, IJCLOD
      INTEGER  NJET, IJMUL, IJMUL0, IJMULV, ITHOD, ITHOD0
      INTEGER  JODJT, JODJT0, JODJTV, JTFL, JTBH, ITHJET
      REAL PJET, THR, THRVEC, EVIS, DIPE, D0MED, YL, YU
      COMMON /BTJETR/ PJET(5,MXJET), THR, THRVEC(3), EVIS, DIPE, D0MED,
     +                YL,YU
      COMMON /BTJETI/ IODJT(MXJET,MXTKJT),IODJT0(MXJET,MXCLJT),
     +                IODJTV(MXJET,MXTKJT),IJMUL(MXJET),IJMUL0(MXJET),
     +                IJMULV(MXJET),IJTKOD(MXTKJT),IJCLOD(MXCLJT),
     +                ITHOD(MXTKJT),ITHOD0(MXCLJT),NJET,
     +                JODJT(MXTKJT,MXJET),JODJT0(MXCLJT,MXJET),
     +                JODJTV(MXTKJT,MXJET),JTFL(MXJET),JTBH(MXJET),
     +                ITHJET(MXJET)
      SAVE /BTJETR/
      SAVE /BTJETI/
      INTEGER MAXPRI
      PARAMETER(MAXPRI=200)
      INTEGER NXYZBT,IXYZBT(MAXPRI)
      INTEGER NXYZCX,IXYZCX(MAXPRI),NXYZCB,IXYZCB(MAXPRI)
      INTEGER NZZZBT,IZZZBT(MAXPRI)
      INTEGER NZZZCX,IZZZCX(MAXPRI),NZZZCB,IZZZCB(MAXPRI)
      INTEGER NXYBTH(2),IXYBTH(MAXPRI,2),NZZBTH(2),IZZBTH(MAXPRI,2)
      REAL    XYZBT,XYZCX,XYZCXB,XYZBS,XYZUSR,XYZBTH
      REAL    COVBT,COVCX,COVCXB,COVBS,COVUSR,COVBTH
      REAL    CHTXBT(MAXPRI),CHTZBT(MAXPRI),CHIXBT,CHIZBT,CHXBTH,CHZBTH
      REAL    CHTXCX(MAXPRI),CHTZCX(MAXPRI),CHIXCX,CHIZCX
      REAL    CHTXCB(MAXPRI),CHTZCB(MAXPRI),CHIXCB,CHIZCB
      REAL    BSBBT(MAXPRI),BBT(MAXPRI),BSBBTZ(MAXPRI),BBTZ(MAXPRI)
      REAL    BSBCX(MAXPRI),BCX(MAXPRI),BSBCXZ(MAXPRI),BCXZ(MAXPRI)
      REAL    BSBCB(MAXPRI),BCB(MAXPRI),BSBCBZ(MAXPRI),BCBZ(MAXPRI)
      REAL    BSBBS(MAXPRI),BBS(MAXPRI),BSBBSZ(MAXPRI),BBSZ(MAXPRI)
      REAL    BSBBT3(MAXPRI),BBT3(MAXPRI),BSBCX3(MAXPRI),BCX3(MAXPRI)
      REAL    BSBCB3(MAXPRI),BCB3(MAXPRI),BSBBS3(MAXPRI),BBS3(MAXPRI)
      COMMON /BTPRIM/ XYZBT(3),XYZCX(3),XYZCXB(3),XYZBS(3),XYZUSR(3)
     +               ,COVBT(6),COVCX(6),COVCXB(6),COVBS(6),COVUSR(6)
     +               ,CHTXBT,CHTZBT,CHIXBT,CHIZBT
     +               ,CHTXCX,CHTZCX,CHIXCX,CHIZCX
     +               ,CHTXCB,CHTZCB,CHIXCB,CHIZCB
     +               ,BSBBT, BBT, BSBCX, BCX, BSBCB, BCB, BSBBS, BBS
     +               ,BSBBTZ,BBTZ,BSBCXZ,BCXZ,BSBCBZ,BCBZ,BSBBSZ,BBSZ
     +               ,BSBBT3,BBT3,BSBCX3,BCX3,BSBCB3,BCB3,BSBBS3,BBS3
     +               ,XYZBTH(3,2),COVBTH(6,2),CHXBTH(2),CHZBTH(2)
      COMMON /BTPRII/ NXYZBT,IXYZBT,NXYZCX,IXYZCX,NXYZCB,IXYZCB
     +               ,NZZZBT,IZZZBT,NZZZCX,IZZZCX,NZZZCB,IZZZCB
     +               ,NXYBTH,IXYBTH,NZZBTH,IZZBTH
      SAVE /BTPRIM/
      SAVE /BTPRII/
      INTEGER MXVTX, MXTKVX
      PARAMETER(MXVTX=30,MXTKVX=200)
      INTEGER NVTX, IODVX, IVTKOD, IVMUL, NJETV, IVMULJ, IVJET, JODVX,
     +        NVSIG, IVNDOF, IODVZ, JODVZ, IVMULZ
      REAL PVTX,VXY,VCOV,VCHI2,VPROB, VDLEN, VSEPS, VDELPS,
     +                BSBVX,BSBVZ,VDLEN3,VDERR3,VNN,
     +                VQVTX,VEQVTX,VTVMCR,VTNNPS
      COMMON /BTVTXR/ PVTX(5,MXVTX), VXY(3,MXVTX), VCOV(6,MXVTX),
     +                VCHI2(MXVTX), VPROB(MXVTX), VDLEN(MXVTX),
     +                VSEPS(MXVTX), VDELPS(MXVTX),
     +                BSBVX(MXTKVX,MXVTX),BSBVZ(MXTKVX,MXVTX),
     +                VDLEN3(MXVTX),VDERR3(MXVTX),VNN(MXVTX),
     +                VQVTX(MXVTX),VEQVTX(MXVTX),
     +                VTVMCR(MXVTX,2),VTNNPS(MXTKVX,MXVTX)
      COMMON /BTVTXI/ NVTX,IODVX(MXVTX,MXTKVX),IVMUL(MXVTX),
     +                IVTKOD(MXTKVX),NJETV(MXVTX),IVMULJ(MXVTX),
     +                IVJET(MXVTX),JODVX(MXTKVX,MXVTX),NVSIG(MXVTX),
     +                IVNDOF(MXVTX),IODVZ(MXVTX,MXTKVX),
     +                JODVZ(MXTKVX,MXVTX),IVMULZ(MXVTX)
      INTEGER MXTRK,NBTRAK,NBCLUA,NBCLUU
      PARAMETER (MXTRK=200)
      INTEGER IODTRK,IODCLA,IODCLU
      COMMON /BTTRAK/ IODTRK(MXTRK),NBTRAK,IODCLA(MXTRK),NBCLUA
     +               ,IODCLU(MXTRK),NBCLUU
      REAL    UNCZTL,UNCZZ0,UNCZEM
      COMMON /BTTRAC/ UNCZTL(MXTRK),UNCZZ0(MXTRK),UNCZEM(3,MXTRK)
      SAVE /BTTRAK/
      SAVE /BTTRAC/
*
*     Selected tracks and clusters.
*
      INTEGER MAXCT,MAXEC,MAXHC,MAXFE,MAXFK,MAXSW,MXDSTC,
     +        JWWDEF,JMTDEF
      PARAMETER (MAXCT=200)
      PARAMETER (MAXEC=200)
      PARAMETER (MAXHC=100)
      PARAMETER (MXDSTC=500)
      PARAMETER (MAXFE=10)
      PARAMETER (MAXFK=10)
      PARAMETER (MAXSW=10)
      PARAMETER (JWWDEF=1)
      PARAMETER (JMTDEF=2)
      INTEGER NCT,NEC,NUEC,NHC,ICT,IEC,IHC,IJC,IJE,IJH,IIMASK,
     +        NFE,NFK,NSW,IFE,IFK,ISW,IJFE,IJFK,IJSW,IWWSEL,IQCNOW,
     +        IQCNEW,ID2WCT,ID2WEC,ID2WHC
      REAL    PCT,PEC,PHC,PFE,PFK,PSW,EMTCT,EMTEC,EMTHC,PCTEX
      LOGICAL LSELCT,LSELEC,LSELHC,LSELFE,LSELFK,LSELSW
      COMMON/WWTRKS/NCT,NEC,NUEC,NHC,NFE,NFK,NSW,
     +              PCT(5,MAXCT),ICT(MAXCT),
     +              EMTCT(MAXCT),
     +              PEC(5,MAXEC),IEC(MAXEC),
     +              EMTEC(MAXEC),
     +              PHC(5,MAXHC),IHC(MAXHC),
     +              EMTHC(MAXHC),
     +              PFE(5,MAXFE),IFE(MAXFE),
     +              PFK(5,MAXFK),IFK(MAXFK),
     +              PSW(5,MAXSW),ISW(MAXSW),
     +              IJC(MAXCT),IJE(MAXEC),IJH(MAXHC),
     +              IJFE(MAXFE),IJFK(MAXFK),IJSW(MAXSW),
     +              IIMASK,IWWSEL,IQCNOW,IQCNEW,
     +              LSELCT(MAXCT),LSELEC(MAXEC),LSELHC(MAXHC),
     +              LSELFE(MAXFE),LSELFK(MAXFK),LSELSW(MAXSW),
     +              PCTEX(4,MAXCT),
     +              ID2WCT(MXDSTC),ID2WEC(MXDSTC),ID2WHC(MXDSTC)
*
*-- Definition of different selection-specific sets of cuts
      INTEGER    JQCDEF,   JQC4Q,   JQCQL,   JQCLL
      PARAMETER (JQCDEF=1, JQC4Q=2, JQCQL=3, JQCLL=4)
      CHARACTER*8   CHQCDF
      COMMON/WWQCDF/CHQCDF(4)
*
*     Lepton id information
*
      INTEGER        NMXEMU,NUMEMU
      PARAMETER     (NMXEMU=5,NUMEMU=20)
      INTEGER       IWWEMU,ICTEMU,IECEMU,IHCEMU,NWWEMU
      INTEGER       JWWEMU(NMXEMU),JCTEMU(NUMEMU,NMXEMU),
     +              JECEMU(NUMEMU,NMXEMU),JHCEMU(NUMEMU,NMXEMU),
     +              NCTEMU(NMXEMU),NECEMU(NMXEMU),NHCEMU(NMXEMU)
      EQUIVALENCE   (IWWEMU,JWWEMU(1)),   (ICTEMU,JCTEMU(1,1)),
     +              (IECEMU,JECEMU(1,1)), (IHCEMU,JHCEMU(1,1))
      COMMON/WWLEPT/JWWEMU,JCTEMU,JECEMU,JHCEMU,
     +              NWWEMU,NCTEMU,NECEMU,NHCEMU
*
*     Jets.  Alternative version of the common block to be used
*            along with BT (otherwise NJET, PJET duplicated).
*            In this version they are called NJETWW and PJETWW
*
      INTEGER IRUJET,IEVJET,IALGO,NJETWW,MAXJET
      PARAMETER (MAXJET=20)
      REAL PJETWW
      COMMON/WWJETZ/IRUJET,IEVJET,IALGO,NJETWW,PJETWW(5,MAXJET)
*
*-- Parameters governing cuts (all selections). These used in WWSLCT.
*-- (What we really need are structures in fortran.)
      INTEGER    NQCUTS
      PARAMETER (NQCUTS=4)
*
      INTEGER    NTQUA,    NEQUA,   NHQUA,   NFQUA
      PARAMETER (NTQUA=12, NEQUA=6, NHQUA=1, NFQUA=3)
      INTEGER NCJMIN
      REAL PTMIN,PMAX,D0MAX,Z0MAX,CHRMAX,TLAMAX,CHZMAX,PHIMIN,PHIMAX,
     +     DPOVP,ZUMAX
      COMMON/WWTQUA/PTMIN(NQCUTS),PMAX(NQCUTS),NCJMIN(NQCUTS),
     +              D0MAX(NQCUTS),Z0MAX(NQCUTS),CHRMAX(NQCUTS),
     +              TLAMAX(NQCUTS),CHZMAX(NQCUTS),PHIMIN(NQCUTS),
     +              PHIMAX(NQCUTS),DPOVP(NQCUTS),ZUMAX(NQCUTS)
*
      INTEGER NEBMIN,NEEMIN
      REAL EBRMIN,EBCMIN,EERMIN,EECMIN
      COMMON/WWEQUA/EBRMIN(NQCUTS),EBCMIN(NQCUTS),NEBMIN(NQCUTS),
     +              EERMIN(NQCUTS),EECMIN(NQCUTS),NEEMIN(NQCUTS)
*
      REAL EHTMIN
      COMMON/WWHQUA/EHTMIN(NQCUTS)
*
      REAL EFEMIN,EFKMIN,ESWMIN
      COMMON/WWFQUA/EFEMIN(NQCUTS),EFKMIN(NQCUTS),ESWMIN(NQCUTS)
*
*   Flag to control whether WWTIDY is called
      LOGICAL LTIDY
      COMMON/WWLQUA/LTIDY(NQCUTS)

*
*-- Quality cuts for photon finder.
      INTEGER NBMAX,NB90MX
      REAL    ECOPHO,ACOPHO,EMAXHC,CMAXHC
      COMMON/WWPHOO/NBMAX(4),NB90MX(4),ECOPHO,ACOPHO,EMAXHC,CMAXHC
*
*    Cuts used in WW-->qqqq jet pairing LH selection
*
*
      REAL    Y45D4Q, L4QCUT, L5JCUT
      COMMON/WWJPSE/Y45D4Q, L4QCUT, L5JCUT

*    Cuts used in WW-->qqqq selection
*
      INTEGER    JCU4Q,   JLS4Q,   JRL4Q,   JPC4Q,   JPA4Q
      PARAMETER (JCU4Q=1, JLS4Q=2, JRL4Q=3, JPC4Q=4, JPA4Q=5)
      REAL    RMAX4Q,RVIS4Q,RMIS4Q,Y34D4Q,CTMX4Q,PKF4Q,AKF4Q,RMNL4Q
      INTEGER NCMI4Q,NEMI4Q,NJMI4Q,IDMH4Q,IALG4Q
      COMMON/WW4QSE/NCMI4Q,NEMI4Q,RMAX4Q,RVIS4Q,RMIS4Q,Y34D4Q,
     +              NJMI4Q,CTMX4Q,PKF4Q,AKF4Q,IDMH4Q,
     +              IALG4Q,RMNL4Q

*
*    Cuts used in WW-->qq selection
*
      REAL    RPHO2Q,RVIS2Q,RMIS2Q,BNMI2Q,RVMI2Q,RFD2Q,RLEP2Q,DSQ2Q,
     +        Y45D2Q
      INTEGER NCMI2Q,NEMI2Q
      COMMON/WW2QSE/NCMI2Q,NEMI2Q,RVIS2Q,RMIS2Q,RVMI2Q,
     +              BNMI2Q,RPHO2Q,RFD2Q,RLEP2Q,DSQ2Q,Y45D2Q

*
*    Cuts used in WW-->qqlnu selection
*
      INTEGER    JQQEM,   JQLTV,   JQLLK
      PARAMETER (JQQEM=1, JQLTV=2, JQLLK=3)
      INTEGER IALGQL,NCMIQL,NEMIQL,LPIDQL
      COMMON/WWQLSE/IALGQL,NCMIQL,NEMIQL,LPIDQL

*
*    Cuts used in WW-->qqmunu selection
*
      REAL    RMINQM,P2MXQM,RVISQM,RMISQM,CTMSQM,Y23QM,PTMIQM,CTLEQM,
     +        RGAMQM,RVMIQM
      INTEGER LZRJQM,NJMIQM
      COMMON/WWQMSE/RMINQM,P2MXQM,RVISQM,RMISQM,CTMSQM,LZRJQM,Y23QM,
     +              PTMIQM,CTLEQM,RGAMQM,NJMIQM,RVMIQM

*
*    Cuts used in WW-->qqenu selection
*
      REAL    RMINQE,P2MXQE,RVISQE,RMISQE,CTMSQE,Y23QE,PTMIQE,CTLEQE,
     +        REMNQE,RGAMQE,CTPCQE,RVMIQE
      INTEGER LZRJQE,NJMIQE
      COMMON/WWQESE/RMINQE,P2MXQE,RVISQE,RMISQE,
     +              CTMSQE,LZRJQE,Y23QE,PTMIQE,CTLEQE,REMNQE,RGAMQE,
     +              NJMIQE,CTPCQE,RVMIQE

*
*    Cuts used in WW-->qqtaunu selection
*
      INTEGER    JTTAU,   JLTAU
      PARAMETER (JTTAU=1, JLTAU=2)
      REAL    RVISQT,RMISQT,CTMSQT,Y23QT,COJEQT,COT1QT,COT2QT,EANNQT,
     +        RMISLH,RMINLH,RVMIQT
      INTEGER IALGQT,NJMIQT,IMSKQT,IICVID,IDMHQT
      COMMON/WWQTSE/IALGQT,RVISQT,RMISQT,CTMSQT,Y23QT,
     +              NJMIQT,COJEQT,COT1QT,COT2QT,EANNQT,IMSKQT,IICVID,
     +              RMISLH,RMINLH,IDMHQT,RVMIQT
*
*    Cuts used in WW-->qqlnu TGV style selection
*
      INTEGER         NCQLTV,NEQLTV
      LOGICAL         LPIDTV
      REAL            RPMSTV, REVSTV
      REAL            P2MAXL(2), PMINL(2), CTMAXM(2), PTMINM(2)

      COMMON /WWQLTC/ NCQLTV,NEQLTV,
     +                LPIDTV,
     +                RPMSTV, REVSTV,
     +                P2MAXL, PMINL, CTMAXM, PTMINM
*
*    Cuts used for electron ID
*
      INTEGER IELID,NBLMXE,NDXMN,IGCTAG,NHCMX
      REAL    EOPMNB,EOPMXB,XISOLB,EOPMNO,EOPMXO,EOPMNE,EOPMXE,DXNMN,
     +        DXNMX,DPHIMX
      COMMON/WWELSE/IELID,EOPMNB,EOPMXB,XISOLB,EOPMNO,EOPMXO,EOPMNE,
     +              EOPMXE,NBLMXE,NDXMN,DXNMN,DXNMX,IGCTAG,NHCMX,
     +              DPHIMX
*
*    Cuts used for muon ID
*
      INTEGER IMUID,STRPCM,MNMBCM,MNMECM,MNHBCM,MNMMCM
      REAL    SLMXCM,ECMMX
      DIMENSION ECMMX(3)
      COMMON/WWMUSE/IMUID,STRPCM,MNMBCM,MNMECM,MNHBCM,MNMMCM,SLMXCM,
     +              ECMMX
*
*   Variables used in muon ID
*
      INTEGER IHCAL,IMB,IME,IMUFLG
      REAL    HADSL,ECALM
      COMMON/WWMUVR/IHCAL,IMB,IME,HADSL,ECALM,IMUFLG
*
*     Isolated photons
*
      INTEGER MAXPHO
      PARAMETER (MAXPHO=20)
      INTEGER IWWPHO,NWWPHO
      COMMON/WWPHO/NWWPHO,IWWPHO(MAXPHO)
**  COMMON block with estimated 4-vector of hadron system recoiling
**  against ISR from routine WWSPR:
      REAL PHAD(4)
      COMMON /WWPHAD/ PHAD
*
*
      INTEGER IWWSPM
      REAL    WWSPYC,WWCTHF,WWSP4C,WWSP3C,WWSP2C
      COMMON/WWSPRC/IWWSPM,WWSPYC,WWCTHF,WWSP4C,WWSP3C,WWSP2C
*
*     Parameters governing WWSPR algorithm
*
*     IWWSPM : IIMASK value
*     WWSPYC : y_cut
*     WWCTHF : cos(theta) beyond which kin fit not attempted.
*     WWSP4C : Probability cut for 4C fit
*     WWSP3C : Probability cut for 3C fit
*     WWSP2C : Probability cut for 2C fit
*
*
*--  This is the ntuple/common filled by the event veto subroutines:
*--  LLVQQ and LLVCO
*
      INTEGER NNVET
*-- number of entries in COS ntuple
      PARAMETER (NNVET=18)
      LOGICAL BARREL,PLANE
      REAL XVRUN,XVEVT,XVCODE,XNNORM,XNECA,XNTOF,XCFLAG,TMIN,CC
     +,    TONE,TTWO,TBEST,XPHI,D0MIN,Z0MIN,XBARRL,PONE,PTWO
      INTEGER NNTOF,ICFLAG
      LOGICAL NFILVE
      COMMON/LLNVET/ NFILVE,NNTOF,ICFLAG,BARREL,PLANE
     +,   XVRUN,XVEVT,XVCODE,XNNORM,XNECA,XNTOF,XCFLAG,TMIN,CC
     +,   TONE,TTWO,TBEST,XPHI,D0MIN,Z0MIN,XBARRL,PONE,PTWO
      SAVE  /LLNVET/
*-- the actual ntuple is equivalenced to the REAL variables in the common
      REAL XNVET(NNVET)
      EQUIVALENCE (XVRUN,XNVET(1))
*
*--  This is the ntuple/common filled by the muon pair classification
*--  subroutine: LLCMP
*
      INTEGER NNDATA,NNMONT,NNCMP
*-- NNDATA: number of entries in muon pair ntuple for real data
*-- NNMONT: number of extra entries in muon pair ntuple for monte carlo
*-- NNCMP:  total number of entries in muon pair ntuple
      PARAMETER (NNDATA=166,NNMONT=23,NNCMP=NNDATA+NNMONT)
      REAL
     +  RUNMP,EVTMP,ECMMP,LEPFIL,CODEMP,TRIGMP,PHILTR,NUMBHA
     +, DETST1,DETST2,TRGST1,TRGST2,NNORMP,NECAMP,FLAGMP
     +, TMINMP,TBESMP,DMINMP,ZMINMP,XBARMP,HIGHMP,XNMU,SUMEMP,EMAXMP
     +, XTOT1,ACOPL,CACOP,ACOLL,PHIMP,THETMP,ETA,CTHBLB,NBIGMP
     +, ECACOL,ECACOP,MUACOL,MUACOP,PSACOL,PSACOP,SELMP,KILLMP,MUCOS
     +, MUPHI,PTRGMP,FREE
      REAL
     +  PX1,PY1,PZ1,P1,Q1,NACV1,NSCV1,NCJ1,NCZ1,D01,Z01,ZUNC1,DP1,ISECT1
     +, PSECT1,FITYP1,COSB1,COSFL1,TOF1,DPTOF1,ECLUS1,ESUM1,MB1,ME1
     +, IHCAL1,HADSL1,GEOM1,YESMU1,TRIG1,CNTRL1,XMU1,YMU1,COSM1
     +, PTRIG1,FREE1(2)
     +, PX2,PY2,PZ2,P2,Q2,NACV2,NSCV2,NCJ2,NCZ2,D02,Z02,ZUNC2,DP2,ISECT2
     +, PSECT2,FITYP2,COSB2,COSFL2,TOF2,DPTOF2,ECLUS2,ESUM2,MB2,ME2
     +, IHCAL2,HADSL2,GEOM2,YESMU2,TRIG2,CNTRL2,XMU2,YMU2,COSM2
     +, PTRIG2,FREE2(2)
     +, EX1,EY1,EZ1,E1,ERAW1,NBLOK1,EFRAC1,IDET1,COS1T1,COS2T1,EFREE1
     +, EX2,EY2,EZ2,E2,ERAW2,NBLOK2,EFRAC2,IDET2,COS1T2,COS2T2,EFREE2
     +, EX3,EY3,EZ3,E3,ERAW3,NBLOK3,EFRAC3,IDET3,COS1T3,COS2T3,EFREE3
     +, EX4,EY4,EZ4,E4,ERAW4,NBLOK4,EFRAC4,IDET4,COS1T4,COS2T4,EFREE4
     +, USE1MP,USE2MP,USE3MP,USE4MP,USE5MP
     +, ACOPMC,XTOTMC,PXMC1,PYMC1,PZMC1,PMC1,PXMC2,PYMC2,PZMC2,PMC2
     +, EXMC1,EYMC1,EZMC1,EMC1,POINT1,EXMC2,EYMC2,EZMC2,EMC2,POINT2
     +, IDMC1,IDMC2,ACOLMC
      LOGICAL BTOBEC,BTOBMU,BTOBPS
      LOGICAL NFILMP
      INTEGER NMU,ITRGMP,IPHILT,ITRIG1,ICNTL1,ITRIG2,ICNTL2
     +, IPTGMP,IPTRG1,IPTRG2
      COMMON/LLCCMP/ BTOBEC,BTOBMU,BTOBPS
     +, NFILMP,NMU,ITRGMP,IPHILT,ITRIG1,ICNTL1,ITRIG2,ICNTL2
     +, RUNMP,EVTMP,ECMMP,LEPFIL,CODEMP,TRIGMP,PHILTR,NUMBHA
     +, DETST1,DETST2,TRGST1,TRGST2,NNORMP,NECAMP,FLAGMP
     +, TMINMP,TBESMP,DMINMP,ZMINMP,XBARMP,HIGHMP,XNMU,SUMEMP,EMAXMP
     +, XTOT1,ACOPL,CACOP,ACOLL,PHIMP,THETMP,ETA,CTHBLB,NBIGMP
     +, ECACOL,ECACOP,MUACOL,MUACOP,PSACOL,PSACOP,SELMP,KILLMP,MUCOS
     +, MUPHI,PTRGMP,FREE
      COMMON/LLCCMP/
     +  PX1,PY1,PZ1,P1,Q1,NACV1,NSCV1,NCJ1,NCZ1,D01,Z01,ZUNC1,DP1,ISECT1
     +, PSECT1,FITYP1,COSB1,COSFL1,TOF1,DPTOF1,ECLUS1,ESUM1,MB1,ME1
     +, IHCAL1,HADSL1,GEOM1,YESMU1,TRIG1,CNTRL1,XMU1,YMU1,COSM1
     +, PTRIG1,FREE1
     +, PX2,PY2,PZ2,P2,Q2,NACV2,NSCV2,NCJ2,NCZ2,D02,Z02,ZUNC2,DP2,ISECT2
     +, PSECT2,FITYP2,COSB2,COSFL2,TOF2,DPTOF2,ECLUS2,ESUM2,MB2,ME2
     +, IHCAL2,HADSL2,GEOM2,YESMU2,TRIG2,CNTRL2,XMU2,YMU2,COSM2
     +, PTRIG2,FREE2
     +, EX1,EY1,EZ1,E1,ERAW1,NBLOK1,EFRAC1,IDET1,COS1T1,COS2T1,EFREE1
     +, EX2,EY2,EZ2,E2,ERAW2,NBLOK2,EFRAC2,IDET2,COS1T2,COS2T2,EFREE2
     +, EX3,EY3,EZ3,E3,ERAW3,NBLOK3,EFRAC3,IDET3,COS1T3,COS2T3,EFREE3
     +, EX4,EY4,EZ4,E4,ERAW4,NBLOK4,EFRAC4,IDET4,COS1T4,COS2T4,EFREE4
     +, USE1MP,USE2MP,USE3MP,USE4MP,USE5MP
     +, ACOPMC,XTOTMC,PXMC1,PYMC1,PZMC1,PMC1,PXMC2,PYMC2,PZMC2,PMC2
     +, EXMC1,EYMC1,EZMC1,EMC1,POINT1,EXMC2,EYMC2,EZMC2,EMC2,POINT2
     +, IDMC1,IDMC2,ACOLMC,IPTGMP,IPTRG1,IPTRG2
      SAVE  /LLCCMP/
*-- the actual ntuple is equivalenced to the REAL variables in the common
      REAL XNCMP(NNCMP)
      EQUIVALENCE (RUNMP,XNCMP(1))
*--should move to somewhere else?
      INTEGER  MAXCON
      PARAMETER (MAXCON=20)
*--ntuple/common for the tau pairs
      INTEGER NNDATT,NNMCTT,NNCTP
CXX   PARAMETER (NNDATT=62,NNMCTT=39,NNCTP=NNDATT+NNMCTT)
      PARAMETER (NNDATT=80,NNMCTT=39,NNCTP=NNDATT+NNMCTT)
      LOGICAL NFILTP
      REAL XNCTP(NNCTP)
      REAL
     +XRUN   ,XEVT   ,ECM    ,XSTAT  ,XTRIG  ,XLCODE, XSELTP,
     +COSAVR ,COSTHR ,CTHREE ,CTHRPP ,CLSTRK ,RSHW   ,RTRK  ,
     +XTOF   ,DTFMIN ,DMINTP ,Z0AVR  ,XCON   ,ACOL  ,
     +PCON1X ,PCON1Y ,PCON1Z ,PPCON1 ,
     +ECON1X ,ECON1Y ,ECON1Z ,EECON1 ,XCONE1 ,
     +PCON2X ,PCON2Y ,PCON2Z ,PPCON2 ,
     +ECON2X ,ECON2Y ,ECON2Z ,EECON2 ,XCONE2 ,
     +PCON3X ,PCON3Y ,PCON3Z ,PPCON3 ,
     +ECON3X ,ECON3Y ,ECON3Z ,EECON3 ,XCONE3 ,
     +PTTRK  ,PTCLS  ,CEMIS  ,CPMIS  ,EFWDR  ,EFWDL  ,PTTRFD ,
     +XERROR ,XNUMBH ,XLEPFL ,XDETS1 ,XDETS2 ,XTRGS1 ,XTRGS2 ,
     +AFAIL  ,NCTCN1 ,NMUCN1 ,NCTCN2 ,NMUCN2 ,
     +XTPCNV ,PTPCNV ,XPVTX  ,RADPC  ,RMINPC ,DISTPC ,XYDPC  ,THDPC  ,
     +COPPC  ,AMSPC  ,DEDXP1 ,DEDXP2 ,XEPPC1 ,XEPPC2
* extra for MC
      REAL   XMCTAU,XMCGAM,XMCGAT,XMCDCM,XMCDCP,XDMCDM,XDMCDP,
     +XGMCOK,XGMCNO,XTMCNV,XMVTX ,PTMCNV,XDGMC1,XDGMC2,RESRV1,
     +PXMCTM,PYMCTM,PZMCTM,PPMCTM,PXMCTP,PYMCTP,PZMCTP,PPMCTP,
     +EXMCG1,EYMCG1,EZMCG1,EEMCG1,EXMCG2,EYMCG2,EZMCG2,EEMCG2,
     +PXMCDM,PYMCDM,PZMCDM,PPMCDM,PXMCDP,PYMCDP,PZMCDP,PPMCDP
*
*
      COMMON/LLNCTP/NFILTP,
     +XRUN   ,XEVT   ,ECM    ,XSTAT  ,XTRIG  ,XLCODE, XSELTP,
     +COSAVR ,COSTHR ,CTHREE ,CTHRPP ,CLSTRK ,RSHW   ,RTRK  ,
     +XTOF   ,DTFMIN ,DMINTP ,Z0AVR  ,XCON   ,ACOL  ,
     +PCON1X ,PCON1Y ,PCON1Z ,PPCON1 ,
     +ECON1X ,ECON1Y ,ECON1Z ,EECON1 ,XCONE1 ,
     +PCON2X ,PCON2Y ,PCON2Z ,PPCON2 ,
     +ECON2X ,ECON2Y ,ECON2Z ,EECON2 ,XCONE2 ,
     +PCON3X ,PCON3Y ,PCON3Z ,PPCON3 ,
     +ECON3X ,ECON3Y ,ECON3Z ,EECON3 ,XCONE3 ,
     +PTTRK  ,PTCLS  ,CEMIS  ,CPMIS  ,EFWDR  ,EFWDL  ,PTTRFD ,
     +XERROR ,XNUMBH ,XLEPFL ,XDETS1 ,XDETS2 ,XTRGS1 ,XTRGS2 ,
     +AFAIL  ,NCTCN1 ,NMUCN1 ,NCTCN2 ,NMUCN2 ,
     +XTPCNV ,PTPCNV ,XPVTX  ,RADPC  ,RMINPC ,DISTPC ,XYDPC  ,THDPC  ,
     +COPPC  ,AMSPC  ,DEDXP1 ,DEDXP2 ,XEPPC1 ,XEPPC2 ,
*. extra for MC
     +XMCTAU,XMCGAM,XMCGAT,XMCDCM,XMCDCP,XDMCDM,XDMCDP,
     +XGMCOK,XGMCNO,XTMCNV,XMVTX ,PTMCNV,XDGMC1,XDGMC2,RESRV1,
     +PXMCTM,PYMCTM,PZMCTM,PPMCTM,PXMCTP,PYMCTP,PZMCTP,PPMCTP,
     +EXMCG1,EYMCG1,EZMCG1,EEMCG1,EXMCG2,EYMCG2,EZMCG2,EEMCG2,
     +PXMCDM,PYMCDM,PZMCDM,PPMCDM,PXMCDP,PYMCDP,PZMCDP,PPMCDP
*
      SAVE  /LLNCTP/
      EQUIVALENCE (XNCTP(1),XRUN)
*
*--  This is the ntuple/common filled by the Bhabha classification
*--  subroutine: LLCBH
*
      INTEGER NBDATA,NBMONT,NNCBH
*-- NBDATA: number of entries in Bhabha ntuple for real data
*-- NBMONT: number of additional entries in Bhabha ntuple for monte carlo
*-- NNCBH:  total number of entries in Bhabha ntuple
      PARAMETER (NBDATA=94,NBMONT=0,NNCBH=NBDATA+NBMONT)
      REAL
     +  RUNBH,EVTBH,ECMBH,CODEBH,TRIGBH,NNORBH,NECABH,CLEAN
     +, ETOTE,SUMBIG,ZONE,ACOLB,SELBH
     +, BFREEA,BFREEB,BFREEC
     +, PXB1,PYB1,PZB1,PB1,QB1,NBCV1,FBCJ1,COSTB1,POINB1
     +, PXB2,PYB2,PZB2,PB2,QB2,NBCV2,FBCJ2,COSTB2,POINB2
     +, EXB1,EYB1,EZB1,EB1,ERAWB1,NBLOB1,EFRAB1
     +, IDETB1,PHIB1,COSEB1,COSPB1,PMULT1,NPRES1,POIEB1,FREEB1
     +, EXB2,EYB2,EZB2,EB2,ERAWB2,NBLOB2,EFRAB2
     +, IDETB2,PHIB2,COSEB2,COSPB2,PMULT2,NPRES2,POIEB2,FREEB2
     +, EXB3,EYB3,EZB3,EB3,ERAWB3,NBLOB3,EFRAB3
     +, IDETB3,PHIB3,COSEB3,COSPB3,PMULT3,NPRES3,POIEB3,FREEB3
     +, EXB4,EYB4,EZB4,EB4,ERAWB4,NBLOB4,EFRAB4
     +, IDETB4,PHIB4,COSEB4,COSPB4,PMULT4,NPRES4,POIEB4,FREEB4
      LOGICAL NFILBH
      INTEGER JZONE,BHSELE,ITRGBH
      COMMON/LLCCBH/ NFILBH,JZONE,BHSELE,ITRGBH
     +, RUNBH,EVTBH,ECMBH,CODEBH,TRIGBH,NNORBH,NECABH,CLEAN
     +, ETOTE,SUMBIG,ZONE,ACOLB,SELBH
     +, BFREEA,BFREEB,BFREEC
     +, PXB1,PYB1,PZB1,PB1,QB1,NBCV1,FBCJ1,COSTB1,POINB1
     +, PXB2,PYB2,PZB2,PB2,QB2,NBCV2,FBCJ2,COSTB2,POINB2
     +, EXB1,EYB1,EZB1,EB1,ERAWB1,NBLOB1,EFRAB1
     +, IDETB1,PHIB1,COSEB1,COSPB1,PMULT1,NPRES1,POIEB1,FREEB1
     +, EXB2,EYB2,EZB2,EB2,ERAWB2,NBLOB2,EFRAB2
     +, IDETB2,PHIB2,COSEB2,COSPB2,PMULT2,NPRES2,POIEB2,FREEB2
     +, EXB3,EYB3,EZB3,EB3,ERAWB3,NBLOB3,EFRAB3
     +, IDETB3,PHIB3,COSEB3,COSPB3,PMULT3,NPRES3,POIEB3,FREEB3
     +, EXB4,EYB4,EZB4,EB4,ERAWB4,NBLOB4,EFRAB4
     +, IDETB4,PHIB4,COSEB4,COSPB4,PMULT4,NPRES4,POIEB4,FREEB4
      SAVE  /LLCCBH/
*-- the actual ntuple is equivalenced to the REAL variables in the common
      REAL XNCBH(NNCBH)
      EQUIVALENCE (RUNBH,XNCBH(1))
*
*----------------------------------------------------------------------
*
*--  This is the ntuple/common filled by the e-pair classification
*--  subroutine: LLCEP
*
      INTEGER NEPDAT,NEPMTC,NNCEP
*-- NEPDAT: number of entries in e-pair ntuple for real data
*-- NEPMTC: number of additional entries in e-pair ntuple for monte carlo
*-- NNCEP:  total number of entries in e-pair ntuple
      PARAMETER (NEPDAT=67,NEPMTC=9,NNCEP=NEPDAT+NEPMTC)
      REAL
     +  RUNEP,EVTEP,ECMEP,XCLU,XTRA,XCIN,XELE
     + ,ESUM,PSUM,COSDIR,PHIDIR,EPSZ
     + ,ACOP,ACOLCL,ACOLEE
     + ,EC1,ER1,CO1,PHI1,PHC1,NBL1,PSM1,CPS1,PPS1
     + ,EC2,ER2,CO2,PHI2,PHC2,NBL2,PSM2,CPS2,PPS2
     + ,EC3,ER3,CO3,PHI3,PHC3,NBL3,PSM3,CPS3,PPS3
     + ,PQ1,CT1,PHT1,Z0E1,NHT1
     + ,PQ2,CT2,PHT2,Z0E2,NHT2
     + ,PQ3,CT3,PHT3,Z0E3,NHT3
     + ,COSEE,COSPP,FLAGS
     + ,CODEEP,TRIGEP,PTRIEP,DSTAT1,DSTAT2,TSTAT1,TSTAT2
     + ,V4X1,V4Y1,V4Z1
     + ,V4X2,V4Y2,V4Z2
     + ,V4X3,V4Y3,V4Z3
      LOGICAL NFILEP
      COMMON/LLNCEP/ NFILEP,
     +  RUNEP,EVTEP,ECMEP,XCLU,XTRA,XCIN,XELE
     + ,ESUM,PSUM,COSDIR,PHIDIR,EPSZ
     + ,ACOP,ACOLCL,ACOLEE
     + ,EC1,ER1,CO1,PHI1,PHC1,NBL1,PSM1,CPS1,PPS1
     + ,EC2,ER2,CO2,PHI2,PHC2,NBL2,PSM2,CPS2,PPS2
     + ,EC3,ER3,CO3,PHI3,PHC3,NBL3,PSM3,CPS3,PPS3
     + ,PQ1,CT1,PHT1,Z0E1,NHT1
     + ,PQ2,CT2,PHT2,Z0E2,NHT2
     + ,PQ3,CT3,PHT3,Z0E3,NHT3
     + ,COSEE,COSPP,FLAGS
     + ,CODEEP,TRIGEP,PTRIEP,DSTAT1,DSTAT2,TSTAT1,TSTAT2
     + ,V4X1,V4Y1,V4Z1
     + ,V4X2,V4Y2,V4Z2
     + ,V4X3,V4Y3,V4Z3
      SAVE  /LLNCEP/
*-- the actual ntuple is equivalenced to the REAL variables in the common
      REAL XNCEP(NNCEP)
      EQUIVALENCE (RUNEP,XNCEP(1))
*
*----------------------------------------------------------------------
      EXTERNAL  LLBAT,LLNFIL
      EXTERNAL    BTEVSL,BTHEAD,BTJTFD,BTPRFD,BTMCTY,
     +            BTMTTY,BTBEAM,BTBEEX,BTBSMC,BTCLVX,
     +            BTCOD0,BTCSD0,BTDECL,BTDEC3,BTDLEN,
     +            BTDPFD,BTDSIG,BTFITT,BTFIT3,BTFMUL,
     +            BTGVFT,BTJNN,BTKAV2,BTSVTG,BTSVTX,
     +            BTUFIL,BTVXFD,BTVXTK,BTZFND,BTZSIG,
     +            BT3SIG
      EXTERNAL    GCE,GCEA,GCURES,GCUSEL,GCUTQC,GCUTQE,GCUTQH
      EXTERNAL    GRSNT,GRSTNX,GRSTCL,GRSTGI,GRSTRE,
     +            GRSTDC,GRSPLT,GRSPMT,GRSTXT,GRSFAT,
     +            GRSTAP,GRODCT,GRODEC,GRODFD,GRODHC,
     +            GRODMU,GRODPS,GRODSW,GRODTB,GRODVX,
     +            GRLOGO,GROHIG,GRARRO,GRBOX,GRBOX1,
     +            GRBOX2,GRCONE,GRCRCZ,GRCROS,GRELL,
     +            GRELL3,GRSTRU,GRGETT,GRPXPR
      EXTERNAL    HBOOK1,HBOOK2,HMINIM,HMAXIM,HPLSET,
     +            HPLOPT,HPLOT,HPLAX,HPLFUN,HPLINE,
     +            HTITLE,HFILL,HPLTAB,HDELET,HPLTIT,
     +            HPLZON,HPLEGO,
     +            ISPLCI,ISTXFP,ISTXAL,ISCHH,ISELNT,
     +            ITX,IPL,IFA,IPM,ISTXCI,ISMK,
     +            ICLRWK,ISFAIS,ISFACI,ISPMCI,ISCR
      EXTERNAL    IDPART,IDGCON,IDK0CT,IDLAID
      EXTERNAL    KUEXEC
      EXTERNAL    PPL3,PPM3,PTX3,PFA3,PSPKID,
     +            PSVWI,PPOST,PRES,PUWK,
     +            PSMK,PSMKSC,PSPMCI,PSLN,PSLWSC,
     +            PSPLCI,PSIS,PSISI,PSICI,
     +            PSTXAL,PSCHUP,PSTXFN,PSTXPR,PSTXCI,
     +            PSCHH,PSCHXP,PSCHSP
      EXTERNAL    ODNBLK,ODFBLK,ODDXBT,ODV0ZF,ODV0Z,
     +            ODCSHI,ODCSLD,ODCSPR,ODSIHI,ODTOSI,
     +            ODCTMA,ODCTRE,ODUNCZ,ODGBLK,ODPBLK,
     +            ODSMGL,ODPEVT,ODMOVE
      EXTERNAL    OUSWIM,OUPOLY,OUARCL,OUTCSZ,OUTCXY,
     +            OUXCYL,OUEXPO,OUUCSZ,OUKAV2,OUMOVE,
     +            OUDELM
      EXTERNAL PXPTC4,PXAKO4,PXJSP3,PXLSP3,PXDIAM,
     +         PXTTH3,PXLTH4,PXLUT3,PXLCL5,PXCONE,
     +         PXEEC4,PXFOX4,YKERN,YNJET,YYJET,
     +         YAXES,YASSO,YREAS,YTREE,PXJTR4,
     +         PXYCR4,PXJRZ4,PXJRC4,PXANG3,PXHEM4,PXZERV
      EXTERNAL RMAIL,REPORT,ROCHSE,ROCHPR,ROCHIN
      EXTERNAL SUBEAM,SUALL,SUHOTC,SUEBEA
      EXTERNAL WWSLCT,WWGETT,WWQQQQ,WWQQLN,WWQQTN,
     +         WWLNLN,WWJETS,WWTYPE,WWINFO,WWGETP,
     +         WWGCE ,WWJECP,WWSPRI,WWSPR ,WW2MAS,
     +         WW4MAS,WWPHOT,WWELID,WWMUID,WWISOL,
     +         WWFIT ,WWSELT,WWTPRT,WWJPRT,WWISO,WWJET,
     +         WWLECP,WWFSET,WWFGO,WWFRES,WWPRTF,WWLLCL,
     +         WWHEAD,WWQCUT,WWQCPR,WWLPAR,
     +         WWMT,WWGET,WWJEYI,WWJCHG,WW4FTY,WWANGL
      COMMON/CSUNIT/LUNINP,LUNPM,LUNFIL,LUNLOG,LUNMAP,LUNLIB,
     +                     ISTPM,ISTFIL,ISTLOG,ISTMAP,ISTLIB
      COMMON/COMIS/CS(25000)
      COMMON/PAWC/PAW(1)
      DIMENSION P(1)
      INTEGER ICOMIS
      SAVE ICOMIS
      DATA ICOMIS/0/
*
C.
C.    ------------------------------------------------------------------
C.
      KUVCUR=0
      IF(ICOMIS.NE.0)RETURN
      ICOMIS=1
      LUNPM =81
      LUNFIL=82
      LUNLOG=83
      LUNMAP=84
      LUNEDT=85
      CALL CSSETL(LUNPM,LUNFIL,LUNLOG,LUNMAP,LUNEDT)
      CALL CSINIT(25000)
*
      CALL CSCOM('GCLINK,GCBANK,RCLINE,RCREP,CRO,ROCHCU#',
     +            JDIGI,NZEBRA,CHLINE,CHREP,IRDATE,CHTRQU,P,P,P,P)
      CALL CSCOM('GRDATA,GRATTR,GRCUTS,GRJETS,GRLIDL,'//
     +           'GRMETC,GROD,GRODAT#',
     +            KWTYGR,IGRLN,GRTHMN,IJMODE,LIDE,
     +            CHMETA,IFODCD,NDGEO,P,P)
      CALL CSCOM('IDLAVR,IDELVR,IDMUVR,IDELCT,IDMUCT#',
     +            LMNID ,ELACC ,MUMAC ,ELSEL ,MUSEL ,P,P,P,P,P)
      CALL CSCOM('ODGIPA,ODCIPA,ODPIPA,OSEIPA,ODTIPA,'//
     +           'ODHIPA,ODMIPA,ODFIPA,ODVIPA,ODSIPA#',
     +            MIGNRL,MICTRK,MIPRES,MIECAL,MITOF,
     +            MIHCAL,MIMUON,MIFDET,MIVRTX,MIATRK)
      CALL CSCOM('ODGRPA,ODCRPA,ODPRPA,OSERPA,ODTRPA,'//
     +           'ODHRPA,ODMRPA,ODFRPA,ODVRPA,ODSRPA#',
     +            MRGNRL,MRCTRK,MRPRES,MRECAL,MRTOF,
     +            MRHCAL,MRMUON,MRFDET,MRVRTX,MRATRK)
      CALL CSCOM('ODSIPA,ODSRPA#',MISIPA,MISRPA,P,P,P,P,P,P,P,P)
      CALL CSCOM('BTTRAK,BTTRAC,BTJETR,BTJETI,BTPRIM,'//
     +           'BTPRII,BTFFDR,BTFFDI,BTFFCX,BTFFEC#',
     +            IODTRK,UNCZTL,PJET  ,IODJT ,XYZBT ,
     +            NXYZBT,BTYCUT,BTJTOP,BTTQAL,BTEQAL)
      CALL CSCOM('BTVTXR,BTVTXI,BT2V#',
     +            PVTX  ,NVTX  ,DL2V01,P,P,P,P,P,P,P)
      CALL CSCOM('WWTRKS,WWLEPT,WWJETZ,WWTQUA,WWEQUA,'//
     +           'WWHQUA,WWFQUA,WWPHOO,WW4QSE,WW2QSE#',
     +            NCT   ,JWWEMU,IRUJET,PTMIN ,EBRMIN,
     +            EHTMIN,EFEMIN,NBMAX ,NCMI4Q,NCMI2Q)
      CALL CSCOM('WWQLSE,WWQMSE,WWQESE,WWQTSE,WWQLTC,'//
     +           'WWELSE,WWMUSE,WWMUVR,WWPHO,WWPHAD#',
     +            IALGQL,RMINQM,RMINQE,IALGQT,NCQLTV,
     +            IELID ,IMUID ,IHCAL ,NWWPHO,PHAD)
      CALL CSCOM('WWSPRC#',
     +            IWWSPM,P,P,P,P,P,P,P,P,P)
*
* LL routines
*
      CALL CSCOM('LLNVET,LLCCMP,LLNCTP,LLCCBH,LLNCEP#', 
     +            NFILVE,BTOBEC,NFILTP,NFILBH,NFILEP,P,P,P,P,P) 
      CALL CSEXT('LLBAT,LLNFIL#',LLBAT,LLNFIL,P,P,P,P,P,P,P,P)    
*
* BT routines
*
      CALL CSEXT('BTEVSL.L,BTHEAD.I,BTJTFD,BTPRFD,BTMCTY.I,'//
     +           'BTMTTY.I,BTBEAM,BTBEEX,BTBSMC,BTCLVX#',
     +            BTEVSL,BTHEAD,BTJTFD,BTPRFD,BTMCTY,
     +            BTMTTY,BTBEAM,BTBEEX,BTBSMC,BTCLVX)
      CALL CSEXT('BTCOD0.R,BTCSD0.R,BTDECL,BTDEC3,BTDLEN,'//
     +           'BTDPFD,BTDSIG,BTFITT,BTFIT3,BTFMUL#',
     +            BTCOD0,BTCSD0,BTDECL,BTDEC3,BTDLEN,
     +            BTDPFD,BTDSIG,BTFITT,BTFIT3,BTFMUL)
      CALL CSEXT('BTGVFT,BTJNN,BTKAV2,BTSVTG.L,BTSVTX,'//
     +           'BTUFIL,BTVXFD,BTVXTK,BTZFND,BTZSIG#',
     +            BTGVFT,BTJNN,BTKAV2,BTSVTG,BTSVTX,
     +            BTUFIL,BTVXFD,BTVXTK,BTZFND,BTZSIG)
      CALL CSEXT('BT3SIG#',
     +            BT3SIG,P,P,P,P,P,P,P,P,P)
*
* GCE routines
*
      CALL CSEXT('GCE,GCEA,GCURES,GCUSEL,GCUTQC.L,'//
     +           'GCUTQE.L,GCUTQH.L#',
     +            GCE,GCEA,GCURES,GCUSEL,GCUTQC,GCUTQE,GCUTQH,P,P,P)
*
* GRope routines
*
      CALL CSEXT('GRSNT,GRSTNX.I,GRSTCL,GRSTGI.I,GRSTRE.I,'//
     +           'GRSTDC.I,GRSPLT,GRSPMT,GRSTXT,GRSFAT#',
     +            GRSNT,GRSTNX,GRSTCL,GRSTGI,GRSTRE,
     +            GRSTDC,GRSPLT,GRSPMT,GRSTXT,GRSFAT)
      CALL CSEXT('GRSTAP.I,GRODCT,GRODEC,GRODFD,GRODHC,'//
     +           'GRODMU,GRODPS,GRODSW,GRODTB,GRODVX#',
     +            GRSTAP,GRODCT,GRODEC,GRODFD,GRODHC,
     +            GRODMU,GRODPS,GRODSW,GRODTB,GRODVX)
      CALL CSEXT('GRLOGO,GROHIG,GRARRO,GRBOX,GRBOX1,'//
     +           'GRBOX2,GRCONE,GRCRCZ,GRCROS,GRELL#',
     +            GRLOGO,GROHIG,GRARRO,GRBOX,GRBOX1,
     +            GRBOX2,GRCONE,GRCRCZ,GRCROS,GRELL)
      CALL CSEXT('GRELL3,GRSTRU,GRGETT,GRPXPR#',
     +            GRELL3,GRSTRU,GRGETT,GRPXPR,P,P,P,P,P,P)
*
* HBOOK/HPLOT/HIGZ routines
*
      CALL CSEXT('HBOOK1,HBOOK2,HMINIM,HMAXIM,HPLSET,'//
     +           'HPLOPT,HPLOT,HPLAX,HPLFUN,HPLINE#',
     +            HBOOK1,HBOOK2,HMINIM,HMAXIM,HPLSET,
     +            HPLOPT,HPLOT,HPLAX,HPLFUN,HPLINE)
      CALL CSEXT('HTITLE,HFILL,HPLTAB,HDELET,HPLTIT,'//
     +           'HPLZON,HPLEGO#',
     +            HTITLE,HFILL,HPLTAB,HDELET,HPLTIT,
     +            HPLZON,HPLEGO,P,P,P)
      CALL CSEXT('ISPLCI,ISTXFP,ISTXAL,ISCHH,ISELNT,'//
     +           'ITX,IPL,IFA,IPM,ISTXCI#',
     +            ISPLCI,ISTXFP,ISTXAL,ISCHH,ISELNT,
     +            ITX,IPL,IFA,IPM,ISTXCI)
      CALL CSEXT('ICLRWK,ISFAIS,ISFACI,ISPMCI,ISMK,'//
     +           'ISCR#',
     +            ICLRWK,ISFAIS,ISFACI,ISPMCI,ISMK,ISCR,P,P,P,P)
*
* ID routines
*
      CALL CSEXT('IDPART,IDGCON,IDK0CT,IDLAID#',
     +            IDPART,IDGCON,IDK0CT,IDLAID,P,P,P,P,P,P)
*
* KU routines
*
      CALL CSEXT('KUEXEC#',KUEXEC,P,P,P,P,P,P,P,P,P)
*
* PHIGS routines
*
      CALL CSEXT('PPL3,PPM3,PTX3,PFA3,PSPKID,'//
     +           'PSVWI,PPOST,PRES,PUWK#',
     +            PPL3,PPM3,PTX3,PFA3,PSPKID,
     +            PSVWI,PPOST,PRES,PUWK,P)
      CALL CSEXT('PSMK,PSMKSC,PSPMCI,PSLN,PSLWSC,'//
     +           'PSPLCI,PSIS,PSISI,PSICI#',
     +            PSMK,PSMKSC,PSPMCI,PSLN,PSLWSC,
     +            PSPLCI,PSIS,PSISI,PSICI,P)
      CALL CSEXT('PSTXAL,PSCHUP,PSTXFN,PSTXPR,PSTXCI,'//
     +           'PSCHH,PSCHXP,PSCHSP#',
     +            PSTXAL,PSCHUP,PSTXFN,PSTXPR,PSTXCI,
     +            PSCHH,PSCHXP,PSCHSP,P,P)
*
* OD routines
*
      CALL CSEXT('ODNBLK,ODFBLK,ODDXBT,ODV0ZF,ODV0Z,'//
     +           'ODCSHI,ODCSLD,ODCSPR,ODSIHI,ODTOSI#',
     +            ODNBLK,ODFBLK,ODDXBT,ODV0ZF,ODV0Z,
     +            ODCSHI,ODCSLD,ODCSPR,ODSIHI,ODTOSI)
      CALL CSEXT('ODCTMA,ODCTRE,ODUNCZ,ODGBLK.L,ODPBLK,'//
     +           'ODPEVT,ODMOVE,ODSMGL#',
     +            ODCTMA,ODCTRE,ODUNCZ,ODGBLK,ODPBLK,
     +            ODPEVT,ODMOVE,ODSMGL,P,P)
*
* OU routines
*
      CALL CSEXT('OUSWIM,OUPOLY,OUARCL,OUTCSZ,OUTCXY,'//
     +           'OUXCYL,OUEXPO,OUUCSZ,OUKAV2,OUMOVE#',
     +            OUSWIM,OUPOLY,OUARCL,OUTCSZ,OUTCXY,
     +            OUXCYL,OUEXPO,OUUCSZ,OUKAV2,OUMOVE)
      CALL CSEXT('OUDELM#',
     +            OUDELM,P,P,P,P,P,P,P,P,P)
*
* PX routines
*
      CALL CSEXT('PXPTC4,PXAKO4,PXJSP3,PXLSP3,PXDIAM,'//
     +           'PXTTH3,PXLTH4,PXLUT3,PXLCL5,PXCONE#',
     +            PXPTC4,PXAKO4,PXJSP3,PXLSP3,PXDIAM,
     +            PXTTH3,PXLTH4,PXLUT3,PXLCL5,PXCONE)
      CALL CSEXT('PXEEC4,PXFOX4,YKERN,YNJET,YYJET,'//
     +           'YAXES,YASSO,YREAS,YTREE,PXJTR4#',
     +            PXEEC4,PXFOX4,YKERN,YNJET,YYJET,
     +            YAXES,YASSO,YREAS,YTREE,PXJTR4)
      CALL CSEXT('PXYCR4,PXJRX4,PXJRC4,PXANG3,PXHEM4,PXZERV#',
     +            PXYCR4,PXJRX4,PXJRC4,PXANG3,PXHEM4,PXZERV,P,P,P,P)
*
* ROPE routines
*
      CALL CSEXT('RMAIL,REPORT,ROCHSE,ROCHIN,ROCHPR#',
     +            RMAIL,REPORT,ROCHSE,ROCHIN,ROCHPR,P,P,P,P,P)
*
* SU routines
*
      CALL CSEXT('SUALL,SUBEAM,SUHOTC,SUEBEA#',
     +            SUALL,SUBEAM,SUHOTC,SUEBEA,P,P,P,P,P,P)
*
* WW routines
*
      CALL CSEXT('WWSLCT,WWGETT,WWQQQQ,WWQQLN,WWQQTN,'//
     +           'WWLNLN,WWJETS,WWTYPE,WWINFO,WWGETP#',
     +            WWSLCT,WWGETT,WWQQQQ,WWQQLN,WWQQTN,
     +            WWLNLN,WWJETS,WWTYPE,WWINFO,WWGETP)
      CALL CSEXT('WWGCE,WWJECP,WWSPRI,WWSPR,WW2MAS,'//
     +           'WW4MAS,WWPHOT,WWELID,WWMUID,WWISOL#',
     +            WWGCE ,WWJECP,WWSPRI,WWSPR ,WW2MAS,
     +            WW4MAS,WWPHOT,WWELID,WWMUID,WWISOL)
      CALL CSEXT('WWFIT,WWSELT,WWTPRT,WWJPRT,WWISO,'//
     +           'WWJET,WWLECP,WWFSET,WWFGO,WWFRES#',
     +            WWFIT,WWSELT,WWTPRT,WWJPRT,WWISO,
     +            WWJET,WWLECP,WWFSET,WWFGO,WWFRES)
      CALL CSEXT('WWPRTF,WWLLCL,WWHEAD,WWQCUT,WWQCPR,'//
     +           'WWLPAR,WWMT,WWGET,WWJEYI,WWJCHG#',
     +            WWPRTF,WWLLCL,WWHEAD,WWQCUT,WWQCPR,
     +            WWLPAR,WWMT,WWGET,WWJEYI,WWJCHG)
      CALL CSEXT('WW4FTY,WWANGL#',
     +            WW4FTY,WWANGL,P,P,P,P,P,P,P,P)
*
      RETURN
*
      END
CDECK  ID>, GRHEAD.
      SUBROUTINE GRHEAD
*.
*...GRHEAD   Draw picture header.
*.
*. SEQUENCE  : CRO    DECLAR GRDATA GRODAT ODPAR  PENUM  RCREP  ROBANK
*. SEQUENCE  : ROCPAR ROPAR
*. CALLS     : DATIMH GRLOGO GROBL2 GRSFAT GRSNT  GRSPLT GRSTCL GRSTXT
*. CALLS     : ODFBLK PFA    PPOST  PSCHUP PSPKID PSTXAL PSVWI  PTX
*. CALLS     : REPORT VZERO
*. CALLED    : GRDRAW GROSET
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : P.M.Watkins
*. VERSION   : 0.00
*. CREATED   : 14-Oct-87
*. LAST MOD  : 11-Apr-00
*.
*. Modification Log.
*. 11-Apr-00  N.K.Watson Mods for y2k dates and energies.
*.  3-Apr-94  D.R.Ward   SET/BACK
*.  5-Aug-93  D.R.Ward   Add SI to detector status display
*. 26-Mar-92  J.Banks    Make GOSIP/GPHIGS text readable
*. 11-Mar-92  J.N.Banks  Mods for GOSIP
*.  4-Nov-91  D.R.Ward   Allow turning off header info
*.  3-Jun-91  D.R.Ward   Add SI to detector status display
*. 24-May-90  D.R.Ward   Add filename to picture (VAX)
*. 17-May-90  I.WingerterFix bug in FDET energy calculation
*. 17-Apr-90  D.R.Ward   Add Userid and date to display (VAX only)
*. 21-Mar-90  D.R.Ward   Modify status display
*. 12-Dec-89  D.R.Ward   Check MAGF bank for field value
*. 29-Nov-89  D.R.Ward   Display status info
*. 20-Sep-89  D.R.Ward   Get Bz from SCRA bank if possible.
*. 18-Sep-89  D.R.Ward   Changes for OD305
*. 17-Aug-89  D.R.Ward   Allow for 6 digit event numbers just in case
*.  3-Aug-89  D.R.Ward   Tinker again
*. 17-Jul-89  D.R.Ward   Tinker again
*. 14-Jul-89  D.R.Ward   Call GRLOGO
*. 12-Jul-89  D.R.Ward   Add still more info to header
*.  3-May-89  D.R.Ward   Add more info to header
*.  4-Apr-89  J.LeMouel  Use attributes management package
*.  8-Feb-89  D.R.Ward   Modify date/time
*.  7-Feb-89  D.R.Ward   Handle segment opening
*. 18-Aug-88  D.R.Ward   Call PSTXAL (stop overwriting problem I hope)
*. 19-Feb-88  A.Buijs    Spell 'Event' correctly, add date and time.
*.
*.**********************************************************************
*.
      IMPLICIT NONE
*  DRAW HEADER FOR EVENT DISPLAY
*  ASSUMES +/- 900 CMS MAPPED ON TO SCREEN.
*     View index numbers
      INTEGER JVWIEV,JVWIAX,JVWIHD
      PARAMETER (JVWIEV=4,JVWIAX=2,JVWIHD=0)
      INTEGER JVWIV1,JVWIV2,JVWIV3
      PARAMETER (JVWIV1=4,JVWIV2=5,JVWIV3=3)
*
*     Transformation numbers
      INTEGER JTNREV,JTNRAX,JTNRHD
      PARAMETER (JTNREV=4,JTNRAX=5,JTNRHD=3)
*
*     Workstation types.  (MetaFile O/p)
      INTEGER KWTMFO
      PARAMETER (KWTMFO=10201)
*
*     KWTYPE (screen) set by data card/KUIP
*     MFSTAT tells whether Metafile open
*     COLOUR flags whether screen in colour or not
      INTEGER KWTYPE,MFSTAT
      LOGICAL COLOUR
*     Workstation IDs  (GRope, MetaFile, DZdoc etc.)
*             KWIDGR,KWIDMF, etc.
*     Connection  IDs  (GRope, MetaFile)
*             KONIGR,KONIMF
*
      INTEGER KWTYGR,KWTYDZ,KWTYKU,
     + KWIDGR,KWIDMF,KWIDDZ,KWIDLE,KWIDDX,KWIDSI,KWIDSW,KWIDTF,
     + KONIGR,KONIMF,
     + IPPERS
      REAL DPRP
      EQUIVALENCE (KWTYGR,KWTYPE)
      COMMON/GRDATA/KWTYGR,KWTYDZ,KWTYKU,
     +KWIDGR,KWIDMF,KWIDDZ,KWIDLE,KWIDDX,KWIDSI,KWIDSW,KWIDTF,
     +KONIGR,KONIMF,
     +MFSTAT,COLOUR,IPPERS,DPRP
      INTEGER      NUHMAX
      PARAMETER   (NUHMAX=64)
      INTEGER      IRDATE,IRTIME,IVGOPA,IRBEAM,IRINTR,
     +             LRIN  ,LROUT ,
     +             IREVNT,IRDEXP,IRDRUN,IRDEVT,IRDEBU,
     +             NUHEAD,IOHEAD,IUHEAD
      REAL         RUHEAD
      DIMENSION    RUHEAD(NUHMAX)
      COMMON/CRO/  IRDATE,IRTIME,IVGOPA,IRBEAM,IRINTR,
     +             LRIN  ,LROUT ,
     +             IREVNT,IRDEXP,IRDRUN,IRDEVT,IRDEBU,
     +             NUHEAD,IOHEAD(2),IUHEAD(NUHMAX)
      EQUIVALENCE (IUHEAD,RUHEAD)
      INTEGER      NHEADR
      REAL         RHEADR(NUHMAX)
      COMMON/RONHDE/NHEADR(NUHMAX)
      EQUIVALENCE (NHEADR,RHEADR)
C
C         Archive state
C
C   archive closed , archive opened
      INTEGER  PARCL  , PAROP
      PARAMETER (PARCL = 0 , PAROP  = 1)
C
C         Attribute identifier
C
      INTEGER PLN , PLWSC , PPLCI , PMK , PMKSC , PPMCI, PTXFN , PTXPR ,
     +PCHXP , PCHSP , PTXCI , PIS , PISI , PICI , PEDFG , PEDTY ,
     +PEWSC , PEDCI

      PARAMETER (PLN= 0, PLWSC= 1, PPLCI= 2, PMK= 3, PMKSC= 4, PPMCI= 5,
     +PTXFN= 6, PTXPR= 7, PCHXP= 8, PCHSP= 9, PTXCI=10, PIS =11, PISI
     +=12, PICI =13, PEDFG=14, PEDTY=15, PEWSC=16, PEDCI=17)
C
C         Aspect source flag
C
C   bundled individual
      INTEGER  PBUNDL       , PINDIV
      PARAMETER (PBUNDL=0     , PINDIV =1)
C
C         Clear control flag
C
C   conditionally   always
      INTEGER  PCONDI  , PALWAY
      PARAMETER (PCONDI=0 , PALWAY = 1)
C
C         Clipping indicator
C
C   noclip    clip
      INTEGER  PNCLIP  , PCLIP
      PARAMETER (PNCLIP=0 , PCLIP  = 1)
C
C         Colour available
C
C   monochrome   colour
      INTEGER  PMONOC  , PCOLOR
      PARAMETER (PMONOC=0 , PCOLOR = 1)
C
C         Composition type
C
C    preconcatenate   postconcatenate   replace
      INTEGER   PCPRE  ,  PCPOST    , PCREPL
      PARAMETER ( PCPRE=0 ,  PCPOST=1    , PCREPL=2 )
C
C         Conflict resolution
C
C   maintain , abandon    , update
      INTEGER  PCRMNT  , PCRABA    , PCRUPD
      PARAMETER (PCRMNT=0 , PCRABA =1    , PCRUPD=2)
C
C         Deferral mode
C
C   ASAP    , BNIG     , BNIL  , ASTI     , WAIT
      INTEGER  PASAP    , PBNIG    , PBNIL  , PASTI    , PWAITD
      PARAMETER (PASAP =0  , PBNIG =1 , PBNIL =2 , PASTI =3 , PWAITD=4)
C
C         Device coordinate units
C
C   metres      other
      INTEGER  PMETRE    , POTHU
      PARAMETER (PMETRE=0  , POTHU  =1)
C
C         Display surface empty
C
C   notempty  , empty
      INTEGER  PNEMPT    , PEMPTY
      PARAMETER (PNEMPT=0  , PEMPTY =1)
C
C         Dynamic modification
C
C   IRG      IMM    CBS
      INTEGER  PIRG    , PIMM  , PCBS
      PARAMETER (PIRG  =0  , PIMM   =1  , PCBS  =2)
C
C         Echo switch
C
C   noecho       echo
      INTEGER  PNECHO     , PECHO
      PARAMETER (PNECHO=0   , PECHO  =1)
C
C       Edit mode
C
C    insert      replace
      INTEGER   PINSRT    , PREPLC
      PARAMETER ( PINSRT=0  , PREPLC=1 )
C
C       Element Type
C
      INTEGER PEALL , PENIL , PEPL3 , PEPL , PEPM3 , PEPM , PETX3 ,
     +PETX , PEATR3 , PEATR , PEFA3 , PEFA , PEFAS3 , PEFAS , PECA3 ,
     +PECA , PEGDP3 , PEGDP , PEPLI , PEPMI , PETXI , PEII , PEEDI ,
     +PELN , PELWSC , PEPLCI , PEMK , PEMKSC , PEPMCI , PETXFN ,
     +PETXPR , PECHXP , PECHSP , PETXCI , PECHH , PECHUP

      INTEGER PETXP , PETXAL , PEATCH , PEATCU , PEATP , PEATAL ,
     +PEANST , PEIS , PEISI , PEICI , PEEDFG , PEEDT , PEEWSC , PEEDCI ,
     +PEPA , PEPRPV , PEPARF , PEADS , PERES , PEIASF , PEHRID ,
     +PELMT3 , PELMT , PEGMT3 , PEGMT , PEMCV3 , PEMCV , PEMCLI ,
     +PERMCL , PEVWI , PEEXST , PELB , PEAP , PEGSE , PEPKID
C
      PARAMETER ( PEALL = 00, PENIL = 01, PEPL3 = 02, PEPL = 03, PEPM3 =
     +04, PEPM = 05, PETX3 = 06, PETX = 07, PEATR3= 08, PEATR = 09,
     +PEFA3 = 10, PEFA = 11, PEFAS3= 12, PEFAS = 13, PECA3 = 14, PECA =
     +15, PEGDP3= 16, PEGDP = 17, PEPLI = 18, PEPMI = 19, PETXI = 20,
     +PEII = 21, PEEDI = 22, PELN = 23, PELWSC= 24, PEPLCI= 25, PEMK =
     +26, PEMKSC= 27, PEPMCI= 28, PETXFN= 29, PETXPR= 30, PECHXP= 31,
     +PECHSP= 32, PETXCI= 33, PECHH = 34, PECHUP=35)

      PARAMETER ( PETXP = 36, PETXAL= 37, PEATCH= 38, PEATCU= 39, PEATP
     += 40, PEATAL= 41, PEANST= 42, PEIS = 43, PEISI = 44, PEICI = 45,
     +PEEDFG= 46, PEEDT = 47, PEEWSC= 48, PEEDCI= 49, PEPA = 50, PEPRPV=
     +51, PEPARF= 52, PEADS = 53, PERES = 54, PEIASF= 55, PEHRID= 56,
     +PELMT3= 57, PELMT = 58, PEGMT3= 59, PEGMT = 60, PEMCV3= 61, PEMCV
     += 62, PEMCLI= 63, PERMCL= 64, PEVWI = 65, PEEXST= 66, PELB = 67,
     +PEAP = 68, PEGSE = 69, PEPKID=70)
C
C       Search success indicator
C
C   failure    , success
      INTEGER  PFAIL     , PSUCC
      PARAMETER (PFAIL =0  , PSUCC =1 )
C
C       Input device status
C
C   none     , ok      , nopick  , nochoice
      INTEGER  PNONE     , POK     , PNPICK  , PNCHOI
      PARAMETER (PNONE =0  , POK  =1 , PNPICK=2 , PNCHOI= 2)
C
C       Interior style
C
C    hollow   , solid    , pattern  , hatch    , empty
      INTEGER   PHOLLO   , PSOLID   , PPATTR  , PHATCH   , PISEMP
      PARAMETER ( PHOLLO=0 , PSOLID=1 , PPATTR=2 , PHATCH=3 , PISEMP=4)
C
C       Input class
C
C   none   ,locator ,stroke  ,valuator,choice  ,pick ,
C   string
      INTEGER PNCLAS ,PLOCAT ,PSTROK ,PVALUA ,PCHOIC ,PPICK, PSTRIN ,
     +PEXPOS ,PRSIZE
      PARAMETER (PNCLAS =0,PLOCAT=1,PSTROK=2,PVALUA=3,PCHOIC=4,PPICK=5,
     +PSTRIN=6,PEXPOS=10,PRSIZE=11)
C
C       Modification mode
C
C   NIVE     , UWOR     , UQUM
      INTEGER  PNIVE     , PUWOR    , PUQUM
      PARAMETER (PNIVE =0  , PUWOR =1 , PUQUM =2)
C
C      Off/on switch for edge flag and error handling mode
C
C   off       on
      INTEGER  POFF     , PON      ,PACT
      PARAMETER (POFF =0  , PON   =1 ,PACT   =2)
C
C       Open - Structure Status
C
C    none       open
      INTEGER   PNONST    , POPNST
      PARAMETER ( PNONST=0  , POPNST=1 )
C
C       Operating mode
C
C   request    , sample , event
      INTEGER  PREQU     , PSAMPL , PEVENT
      PARAMETER (PREQU =0  , PSAMPL=1 , PEVENT=2)
C
C       Path order
C
C   top first  , bottom first
      INTEGER  PPOTOP     , PPOBOT
      PARAMETER (PPOTOP =0  , PPOBOT=1)
C
C       Presence of invalid values
C
C   absent     , present
      INTEGER  PABSNT     , PPRSNT
      PARAMETER (PABSNT=0   , PPRSNT=1)
C
C       Reference handling flag
C
C   delete     , keep
      INTEGER  PDELE     , PKEEP
      PARAMETER (PDELE =0  , PKEEP =1)
C
C       regeneration flag
C
C   postpone   , perform
      INTEGER  PPOSTP     , PPERFO
      PARAMETER (PPOSTP =0  , PPERFO=1)
C
C       relative input priority
C
C   higher     , lower
      INTEGER  PHIGHR     , PLOWER
      PARAMETER (PHIGHR =0  , PLOWER=1)
C
C       search direction
C
C   backward   , forward
      INTEGER  PBWD     , PFWD
      PARAMETER (PBWD =0  , PFWD  =1)
C
C       simultaneous events flag
C
C   nomore     , more
      INTEGER  PNMORE     , PMORE
      PARAMETER (PNMORE =0  , PMORE =1)
C
C       state of visual representation
C
C   correct    , deferred , simulated
      INTEGER  PVROK     , PVRDFR , PVRSIM
      PARAMETER (PVROK =0  , PVRDFR=1 , PVRSIM=2)
C
C       structure network source
C
C   CSS     , archive file
      INTEGER  PCSS     , PARCHV
      PARAMETER (PCSS =0  , PARCHV=1)
C
C       Structure State Value
C
C    STCL      STOP
      INTEGER   PSTCL    , PSTOP
      PARAMETER ( PSTCL=0  , PSTOP=1 )
C
C       structure status indicator
C
C   non-existent, empty  , non-empty
      INTEGER  PSNOEX      , PSEMPT  , PSNEMP
      PARAMETER (PSNOEX =0   , PSEMPT=1  , PSNEMP=2)
C
C
C        System State Value
C
C    PHCL      PHOP
      INTEGER   PPHCL    , PPHOP
      PARAMETER ( PPHCL=0  , PPHOP=1 )
C
C       text alignment horizontal
C
C   normal     , left , center  , right
      INTEGER  PAHNOR     , PALEFT , PACENT  , PARITE
      PARAMETER (PAHNOR =0  , PALEFT=1 , PACENT=2, PARITE=3)
C
C       text alignment vertical
C
C   normal   ,top    ,cap    ,half    ,base    ,bottom
      INTEGER  PAVNOR   ,PATOP   ,PACAP  ,PAHALF  ,PABASE  ,PABOTT
      PARAMETER (PAVNOR =0,PATOP =1,PACAP=2,PAHALF=3,PABASE=4,PABOTT=5)
C
C       text path
C
C   right     , left , up   , down
      INTEGER  PRIGHT     , PLEFT , PUP   , PDOWN
      PARAMETER (PRIGHT =0  , PLEFT =1 , PUP=2   , PDOWN=3)
C
C       text precision
C
C   string     , character , stroke
      INTEGER  PSTRP     , PCHARP , PSTRKP
      PARAMETER (PSTRP =0  , PCHARP=1 , PSTRKP=2)
C
C       type of returned values
C
C   set     , realized
      INTEGER  PSET     , PREALI
      PARAMETER (PSET =0  , PREALI=1)
C
C       update state
C
C   notpending , pending
      INTEGER  PNPEND     , PPEND
      PARAMETER (PNPEND =0  , PPEND =1)
C
C       vector/raster/other type
C
C   vector     , raster , other
      INTEGER  PVECTR     , PRASTR , POTHWK
      PARAMETER (PVECTR =0  , PRASTR=1 , POTHWK=2)
C
C    viewtype
C
C   parallel   , perspective
      INTEGER  PPARL     , PPERS
      PARAMETER (PPARL =0  , PPERS =1)
C
C       workstation category
C
C   OUTPUT     , INPUT , OUTIN   , MO   , MI
      INTEGER  POUTPT     , PINPUT , POUTIN  , PMO   , PMI
      PARAMETER (POUTPT =0  , PINPUT=1 , POUTIN=2, PMO=3 , PMI=4)
C
C   workstation dependency indicator
C
C   workstation independent, workstation dependent ,
      INTEGER  PWKI   , PWKD
      PARAMETER (PWKI = 0  , PWKD=1)
C
C       workstation state
C
C   closed     , open
      INTEGER  PWKCL     , PWKOP
      PARAMETER (PWKCL =0  , PWKOP =1)
C
C       list of GDP
C
C     attributes polyline  , polymarker, text  , interior , edge
      INTEGER  PPLBND    , PPMBND    , PTXBND  , PINBND   , PEDBND
      PARAMETER (PPLBND =0 , PPMBND=1  , PTXBND=2, PINBND=3 , PEDBND=4)
C
C   linetype
C
C   solid     , dash , dot    , dash-dot
      INTEGER  PLSOLI     , PLDASH , PLDOT    , PLDASD
      PARAMETER (PLSOLI =1  , PLDASH=2 , PLDOT=3  , PLDASD=4)
C
C       marker type
C               "."        "+"       "*"      "o"       "x"
      INTEGER  PPOINT     , PPLUS , PAST  , POMARK  , PXMARK
      PARAMETER (PPOINT =1  , PPLUS =2 , PAST=3 , POMARK=4, PXMARK=5)
C
C       annotation style
C   unconnected, lead line using current
C         polyline attributes
      INTEGER  PUNCON     , PLDLN
      PARAMETER (PUNCON =1  , PLDLN =2)
C
C       colour model
C
C   RGB     , CIE , HSV   , HLS
      INTEGER  PRGB     , PCIE , PHSV   , PHLS
      PARAMETER (PRGB =1  , PCIE  =2 , PHSV=3  , PHLS=4)
C
C       modelling clipping operator
C
C   replace      intersect
      INTEGER  PMCREP     , PMCINT
      PARAMETER (PMCREP =1  , PMCINT=2)
C
C       polyline/fill area control flag
C
C   polyline     fill area , fill area set
      INTEGER  PPLINE     , PFILLA , PFILAS
      PARAMETER (PPLINE =0  , PFILLA=1 , PFILAS=2)
C
C       Additional in the FORTRAN binding, to be used with
C       PHIGS inquiry functions that return both Current
C   and Requested values
C
C   current      requested
      INTEGER  PCURVL     , PRQSVL
      PARAMETER (PCURVL =0  , PRQSVL=1)
C
C
C        Names used for Error Handling
C
      INTEGER  EOPPH    ,ECLPH     ,EOPWK  ,ECLWK     ,ERST
      INTEGER  EUWK    ,ESDUS     ,EMSG  ,EPL3     ,EPL
      INTEGER  EPM3    ,EPM       ,ETX3  ,ETX     ,EATR3
      INTEGER  EATR    ,EFA3      ,EFA  ,EFAS3     ,EFAS
      INTEGER  ECA3    ,ECA       ,EGDP3  ,EGDP     ,ESPLI
      INTEGER  ESPMI    ,ESTXI     ,ESII  ,ESEDI     ,ESLN
      INTEGER  ESLWSC    ,ESPLCI    ,ESMK  ,ESMKSC    ,ESPMCI
      INTEGER  ESTXFN    ,ESTXPR    ,ESCHXP  ,ESCHSP    ,ESTXCI
      INTEGER  ESCHH    ,ESCHUP    ,ESTXP  ,ESTXAL    ,ESATCH
      INTEGER  ESATCU    ,ESATP     ,ESATAL  ,ESANS     ,ESIS
      INTEGER  ESISI    ,ESICI     ,ESEDFG  ,ESEDT     ,ESEWSC
      INTEGER  ESEDCI    ,ESPA      ,ESPRPV  ,ESPARF    ,EADS
      INTEGER  ERES    ,ESIASF    ,ESPLR  ,ESPMR     ,ESTXR
      INTEGER  ESIR    ,ESEDR     ,ESPAR  ,ESCR     ,ESHLFT
      INTEGER  ESIVFT    ,ESCMD     ,ESHRID  ,ESHRM     ,ESLMT3
      INTEGER  ESLMT    ,ESGMT3    ,ESGMT  ,ESMCV3    ,ESMCV
      INTEGER  ESMCLI    ,ERMCV     ,ESVWI  ,ESVWR3    ,ESVWR
      INTEGER  ESVTIP    ,ESWKW3    ,ESWKW  ,ESWKV3    ,ESWKV
      INTEGER  EOPST    ,ECLST     ,EEXST  ,ELB     ,EAP
      INTEGER  EGSE    ,ESEDM     ,ECELST  ,ESEP     ,EOSEP
      INTEGER  ESEPLB    ,EDEL      ,EDELRA  ,EDELLB    ,EEMST
      INTEGER  EDST    ,EDSN      ,EDAS  ,ECSTID    ,ECSTRF
      INTEGER  ECSTIR    ,EPOST     ,EUPOST  ,EUPAST    ,EOPARF
      INTEGER  ECLARF    ,EARST     ,EARSN  ,EARAST    ,ESCNRS
      INTEGER  ERSID    ,EREST     ,ERESN  ,ERAST     ,ERANST
      INTEGER  ERDEST    ,EDSTAR    ,EDSNAR  ,EDASAR    ,ESPKID
      INTEGER  ESPKFT    ,EINLC3    ,EINLC  ,EINSK3    ,EINSK
      INTEGER  EINVL3    ,EINVL     ,EINCH3    ,EINCH     ,EINPK3
      INTEGER  EINPK     ,EINST3    ,EINST     ,ESLCM     ,ESSKM
      INTEGER  ESVLM     ,ESCHM     ,ESPKM     ,ESSTM     ,ERQLC3
      INTEGER  ERQLC     ,ERQSK3    ,ERQSK     ,ERQVL     ,ERQCH
      INTEGER  ERQPK     ,ERQST     ,ESMLC3    ,ESMLC     ,ESMSK3
      INTEGER  ESMSK     ,ESMVL     ,ESMCH     ,ESMPK     ,ESMST
      INTEGER  EWAIT     ,EFLUSH    ,EGTLC3    ,EGTLC     ,EGTSK3
      INTEGER  EGTSK     ,EGTVL     ,EGTCH     ,EGTPK     ,EGTST
      INTEGER  EWITM     ,EGTITM    ,ERDITM    ,EIITM     ,ESERHM
      INTEGER  EUREC     ,EPREC     ,EESC
C
      PARAMETER (EOPPH =000,ECLPH =001,EOPWK =002,ECLWK =003,ERST  =004)
      PARAMETER (EUWK  =005,ESDUS =006,EMSG  =007,EPL3 =008,EPL   =009)
      PARAMETER (EPM3  =010,EPM   =011,ETX3  =012,ETX =013,EATR3 =014)
      PARAMETER (EATR  =015,EFA3  =016,EFA   =017,EFAS3 =018,EFAS  =019)
      PARAMETER (ECA3  =020,ECA   =021,EGDP3 =022,EGDP =023,ESPLI =024)
      PARAMETER (ESPMI =025,ESTXI =026,ESII  =027,ESEDI =028,ESLN  =029)
      PARAMETER (ESLWSC=030,ESPLCI=031,ESMK  =032,ESMKSC=033,ESPMCI=034)
      PARAMETER (ESTXFN=035,ESTXPR=036,ESCHXP=037,ESCHSP=038,ESTXCI=039)
      PARAMETER (ESCHH =040,ESCHUP=041,ESTXP =042,ESTXAL=043,ESATCH=044)
      PARAMETER (ESATCU=045,ESATP =046,ESATAL=047,ESANS =048,ESIS  =049)
      PARAMETER (ESISI =050,ESICI =051,ESEDFG=052,ESEDT =053,ESEWSC=054)
      PARAMETER (ESEDCI=055,ESPA  =056,ESPRPV=057,ESPARF=058,EADS  =059)
      PARAMETER (ERES  =060,ESIASF=061,ESPLR =062,ESPMR =063,ESTXR =064)
      PARAMETER (ESIR  =065,ESEDR =066,ESPAR =067,ESCR =068,ESHLFT=069)
      PARAMETER (ESIVFT=070,ESCMD =071,ESHRID=072,ESHRM =073,ESLMT3=074)
      PARAMETER (ESLMT =075,ESGMT3=076,ESGMT =077,ESMCV3=078,ESMCV =079)
      PARAMETER (ESMCLI=080,ERMCV =081,ESVWI =082,ESVWR3=083,ESVWR =084)
      PARAMETER (ESVTIP=085,ESWKW3=086,ESWKW =087,ESWKV3=088,ESWKV =089)
      PARAMETER (EOPST =090,ECLST =091,EEXST =092,ELB =093,EAP   =094)
      PARAMETER (EGSE  =095,ESEDM =096,ECELST=097,ESEP =098,EOSEP =099)
      PARAMETER (ESEPLB=100,EDEL  =101,EDELRA=102,EDELLB=103,EEMST =104)
      PARAMETER (EDST  =105,EDSN  =106,EDAS  =107,ECSTID=108,ECSTRF=109)
      PARAMETER (ECSTIR=110,EPOST =111,EUPOST=112,EUPAST=113,EOPARF=114)
      PARAMETER (ECLARF=115,EARST =116,EARSN =117,EARAST=118,ESCNRS=119)
      PARAMETER (ERSID =120,EREST =121,ERESN =122,ERAST =123,ERANST=124)
      PARAMETER (ERDEST=125,EDSTAR=126,EDSNAR=127,EDASAR=128,ESPKID=129)
      PARAMETER (ESPKFT=130,EINLC3=131,EINLC =132,EINSK3=133,EINSK =134)
      PARAMETER (EINVL3=135,EINVL =136,EINCH3=137,EINCH =138,EINPK3=139)
      PARAMETER (EINPK =140,EINST3=141,EINST =142,ESLCM =143,ESSKM =144)
      PARAMETER (ESVLM =145,ESCHM =146,ESPKM =147,ESSTM =148,ERQLC3=149)
      PARAMETER (ERQLC =150,ERQSK3=151,ERQSK =152,ERQVL =153,ERQCH =154)
      PARAMETER (ERQPK =155,ERQST =156,ESMLC3=157,ESMLC =158,ESMSK3=159)
      PARAMETER (ESMSK =160,ESMVL =161,ESMCH =162,ESMPK =163,ESMST =164)
      PARAMETER (EWAIT =165,EFLUSH=166,EGTLC3=167,EGTLC =168,EGTSK3=169)
      PARAMETER (EGTSK =170,EGTVL =171,EGTCH =172,EGTPK =173,EGTST= 174)
      PARAMETER (EWITM =175,EGTITM=176,ERDITM=177,EIITM =178,ESERHM=179)
      PARAMETER (EUREC =180,EPREC =181,EESC  =182)
C
C
C
C  INQUIRY
C
C         Structure status indicator
C
C   not exist , not empty
      INTEGER  PNOEXS    , PNOEMP
      PARAMETER (PNOEXS=0  , PNOEMP=2)
C
C
C=====================================================================
C================ EXTENTION ==========================================
C=====================================================================
C
C     Additional Names used for Extension Error Handling
C
      INTEGER    EXAMOD    ,EXGMOD    ,EXCHLG
      PARAMETER (EXAMOD=900,EXGMOD=901,EXCHLG=909)
      INTEGER    EXQMT     ,EXQMT3
      PARAMETER (EXQMT =902,EXQMT3=903)
      INTEGER    EXSTFT    ,EXRTRP
      PARAMETER (EXSTFT=904,EXRTRP=905)
      INTEGER    EXQTLA    ,EXQTMA    ,EXQTTA
      PARAMETER (EXQTLA=906,EXQTMA=907,EXQTTA=908)
C
C
C
      INTEGER    PXMCWC  ,PXWCMC
      PARAMETER (PXMCWC=0,PXWCMC=1)
C HLHSR identifiers
C
      INTEGER    PHIDEF  , PZBON   , PZBOFF
      PARAMETER (PHIDEF=0, PZBON=1 , PZBOFF=2)
*     Receive the content of DGEO, DHIT, DREC data cards - defining the
*     default drawing options for the run.
      INTEGER NDGEO,LDGEO,NDHIT,LDHIT,NDREC,LDREC,MODE,FSTPAS,IGRFIL,
     +IGRISI,IGRFED,IPVTX
      REAL    DSCALE
      LOGICAL GOFLAG
      LOGICAL LBOX,LHSTAT,LHAXES,LHHEAD,LHLOGO,LHSCAL,LHFILE,LHHEAB
      LOGICAL LAUTDZ,LAUTDX,LAUTTF,LAUTSI,LAUTSW,LAUTLE,LHXY,LHSIDE
      CHARACTER*4 CVIEW1,CVIEW2,CVIEW3
      COMMON/GRODAT/NDGEO,LDGEO(40),NDHIT,LDHIT(40),NDREC,LDREC(40),
     +GOFLAG,DSCALE,MODE,FSTPAS,LBOX,LHSTAT,IGRFIL,IGRISI,IGRFED,
     +LHAXES,LHHEAD,LHLOGO,LHSCAL,LHFILE,IPVTX,
     +LAUTDZ,LAUTDX,LAUTTF,LAUTSI,LAUTSW,LAUTLE,LHHEAB,LHXY,LHSIDE
      COMMON/GRODAC/CVIEW1,CVIEW2,CVIEW3
*
* DEFINES THE MODES IN WHICH THE PROGRAM CAN BE
* GENERAL 3D MODE
      INTEGER MTHDIM
      PARAMETER (MTHDIM = 300)
* 2D MODEs
      INTEGER MTWDIM
      PARAMETER (MTWDIM = 200)
      INTEGER NRODUM
      PARAMETER (NRODUM=50)
      INTEGER  IRODIV, IROCON, IROSTA
      COMMON/ROBANK/IRODIV,IROCON,IROSTA
      INTEGER IQND(NRODUM-29),  IQNS(NRODUM-28),
     +        IQNL(NRODUM-27), IQIDH(NRODUM-26), IQIDN(NRODUM-25)
      EQUIVALENCE (  IQ(1),  IQND(2),  IQNS(3),
     +             IQNL(4), IQIDH(5), IQIDN(6))
      INTEGER LQNEXT(NRODUM-22),  LQUP(NRODUM-23), LQORIG(NRODUM-24)
      EQUIVALENCE (LQ(3), LQORIG(1),  LQUP(2), LQNEXT(3))
      INTEGER       LREV ,LRCO ,LRST ,LHEAD,LAA  ,
     +        LEX  ,LUT  ,LDA  ,LCD  ,LEC  ,LHC  ,LMU  ,LFO  ,LDD  ,
     +        LOD  ,LLEP ,LMC  ,LCV  ,LCJ  ,LCZ  ,LCT  ,LDX  ,LCF  ,
     +        LCX  ,LSI  ,LCS  ,LCE  ,LCA  ,LTB  ,LPB  ,LEB  ,LPE  ,
     +        LEE  ,LEM  ,LHB  ,LHE  ,LHP  ,LHM  ,LMB  ,LME  ,LMM  ,
     +        LFD  ,LSW  ,LUS  ,
     +        LEXC ,LUTC ,LDAC ,LCDC ,LECC ,LHCC ,LMUC ,LFOC ,LDDC ,
     +        LODC ,LLEPC,LMCC ,LCVC ,LCJC ,LCZC ,LCTC ,LDXC ,LCFC ,
     +        LCXC ,LSIC ,LCSC ,LCEC ,LCAC ,LTBC ,LPBC ,LEBC ,LPEC ,
     +        LEEC ,LEMC ,LHBC ,LHEC ,LHPC ,LHMC ,LMBC ,LMECO,LMMC ,
     +        LFDC ,LSWC ,LUSC ,
     +        LEXS ,LUTS ,LDAS ,LCDS ,LECS ,LHCS ,LMUS ,LFOS ,LDDS ,
     +        LODS ,LLEPS,LMCS ,LCVS ,LCJS ,LCZS ,LCTS ,LDXS ,LCFS ,
     +        LCXS ,LSIS ,LCSS ,LCES ,LCAS ,LTBS ,LPBS ,LEBS ,LPES ,
     +        LEES ,LEMS ,LHBS ,LHES ,LHPS ,LHMS ,LMBS ,LMES ,LMMS ,
     +        LFDS ,LSWS ,LUSS ,LTE  ,LTEC ,LTES ,LZZ
      COMMON/RCLINK/LREV ,LRCO ,LRST ,LHEAD,LAA  ,
     +        LEX  ,LUT  ,LDA  ,LCD  ,LEC  ,LHC  ,LMU  ,LFO  ,LDD  ,
     +        LOD  ,LLEP ,LMC  ,LCV  ,LCJ  ,LCZ  ,LCT  ,LDX  ,LCF  ,
     +        LCX  ,LSI  ,LCS  ,LCE  ,LCA  ,LTB  ,LPB  ,LEB  ,LPE  ,
     +        LEE  ,LEM  ,LHB  ,LHE  ,LHP  ,LHM  ,LMB  ,LME  ,LMM  ,
     +        LFD  ,LSW  ,LUS  ,
     +        LEXC ,LUTC ,LDAC ,LCDC ,LECC ,LHCC ,LMUC ,LFOC ,LDDC ,
     +        LODC ,LLEPC,LMCC ,LCVC ,LCJC ,LCZC ,LCTC ,LDXC ,LCFC ,
     +        LCXC ,LSIC ,LCSC ,LCEC ,LCAC ,LTBC ,LPBC ,LEBC ,LPEC ,
     +        LEEC ,LEMC ,LHBC ,LHEC ,LHPC ,LHMC ,LMBC ,LMECO,LMMC ,
     +        LFDC ,LSWC ,LUSC ,
     +        LEXS ,LUTS ,LDAS ,LCDS ,LECS ,LHCS ,LMUS ,LFOS ,LDDS ,
     +        LODS ,LLEPS,LMCS ,LCVS ,LCJS ,LCZS ,LCTS ,LDXS ,LCFS ,
     +        LCXS ,LSIS ,LCSS ,LCES ,LCAS ,LTBS ,LPBS ,LEBS ,LPES ,
     +        LEES ,LEMS ,LHBS ,LHES ,LHPS ,LHMS ,LMBS ,LMES ,LMMS ,
     +        LFDS ,LSWS ,LUSS ,LTE  ,LTEC ,LTES ,LZZ
      INTEGER IQ,LQ,NZEBRA,IXSTOR,IXDIV,IXCONS,LMAIN,LR1,JCG
      INTEGER KWBANK,KWWORK,IWS
      REAL GVERSN,ZVERSN,FENDQ,WS,Q
C
      PARAMETER (KWBANK=69000,KWWORK=5200)
      COMMON/GCBANK/NZEBRA,GVERSN,ZVERSN,IXSTOR,IXDIV,IXCONS,FENDQ(16)
     +             ,LMAIN,LR1,WS(KWBANK)
      DIMENSION IQ(2),Q(2),LQ(8000),IWS(2)
      EQUIVALENCE (Q(1),IQ(1),LQ(9)),(LQ(1),LMAIN),(IWS(1),WS(1))
      EQUIVALENCE (JCG,JGSTAT)
      INTEGER       JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
C
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
C
      EQUIVALENCE (WS(1),IWS(1))
      INTEGER   IIDAT ,IIEXPT,IIRUN ,IIEVT ,IIBUN ,
     +          IIDETS,IITRGS,IITRWD,IITRWC,IITRWB,
     +          IITRWA,IIFITY,IIEVTY,IIEVT2,IIDATE,
     +          IITIME,IIPVER,IINCTR,IIECAL,IIHCAL,
     +          IINMUO,IINVTX,IIEBEA,IIFILL,IITAPE,
     +          IIRECI,IIPROD,IIRECO,IICDAT,IICTIM,
     +          IISULM,IIDAQS,IIFIDD,IIFIST,IIROST
      INTEGER   IITHRU,IICTHR,IIMEPX,IIMEPY,IIMEPZ,
     +          IINCT ,IISCT ,IINEB ,IISEB ,IINEE ,
     +          IISEE ,IINHT ,IISHT ,IINHPT,IISHPT,
     +          IISHS ,IISHPS,IISFE ,IISFK ,IIPRTA,
     +          IIPRTB,IIVERN,IIEVLG,IIDET1,IITRG1,
     +          IITRPU,IIPPSF,IIFXST
      INTEGER   IIPDSF,IIPDSR,IIPDSE,IIPDDF,IIPDDR,IIPDDE
      INTEGER   NLREV ,NSREV ,NDREV ,NIREV ,IOREV ,
     +          LLEX  ,LLUT  ,LLDA  ,LLCD  ,LLEC  ,
     +          LLHC  ,LLMU  ,LLFO  ,LLDD  ,LLOD
      INTEGER   NLEX  ,NSEX  ,NDEX  ,NIEX  ,IOEX  ,
     +          LLTRIG,LLMC  ,LLLEP ,
     +          IIFTRI,IIFMC ,IIFLEP
      INTEGER   NLUT  ,NSUT  ,NDUT  ,NIUT  ,IOUT  ,
     +          LLREHE
      INTEGER   NLDA  ,NSDA  ,NDDA  ,NIDA  ,IODA  ,
     +          LLCVRA,LLCJRA,LLCZRA,LLTBRA,LLPBRA,LLEBRA,LLPERA,
     +          LLEERA,LLHTRA,LLHSRA,LLHPRA,LLMBRA,LLMERA,LLFDRA,
     +          LLTRRA,LLTTRA,LLSCRA,LLFIRA,LLGNRA,LLSIRA,LLSWRA,
     +          LLTERA,
     +          IFCVRA,IFCJRA,IFCZRA,IFTBRA,IFPBRA,IFEBRA,IFPERA,
     +          IFEERA,IFHTRA,IFHSRA,IFHPRA,IFMBRA,IFMERA,IFFDRA,
     +          IFTRRA,IFTTRA,IFSCRA,IFFIRA,IFGNRA,IFSIRA,IFSWRA,
     +          IFTERA
      INTEGER   NLCD  ,NSCD  ,NDCD  ,NICD  ,IOCD  ,
     +          LLCV  ,LLCJ  ,LLCZ  ,LLCT  ,LLDX  ,LLCF  ,LLCX  ,
     +          LLSI  ,LLCS  ,
     +          IIFCV ,IIFCJ ,IIFCZ ,IIFCT ,IIFDX ,IIFCF ,IIFCX ,
     +          IIFSI ,IIFCS ,IIFCE ,IIFCA
      INTEGER   NLEC  ,NSEC  ,NDEC  ,NIEC  ,IOEC  ,
     +          LLTB  ,LLPB  ,LLEB  ,LLTE  ,LLPE  ,LLEE  ,LLEM ,
     +          IIFTB ,IIFPB ,IIFEB ,IIFTE ,IIFPE ,IIFEE ,IIFEM
      INTEGER   NLHC  ,NSHC  ,NDHC  ,NIHC  ,IOHC  ,
     +          LLHB  ,LLHE  ,LLHP  ,LLHM  ,
     +          IIFHB ,IIFHE ,IIFHP ,IIFHM
      INTEGER   NLMU  ,NSMU  ,NDMU  ,NIMU  ,IOMU  ,
     +          LLMB  ,LLME  ,LLMM  ,
     +          IIFMB ,IIFME ,IIFMM
      INTEGER   NLFO  ,NSFO  ,NDFO  ,NIFO  ,IOFO  ,
     +          LLFD  ,LLFDD ,LLSW  ,
     +          IIFFD ,IIFFDD,IIFSW
      INTEGER   NLOD  ,NSOD  ,NDOD  ,NIOD  ,IOOD  ,
     +          LLODGL,LLODCT,LLODPR,LLODEC,LLODUE,LLODHC,
     +          LLODMU,LLODFD,LLODVT,LLODAT,LLODUS,LLODSW,LLODTE
      PARAMETER(IIDAT =  1,IIEXPT=  2,IIRUN =  3,IIEVT =  4,IIBUN =  5,
     +          IIDETS=  6,IITRGS=  7,IITRWD=  8,IITRWC=  9,IITRWB= 10,
     +          IITRWA= 11,IIFITY= 12,IIEVTY= 13,IIEVT2= 14,IIDATE= 15,
     +          IITIME= 16,IIPVER= 17,IINCTR= 18,IIECAL= 19,IIHCAL= 20,
     +          IINMUO= 21,IINVTX= 22,IIEBEA= 23,IIFILL= 24,IITAPE= 25,
     +          IIRECI= 26,IIPROD= 27,IIRECO= 28,IICDAT= 29,IICTIM= 30,
     +          IISULM= 31,IIDAQS= 32,IIFIDD= 33,IIFIST= 34,IIROST= 35)
      PARAMETER(IITHRU= 36,IICTHR= 37,IIMEPX= 38,IIMEPY= 39,IIMEPZ= 40,
     +          IINCT = 41,IISCT = 42,IINEB = 43,IISEB = 44,IINEE = 45,
     +          IISEE = 46,IINHT = 47,IISHT = 48,IINHPT= 49,IISHPT= 50,
     +          IISHS = 51,IISHPS= 52,IISFE = 53,IISFK = 54,IIPRTA= 55,
     +          IIPRTB= 56,IIVERN= 57,IIEVLG= 58,IIDET1= 59,IITRG1= 60,
     +          IITRPU= 61,IIPDDF= 62,IIPPSF= 63,IIFXST= 64 )
      PARAMETER(IIPDSF= 59,IIPDSR= 60,IIPDSE= 61,IIPDDR= 63,
     +          IIPDDE= 64)
      PARAMETER(NLREV = 10,NSREV = 10,NDREV = 64,NIREV = 64,
     +          LLEX  =  1,LLUT  =  2,LLDA  =  3,LLCD  =  4,LLEC  =  5,
     +          LLHC  =  6,LLMU  =  7,LLFO  =  8,LLDD  =  9,LLOD  = 10)
      PARAMETER(NLEX  =  3,NSEX  =  3,NDEX  =  3,NIEX  =  3,IOEX  =  2,
     +          LLTRIG=  1,LLMC  =  2,LLLEP =  3,
     +          IIFTRI=  1,IIFMC =  2,IIFLEP=  3)
      PARAMETER(NLUT  =  1,NSUT  =  1,NDUT  =  0,NIUT  =  0,IOUT  =  2,
     +          LLREHE=  1)
      PARAMETER(NLDA  = 23,NSDA  = 23,NDDA  = 23,NIDA  = 23,IODA  =  2,
     +          LLCVRA=  1,LLCJRA=  2,LLCZRA=  3,LLTBRA=  4,LLPBRA=  5,
     +          LLEBRA=  6,LLPERA=  7,LLEERA=  8,LLHTRA=  9,LLHSRA= 10,
     +          LLHPRA= 11,LLMBRA= 12,LLMERA= 13,LLFDRA= 14,LLTRRA= 15,
     +          LLTTRA= 16,LLSCRA= 17,LLFIRA= 18,LLGNRA= 19,LLSIRA= 20,
     +          LLSWRA= 22,LLTERA= 23,
     +          IFCVRA=  1,IFCJRA=  2,IFCZRA=  3,IFTBRA=  4,IFPBRA=  5,
     +          IFEBRA=  6,IFPERA=  7,IFEERA=  8,IFHTRA=  9,IFHSRA= 10,
     +          IFHPRA= 11,IFMBRA= 12,IFMERA= 13,IFFDRA= 14,IFTRRA= 15,
     +          IFTTRA= 16,IFSCRA= 17,IFFIRA= 18,IFGNRA= 19,IFSIRA= 20,
     +          IFSWRA= 22,IFTERA= 23)
      PARAMETER(NLCD  =  9,NSCD  =  9,NDCD  = 11,NICD  = 11,IOCD  =  2,
     +          LLCV  =  1,LLCJ  =  2,LLCZ  =  3,LLCT  =  4,LLDX  =  5,
     +          LLCF  =  6,LLCX  =  7,LLSI  =  8,LLCS  =  9,
     +          IIFCV =  1,IIFCJ =  2,IIFCZ =  3,IIFCT =  4,IIFDX =  5,
     +          IIFCF =  6,IIFCX =  7,IIFSI =  8,IIFCS =  9,IIFCE = 10,
     +          IIFCA = 11)
      PARAMETER(NLEC  =  7,NSEC  =  7,NDEC  =  7,NIEC  =  7,IOEC  =  2,
     +          LLTB  =  1,LLPB  =  2,LLEB  =  3,LLPE  =  4,LLEE  =  5,
     +          LLEM  =  6,LLTE  =  7,
     +          IIFTB =  1,IIFPB =  2,IIFEB =  3,IIFPE =  4,IIFEE =  5,
     +          IIFEM =  6,IIFTE =  7)
      PARAMETER(NLHC  =  4,NSHC  =  4,NDHC  =  4,NIHC  =  4,IOHC  =  2,
     +          LLHB  =  1,LLHE  =  2,LLHP  =  3,LLHM  =  4,
     +          IIFHB =  1,IIFHE =  2,IIFHP =  3,IIFHM =  4)
      PARAMETER(NLMU  =  3,NSMU  =  3,NDMU  =  3,NIMU  =  3,IOMU  =  2,
     +          LLMB  =  1,LLME  =  2,LLMM  =  3,
     +          IIFMB =  1,IIFME =  2,IIFMM =  3)
      PARAMETER(NLFO  =  3,NSFO  =  3,NDFO  =  3,NIFO  =  3,IOFO  =  2,
     +          LLFD  =  1,LLFDD =  2,LLSW =  3,
     +          IIFFD =  1,IIFFDD=  2,IIFSW =  3)
      PARAMETER(NLOD  = 13,NSOD  = 13,NDOD  =  0,NIOD  =  0,IOOD  =  2,
     +          LLODGL=  1,LLODCT=  2,LLODPR=  3,LLODEC=  4,LLODUE=  5,
     +          LLODHC=  6,LLODMU=  7,LLODFD=  8,LLODVT=  9,LLODAT= 10,
     +          LLODUS= 11,LLODSW= 12,LLODTE= 13)
      COMMON/ROPAR/IOREV(2)
      INTEGER   NLRCO ,NSRCO ,NDRCO ,NIRCO ,IORCO ,
     +          LLEXC ,LLUTC ,LLDAC ,LLCDC ,LLECC ,
     +          LLHCC ,LLMUC ,LLFOC ,LLDDC ,LLODC ,
     +          IIFEXC,IIFUTC,IIFDAC,IIFCDC,IIFECC,
     +          IIFHCC,IIFMUC,IIFFOC,IIFDDC,IIFODC
      INTEGER   NLEXC ,NSEXC ,NDEXC ,NIEXC ,IOEXC ,
     +          LLTRIC,LLMCC ,LLLEPC,
     +          IIFTRC,IIFMCC,IIFLEC
      INTEGER   NLUTC ,NSUTC ,NDUTC ,NIUTC ,IOUTC ,
     +          LLREPO,LLGRHD,LLIOHD,LLSLCT,LLMSRN
      INTEGER   NLDAC ,NSDAC ,NDDAC ,NIDAC ,IODAC ,
     +          LLCVCT,LLCJCT,LLCZCT,LLTBCT,LLPBCT,LLEBCT,LLPECT,
     +          LLEECT,LLHTCT,LLHSCT,LLHPCT,LLMBCT,LLMECT,LLFDCT,
     +          LLTRCT,LLTTCT,LLSCCT,LLFICT,LLGNCT,LLSICT,LLDXCT,
     +          LLSWCT,LLTECT,
     +          IFCVCT,IFCJCT,IFCZCT,IFTBCT,IFPBCT,IFEBCT,IFPECT,
     +          IFEECT,IFHTCT,IFHSCT,IFHPCT,IFMBCT,IFMECT,IFFDCT,
     +          IFTRCT,IFTTCT,IFSCCT,IFFICT,IFGNCT,IFSICT,IFDXCT,
     +          IFSWCT,IFTECT
      INTEGER   NLCDC ,NSCDC ,NDCDC ,NICDC ,IOCDC ,
     +          LLCVC ,LLCJC ,LLCZC ,LLCTC ,LLDXC ,LLCFC ,LLCXC ,
     +          LLSIC ,LLCSC ,LLCEC ,LLCAC ,
     +          IIFCVC,IIFCJC,IIFCZC,IIFCTC,IIFDXC,IIFCFC,IIFCXC,
     +          IIFSIC,IIFCSC,IIFCEC,IIFCAC
      INTEGER   NLECC ,NSECC ,NDECC ,NIECC ,IOECC ,
     +          LLTBC ,LLPBC ,LLEBC ,LLPEC ,LLEEC ,LLEMC ,LLTEC,
     +          IIFTBC,IIFTEC,IIFPBC,IIFEBC,IIFPEC,IIFEEC,IIFEMC
      INTEGER   NLHCC ,NSHCC ,NDHCC ,NIHCC ,IOHCC ,
     +          LLHBC ,LLHEC ,LLHPC ,LLHMC ,
     +          IIFHBC,IIFHEC,IIFHPC,IIFHMC
      INTEGER   NLMUC ,NSMUC ,NDMUC ,NIMUC ,IOMUC ,
     +          LLMBC ,LLMECO,LLMMC ,
     +          IIFMBC,IIFMEC,IIFMMC
      INTEGER   NLFOC ,NSFOC ,NDFOC ,NIFOC ,IOFOC ,
     +          LLFDCR,LLFDCL,LLSWC,
     +          IIFFDC,IIFSWC
      INTEGER   NLODC ,NSODC ,NDODC ,NIODC ,IOODC ,
     +          LLODCB,
     +          IIFODG,IIFODT,IIFODP,IIFODE,IIFODU,IIFODH,
     +          IIFODM,IIFODF,IIFODV,IIFODA,IIFODX,IIFODW,
     +          IIFODD
      INTEGER   NLIOHD,NSIOHD,NDIOHD,NIIOHD,IOIOHD,
     +          LLIOII,LLIOCI,LLIODI,LLIODO,LLIODC,LLIOOV,
     +          LLIODS,LLIODD,LLIOCA,LLIOME,LLIOBK,LLIOHB,
     +          LLIODP,LLIODG,LLIOAO,LLIONO,LLIOMS,LLIOEO
      INTEGER   NLSLCT,NSSLCT,NDSLCT,NISLCT,IOSLCT,
     +          LLSLEV,LLSLRE,LLSLGE
      INTEGER   NLIOXX,NSIOXX,NDIOXX,NIIOXX,IOIOXX,
     +          JACTIV,JSELEC,JLUN  ,JLREC ,JFCHOP,
     +          JDCHOP,JFSTAT,JFNTYP,JACMOD,JFLAGS,
     +          JDEVIC,JFKEYS,JFNAME,JFJFIL
      INTEGER   NLSLEV,NSSLEV,NDSLEV,NISLEV,IOSLEV,
     +          JRUFST,JEVFST,JRULST,JEVLST
      INTEGER   NLSLRE,NSSLRE,NDSLRE,NISLRE,IOSLRE,
     +          IREFST,IRELST,IRESTP
      INTEGER   NLSLGE,NSSLGE,NDSLGE,NISLGE,IOSLGE,
     +          IRUGET,IEVGET
      INTEGER   NLGNCT,NSGNCT,NDGNCT,NIGNCT,IOGNCT,
     +          LLMAGF,LLBEAM,LLLIFE,LLBUTZ
      INTEGER   NLMAGF,NSMAGF,NDMAGF,NIMAGF,IOMAGF,
     +          IMEANB
      INTEGER   NLBEAM,NSBEAM,NDBEAM,NIBEAM,IOBEAM,
     +          IXBEAM,IYBEAM,IZBEAM,IDXBEA,IDYBEA,IDZBEA,
     +          IEXBEA,IEYBEA,IEZBEA
      INTEGER   NLBUTZ,NSBUTZ,NDBUTZ,NIBUTZ
      INTEGER   NLLIFE,NSLIFE,NDLIFE,NILIFE,IOLIFE
      PARAMETER(NLRCO = 10,NSRCO = 10,NDRCO = 10,NIRCO = 10,IORCO =  2,
     +          LLEXC =  1,LLUTC =  2,LLDAC =  3,LLCDC =  4,LLECC =  5,
     +          LLHCC =  6,LLMUC =  7,LLFOC =  8,LLDDC =  9,LLODC = 10,
     +          IIFEXC=  1,IIFUTC=  2,IIFDAC=  3,IIFCDC=  4,IIFECC=  5,
     +          IIFHCC=  6,IIFMUC=  7,IIFFOC=  8,IIFDDC=  9,IIFODC= 10)
      PARAMETER(NLEXC =  3,NSEXC =  3,NDEXC =  3,NIEXC =  3,IOEXC =  2,
     +          LLTRIC=  1,LLMCC =  2,LLLEPC=  3,
     +          IIFTRC=  1,IIFMCC=  2,IIFLEC=  3)
      PARAMETER(NLUTC =  5,NSUTC =  5,NDUTC =  0,NIUTC =  0,IOUTC =  0,
     +          LLREPO=  1,LLGRHD=  2,LLIOHD=  3,LLSLCT=  4,LLMSRN=  5)
      PARAMETER(NLDAC = 23,NSDAC = 23,NDDAC = 23,NIDAC = 23,IODAC =  2,
     +          LLCVCT=  1,LLCJCT=  2,LLCZCT=  3,LLTBCT=  4,LLPBCT=  5,
     +          LLEBCT=  6,LLPECT=  7,LLEECT=  8,LLHTCT=  9,LLHSCT= 10,
     +          LLHPCT= 11,LLMBCT= 12,LLMECT= 13,LLFDCT= 14,LLTRCT= 15,
     +          LLTTCT= 16,LLSCCT= 17,LLFICT= 18,LLGNCT= 19,LLSICT= 20,
     +          LLDXCT= 21,LLSWCT= 22,LLTECT= 23,
     +          IFCVCT=  1,IFCJCT=  2,IFCZCT=  3,IFTBCT=  4,IFPBCT=  5,
     +          IFEBCT=  6,IFPECT=  7,IFEECT=  8,IFHTCT=  9,IFHSCT= 10,
     +          IFHPCT= 11,IFMBCT= 12,IFMECT= 13,IFFDCT= 14,IFTRCT= 15,
     +          IFTTCT= 16,IFSCCT= 17,IFFICT= 18,IFGNCT= 19,IFSICT= 20,
     +          IFDXCT= 21,IFSWCT= 22,IFTECT= 23)
      PARAMETER(NLCDC = 11,NSCDC = 11,NDCDC = 11,NICDC = 11,IOCDC =  2,
     +          LLCVC =  1,LLCJC =  2,LLCZC =  3,LLCTC =  4,LLDXC =  5,
     +          LLCFC =  6,LLCXC =  7,LLSIC =  8,LLCSC =  9,LLCEC = 10,
     +          LLCAC = 11,
     +          IIFCVC=  1,IIFCJC=  2,IIFCZC=  3,IIFCTC=  4,IIFDXC=  5,
     +          IIFCFC=  6,IIFCXC=  7,IIFSIC=  8,IIFCSC=  9,IIFCEC= 10,
     +          IIFCAC= 11)
      PARAMETER(NLECC =  7,NSECC =  7,NDECC =  7,NIECC =  7,IOECC =  2,
     +          LLTBC =  1,LLPBC =  2,LLEBC =  3,LLPEC =  4,LLEEC =  5,
     +          LLEMC =  6,LLTEC =  7,
     +          IIFTBC=  1,IIFTEC=  2,IIFPBC=  3,IIFEBC=  4,IIFPEC=  5,
     +          IIFEEC=  6,IIFEMC=  7)
      PARAMETER(NLHCC =  4,NSHCC =  4,NDHCC =  4,NIHCC =  4,IOHCC =  2,
     +          LLHBC =  1,LLHEC =  2,LLHPC =  3,LLHMC =  4,
     +          IIFHBC=  1,IIFHEC=  2,IIFHPC=  3,IIFHMC=  4)
      PARAMETER(NLMUC =  3,NSMUC =  3,NDMUC =  3,NIMUC =  3,IOMUC =  2,
     +          LLMBC =  1,LLMECO=  2,LLMMC =  3,
     +          IIFMBC=  1,IIFMEC=  2,IIFMMC=  3)
      PARAMETER(NLFOC =  3,NSFOC =  3,NDFOC =  3,NIFOC =  3,IOFOC =  2,
     +          LLFDCR=  1,LLFDCL=  2,LLSWC =  3,
     +          IIFFDC=  1,           IIFSWC=  3)
      PARAMETER(NLODC =  1,NSODC =  1,NDODC = 13,NIODC = 13,IOODC =  2,
     +          LLODCB=  1,
     +          IIFODG=  1,IIFODT=  2,IIFODP=  3,IIFODE=  4,IIFODU= 5,
     +          IIFODH=  6,IIFODM=  7,IIFODF=  8,IIFODV=  9,IIFODA= 10,
     +          IIFODX= 11,IIFODW=12,IIFODD=13)
      INTEGER   LLIODT
      PARAMETER(NLIOHD= 19,NSIOHD= 19,NDIOHD=  0,NIIOHD=  0,IOIOHD=  2,
     +          LLIOII=  1,LLIOCI=  2,LLIODI=  3,LLIODO=  4,LLIODC=  5,
     +          LLIOOV=  6,LLIODS=  7,LLIODD=  8,LLIOCA=  9,LLIOME= 10,
     +          LLIOBK= 11,LLIOHB= 12,LLIODP= 13,LLIODG= 14,LLIOAO= 15,
     +          LLIONO= 16,LLIOMS= 17,LLIOEO= 18,LLIODT= 19)
      PARAMETER(NLSLCT=  3,NSSLCT=  3,NDSLCT=  0,NISLCT=  0,IOSLCT=  2,
     +          LLSLEV=  1,LLSLRE=  2,LLSLGE=  3)
      PARAMETER(NLIOXX=  0,NSIOXX=  0,NDIOXX= 42,NIIOXX= 42,IOIOXX=  2,
     +          JACTIV=  1,JSELEC=  2,JLUN  =  3,JLREC =  4,JFCHOP=  5,
     +          JDCHOP=  6,JFSTAT=  7,JFNTYP=  8,JACMOD=  9,JFLAGS= 10,
     +          JDEVIC= 11,JFKEYS= 12,JFNAME= 22,JFJFIL= 23)
      PARAMETER(NLSLEV=  0,NSSLEV=  0,NDSLEV=  4,NISLEV=  4,IOSLEV=  2,
     +          JRUFST=  1,JEVFST=  2,JRULST=  3,JEVLST=  4)
      PARAMETER(NLSLRE=  0,NSSLRE=  0,NDSLRE=  3,NISLRE=  3,IOSLRE=  2,
     +          IREFST=  1,IRELST=  2,IRESTP=  3)
      PARAMETER(NLSLGE=  0,NSSLGE=  0,NDSLGE=  2,NISLGE=  2,IOSLGE=  2,
     +          IRUGET=  1,IEVGET=  2)
      PARAMETER(NLGNCT=  4,NSGNCT=  4,NDGNCT=  0,NIGNCT=  0,IOGNCT=  2,
     +          LLMAGF=  1,LLBEAM=  2,LLLIFE=  3,LLBUTZ=  4)
      PARAMETER(NLMAGF=  0,NSMAGF=  0,NDMAGF=  1,NIMAGF=  0,IOMAGF=  3,
     +          IMEANB=  1)
      PARAMETER(NLBEAM=  0,NSBEAM=  0,NDBEAM=  9,NIBEAM=  0,IOBEAM=  3,
     +          IXBEAM=  1,IYBEAM=  2,IZBEAM=  3,
     +          IDXBEA=  4,IDYBEA=  5,IDZBEA=  6,
     +          IEXBEA=  7,IEYBEA=  8,IEZBEA=  9)
      PARAMETER(NLLIFE=  0,NSLIFE=  0,NDLIFE= 30,NILIFE=  0,IOLIFE=  3)
      PARAMETER(NLBUTZ=  0,NSBUTZ=  0,NDBUTZ= 66,NIBUTZ=  2)
* Number of blocks:
      INTEGER   NUMBLK
      PARAMETER(NUMBLK=13)
* General block:
      INTEGER NIBMAX,NRBMAX,NWBMAX
      INTEGER NIGNRL,NRGNRL,NWGNRL,MIGNRL,MRGNRL
      INTEGER JGDTYP,JGDSTY,JGIEXP,JGIRUN,JGIFIL,JGIEVT
      INTEGER JGPVER,JGITAP,JGIBUN,JGDETS,JGTRGS,JGEVTY
      INTEGER JGFITY,JGDATE,JGTIME,JGNCTR,JGNPRE,JGNECA
      INTEGER JGNTOF,JGNHCA,JGNMUO,JGNFDE,JGNVTX,JGNATR
      INTEGER JGTRM1,JGTRM2,JGTRM3,JGTRM4,JGNFCL,JGNTBR
      INTEGER JGNTBC,JGNJET,JGTPT1,JGTPT2,JGTPT3,JGTPT4
      INTEGER JGTPT5,JGTPT6,JGTPOB,JGTPE1,JGTPE2,JGTPE3
      INTEGER JGTPE4,JGTPE5,JGTPE6,JGTPH1,JGTPH2,JGTPH3
      INTEGER JGTPH4,JGTPH5,JGTPH6,JGTPM1,JGTPM2,JGTPMB
      INTEGER JGTPM5,JGTPM6,JGNCT ,JGNEB ,JGNEE ,JGNHBT
      INTEGER JGNHET,JGNHPT,JGTRES,JGDAQS,JGFIDD,JGFIST
      INTEGER JGROST,JGEVT2,JGLEPQ,JGCDP1,JGCDP2,JGCDP3
      INTEGER JGCDP4,JGCDP5,JGCDP6,JGCDP7,JGPTR1,JGPTR2
      INTEGER JGPTP1,JGPTP2,JGPTP3,JGPTP4,JGNSIW,JGTETR
      INTEGER JGTENC,JGTPD1,JGTPD2,JGTRPU
*
      INTEGER JGBZ,  JGEBEA,JGDEBE,JGEVIS,JGPOL1,JGPOL2
      INTEGER JGVX,  JGVY,  JGVZ,  JGVE11,JGVE21,JGVE22
      INTEGER JGVE31,JGVE32,JGVE33,JGVWXY,JGVW3D,JGSPHE
      INTEGER JGSPCT,JGSECA,JGSHCA,JGAPLA,JGCSPH,JGTHRU
      INTEGER JGOBLA,JGCTHR,JGT0AV,JGDT0A,JGDT0M,JGPSPH
      INTEGER JGPTHR,JGMEPX,JGMEPY,JGMEPZ,JGBX  ,JGBXCJ
      INTEGER JGBXCV,JGDECV,JGSCT ,JGSEB ,JGSEE ,JGSHBS
      INTEGER JGSHES,JGSHPS,JGSHBT,JGSHET,JGSHPT,JGSFE
      INTEGER JGSFK, JGLEPX,JGLEPY,JGBXDI,JGSTCN,JGOPMX
      INTEGER JGBTZ
* Charged track block:
      INTEGER NICTRK,NRCTRK,NWCTRK,MICTRK,MRCTRK
      INTEGER JCNHCV,JCNHCJ,JCNHCZ,JCFTYP,JCPTYP,JCIMCT
      INTEGER JCMMSK,JCIVT1,JCDXBT,JCVPAT,JCIPRE,JCIECA
      INTEGER JCITOF,JCIHCA,JCIMUO,JCIJET,JCCVHT,JCNHDE
      INTEGER JCNBEC,JCMLLH,JCSIH1,JCSIH2
*
      INTEGER JCPX,  JCPY,  JCPZ,  JCQ,   JCKAPP,JCPHI0
      INTEGER JCD0,  JCTLAM,JCZ0,  JCCHIR,JCCHI3,JCEM11
      INTEGER JCEM21,JCEM22,JCEM31,JCEM32,JCEM33,JCEM44
      INTEGER JCEM54,JCEM55,JCR1,  JCR2,  JCDEDX,JCDDED
      INTEGER JCWDE, JCWDMU,JCWDPI,JCWDK, JCWDP, JCTLEN
      INTEGER JCBETA,JCDBET,JCWPRE,JCWECA,JCWTOF,JCWHCA
      INTEGER JCWMUO,JCTHEC,JCDTHE,JCPHEC,JCDPHE,JCTHHC
      INTEGER JCDTHH,JCPHHC,JCDPHH,JCTHMU,JCDTHM,JCPHMU
      INTEGER JCDPHM,JCP,   JCDP,  JCEM41,JCEM42,JCEM43
      INTEGER JCEM51,JCEM52,JCEM53,JCRECA,JCRHCA,JCRMUO
      INTEGER JCTHDM,JCPHDM,JCVTMU,JCVPMU,JCTPMU,JCECON
      INTEGER JCECO2,JCEPZ, JCEPDZ,JCFMOM,JCDIST,JCRUNT
      INTEGER JCECOR,JCZ0CJ,JCTLCJ,JCQEFF,JCMWD1,JCMWD2
      INTEGER JCMWD3
* Presampler block:
      INTEGER NIPRES,NRPRES,NWPRES,MIPRES,MRPRES
      INTEGER JPSOUR,JPNCTR,JPIECA
*
      INTEGER JPMULT,JPDMUL,JPTHET,JPDTHE,JPPHI, JPDPHI
      INTEGER JPSIZU,JPSIZV,JPWECA
* Electro magnetic block:
      INTEGER NIECAL,NRECAL,NWECAL,MIECAL,MRECAL
      INTEGER JESOUR,JEITOF,JENBLO,JENB90,JENCTR,JENPRE
      INTEGER JENMUO,JEIHCA
*
      INTEGER JEE,   JEDE,  JEERAW,JEDERA,JETHET,JEDTHE
      INTEGER JEPHI, JEDPHI,JETHE1,JETHE2,JEPHI1,JEPHI2
      INTEGER JEFMOM,JECDST,JEFRMX,JEWHCA,JEFSMX,JEDFSB
      INTEGER JEINVM
* Time-of-Flight block:
      INTEGER NITOF,NRTOF,NWTOF   ,MITOF,MRTOF
      INTEGER JTFLAG
*
      INTEGER JTMULT,JTDMUL,JTTHET,JTDTHE,JTPHI, JTTOF
      INTEGER JTDTOF,JTDTHT
* Hadron Block:
      INTEGER NIHCAL,NRHCAL,NWHCAL,MIHCAL,MRHCAL
      INTEGER JHSOUR,JHNSTR,JHNTOW,JHTWBT,JHNCTR,JHNECA
      INTEGER JHNMUO,JHNL14,JHNL58,JHNL90
*
      INTEGER JHE,   JHDE,  JHTHET,JHDTHE,JHPHI, JHDPHI
      INTEGER JHTHE1,JHTHE2,JHPHI1,JHPHI2,JHFIN1,JHET
      INTEGER JHES,  JHEUNC,JHDYSC,JHDXSC
* Muon Block:
      INTEGER NIMUON,NRMUON,NWMUON,MIMUON,MRMUON
      INTEGER JMSOUR,JMNCTR,JMNPRE,JMIMCT,JMCASE,JMIECA
      INTEGER JMITOF,JMIHCA,JMKODE,JMNMBH,JMNEXZ,JMNEYZ
      INTEGER JMNHST,JMNSEX,JMNSEY,JMNDOF,JMHNBY,JMFITZ
*
      INTEGER JMX,   JMY,   JMZ,   JMDX,  JMDY,  JMDZ
      INTEGER JMCHMB,JMCIXZ,JMCIYZ,JMPHI, JMDPHI,JMMTHE
      INTEGER JMDCOT,JMCOXY,JMWECA,JMWTOF,JMWHCA,JMCHHB
      INTEGER JMJUNK
* Forward detector block:
      INTEGER NIFDET,NRFDET,NWFDET,MIFDET,MRFDET
      INTEGER JFSOUR,JFDTI1,JFDTI2,JFPAD1,JFPAD2
*
      INTEGER JFE,   JFDE,  JFTHET,JFDTHE,JFPHI, JFDPHI
      INTEGER JFEPRE,JFEFK, JFTFK, JFPHFK,JFBKM
* Vertex Block:
      INTEGER NIVRTX,NRVRTX,NWVRTX,MIVRTX,MRVRTX
      INTEGER JVTYPE,JVALGO,JVNCTR
*
      INTEGER JVCSRP,JVD0,  JVFLEN,JVSD0, JVCSVP,JVDXY
      INTEGER JVDZ,  JVPSC2,JVMEE, JVMPP, JVMPRP,JVMPPR
* Alias track block:
      INTEGER NIATRK,NRATRK,NWATRK,MIATRK,MRATRK
      INTEGER JAIVT1,JAIVT2,JAICTR
*
      INTEGER JAPX,  JAPY,  JAPZ,  JAQ,   JAKAPP,JAPHI0
      INTEGER JAD0,  JATLAM,JAZ0,  JACHIR,JACHIZ,JAEM11
      INTEGER JAEM21,JAEM22,JAEM31,JAEM32,JAEM33,JAEM44
      INTEGER JAEM54,JAEM55,JAVX,  JAVY,  JAVZ
* Silicon tungsten calorimeter block:
      INTEGER NISIW, NRSIW, NWSIW, MISIW, MRSIW
      INTEGER JSSOUR
*
      INTEGER JSE   ,JSTHET,JSPHI ,JSR   ,JSDR  ,JSLSHD
* Detector Tile Endcap block (only integers so far)
      INTEGER NIDTE, NRDTE, NWDTE, MIDTE, MRDTE
      INTEGER JDITH, JDIPH, JDICAP, JDIADC, JDITD0, JDITDW, JDNOTP
*
* Detector masks:
      INTEGER MSKCV, MSKCJ, MSKCZ, MSKCD, MSKEB, MSKEE, MSKPB
      INTEGER MSKPE, MSKTB, MSKEC, MSKHB, MSKHE, MSKHP, MSKHC
      INTEGER MSKMB, MSKME, MSKMU, MSKFD, MSKSW
*
* The following are now the COMMON blocks which contain the
* offsets. They can be CHANGED, now.
* General Block:
      COMMON/ODGIPA/MIGNRL,
     + JGDTYP,JGDSTY,JGIEXP,JGIRUN,JGIFIL,JGIEVT,
     + JGPVER,JGITAP,JGIBUN,JGDETS,JGTRGS,JGEVTY,
     + JGFITY,JGDATE,JGTIME,JGNCTR,JGNPRE,JGNECA,
     + JGNTOF,JGNHCA,JGNMUO,JGNFDE,JGNVTX,JGNATR,
     + JGTRM1,JGTRM2,JGTRM3,JGTRM4,JGNFCL,JGNTBR,
     + JGNTBC,JGNJET,JGTPT1,JGTPT2,JGTPT3,JGTPT4,
     + JGTPT5,JGTPT6,JGTPOB,JGTPE1,JGTPE2,JGTPE3,
     + JGTPE4,JGTPE5,JGTPE6,JGTPH1,JGTPH2,JGTPH3,
     + JGTPH4,JGTPH5,JGTPH6,JGTPM1,JGTPM2,JGTPMB,
     + JGTPM5,JGTPM6,JGNCT ,JGNEB ,JGNEE ,JGNHBT,
     + JGNHET,JGNHPT,JGTRES,JGDAQS,JGFIDD,JGFIST,
     + JGROST,JGEVT2,JGLEPQ,JGCDP1,JGCDP2,JGCDP3,
     + JGCDP4,JGCDP5,JGCDP6,JGCDP7,JGPTR1,JGPTR2,
     + JGPTP1,JGPTP2,JGPTP3,JGPTP4,JGNSIW,JGTETR,
     + JGTENC,JGTPD1,JGTPD2,JGTRPU
      COMMON/ODGRPA/MRGNRL,
     + JGBZ  ,JGEBEA,JGDEBE,JGEVIS,JGPOL1,JGPOL2,
     + JGVX  ,JGVY  ,JGVZ  ,JGVE11,JGVE21,JGVE22,
     + JGVE31,JGVE32,JGVE33,JGVWXY,JGVW3D,JGSPHE,
     + JGSPCT,JGSECA,JGSHCA,JGAPLA,JGCSPH,JGTHRU,
     + JGOBLA,JGCTHR,JGT0AV,JGDT0A,JGDT0M,JGPSPH,
     + JGPTHR,JGMEPX,JGMEPY,JGMEPZ,JGBX  ,JGBXCJ,
     + JGBXCV,JGDECV,JGSCT ,JGSEB ,JGSEE ,JGSHBS,
     + JGSHES,JGSHPS,JGSHBT,JGSHET,JGSHPT,JGSFE ,
     + JGSFK ,JGLEPX,JGLEPY,JGBXDI,JGSTCN,JGOPMX,
     + JGBTZ
      PARAMETER(NIGNRL=88,NRGNRL=55,NWGNRL=88)
      INTEGER IGIPAR(NIGNRL),IGRPAR(NRGNRL)
      EQUIVALENCE(IGIPAR(1),JGDTYP),(IGRPAR(1),JGBZ)
      SAVE /ODGIPA/,/ODGRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Charged track block:
      COMMON /ODCIPA/MICTRK,
     + JCNHCV,JCNHCJ,JCNHCZ,JCFTYP,JCPTYP,JCIMCT,
     + JCMMSK,JCIVT1,JCDXBT,JCVPAT,JCIPRE,JCIECA,
     + JCITOF,JCIHCA,JCIMUO,JCIJET,JCCVHT,JCNHDE,
     + JCNBEC,JCMLLH,JCSIH1,JCSIH2
      COMMON /ODCRPA/MRCTRK,
     + JCPX  ,JCPY  ,JCPZ  ,JCQ   ,JCKAPP,JCPHI0,
     + JCD0  ,JCTLAM,JCZ0  ,JCCHIR,JCCHI3,JCEM11,
     + JCEM21,JCEM22,JCEM31,JCEM32,JCEM33,JCEM44,
     + JCEM54,JCEM55,JCR1  ,JCR2  ,JCDEDX,JCDDED,
     + JCWDE ,JCWDMU,JCWDPI,JCWDK ,JCWDP ,JCTLEN,
     + JCBETA,JCDBET,JCWPRE,JCWECA,JCWTOF,JCWHCA,
     + JCWMUO,JCTHEC,JCDTHE,JCPHEC,JCDPHE,JCTHHC,
     + JCDTHH,JCPHHC,JCDPHH,JCTHMU,JCDTHM,JCPHMU,
     + JCDPHM,JCP   ,JCDP  ,JCEM41,JCEM42,JCEM43,
     + JCEM51,JCEM52,JCEM53,JCRECA,JCRHCA,JCRMUO,
     + JCTHDM,JCPHDM,JCVTMU,JCVPMU,JCTPMU,JCECON,
     + JCECO2,JCEPZ ,JCEPDZ,JCFMOM,JCDIST,JCRUNT,
     + JCECOR,JCZ0CJ,JCTLCJ,JCQEFF,JCMWD1,JCMWD2,
     + JCMWD3
      PARAMETER(NICTRK=22,NRCTRK=79,NWCTRK=79)
      INTEGER ICIPAR(NICTRK),ICRPAR(NRCTRK)
      EQUIVALENCE(ICIPAR(1),JCNHCV),(ICRPAR(1),JCPX)
      SAVE /ODCIPA/,/ODCRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Presampler block:
      COMMON /ODPIPA/MIPRES,
     + JPSOUR,JPNCTR,JPIECA
      COMMON /ODPRPA/MRPRES,
     + JPMULT,JPDMUL,JPTHET,JPDTHE,JPPHI ,JPDPHI,
     + JPSIZU,JPSIZV,JPWECA
      PARAMETER(NIPRES=3,NRPRES=9,NWPRES=9)
      INTEGER IPIPAR(NIPRES),IPRPAR(NRPRES)
      EQUIVALENCE(IPIPAR(1),JPSOUR),(IPRPAR(1),JPMULT)
      SAVE /ODPIPA/,/ODPRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Electromagnetic Block:
      COMMON /ODEIPA/MIECAL,
     + JESOUR,JEITOF,JENBLO,JENB90,JENCTR,JENPRE,
     + JENMUO,JEIHCA
      COMMON /ODERPA/MRECAL,
     + JEE   ,JEDE  ,JEERAW,JEDERA,JETHET,JEDTHE,
     + JEPHI ,JEDPHI,JETHE1,JETHE2,JEPHI1,JEPHI2,
     + JEFMOM,JECDST,JEFRMX,JEWHCA,JEFSMX,JEDFSB,
     + JEINVM
      PARAMETER(NIECAL=8,NRECAL=19,NWECAL=19)
      INTEGER IEIPAR(NIECAL),IERPAR(NRECAL)
      EQUIVALENCE(IEIPAR(1),JESOUR),(IERPAR(1),JEE)
      SAVE /ODEIPA/,/ODERPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Time-of-Flight block:
      COMMON /ODTIPA/MITOF,
     + JTFLAG
      COMMON /ODTRPA/MRTOF,
     + JTMULT,JTDMUL,JTTHET,JTDTHE,JTPHI ,  JTTOF ,
     + JTDTOF,JTDTHT
      PARAMETER(NITOF=1,NRTOF=8,NWTOF=8)
      INTEGER ITIPAR(NITOF),ITRPAR(NRTOF)
      EQUIVALENCE(ITIPAR(1),JTFLAG),(ITRPAR(1),JTMULT)
      SAVE /ODTIPA/,/ODTRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Hadron calorimeter Block:
      COMMON /ODHIPA/MIHCAL,
     + JHSOUR,JHNSTR,JHNTOW,JHTWBT,JHNCTR,JHNECA,
     + JHNMUO,JHNL14,JHNL58,JHNL90
      COMMON /ODHRPA/MRHCAL,
     + JHE   ,JHDE  ,JHTHET,JHDTHE,JHPHI ,JHDPHI,
     + JHTHE1,JHTHE2,JHPHI1,JHPHI2,JHFIN1,JHET  ,
     + JHES  ,JHEUNC,JHDYSC,JHDXSC
      PARAMETER(NIHCAL=10,NRHCAL=16,NWHCAL=16)
      INTEGER IHIPAR(NIHCAL),IHRPAR(NRHCAL)
      EQUIVALENCE(IHIPAR(1),JHSOUR),(IHRPAR(1),JHE)
      SAVE /ODHIPA/,/ODHRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Muon Block:
      COMMON /ODMIPA/ MIMUON,
     + JMSOUR,JMNCTR,JMNPRE,JMIMCT,JMCASE,JMIECA,
     + JMITOF,JMIHCA,JMKODE,JMNMBH,JMNEXZ,JMNEYZ,
     + JMNHST,JMNSEX,JMNSEY,JMNDOF,JMHNBY,JMFITZ
      COMMON /ODMRPA/ MRMUON,
     + JMX   ,JMY   ,JMZ   ,JMDX  ,JMDY  ,JMDZ  ,
     + JMCHMB,JMCIXZ,JMCIYZ,JMPHI ,JMDPHI,JMMTHE,
     + JMDCOT,JMCOXY,JMWECA,JMWTOF,JMWHCA,JMCHHB,
     + JMJUNK
      PARAMETER(NIMUON=18,NRMUON=19,NWMUON=19)
      INTEGER IMIPAR(NIMUON),IMRPAR(NRMUON)
      EQUIVALENCE(IMIPAR(1),JMSOUR),(IMRPAR(1),JMX)
      SAVE /ODMIPA/,/ODMRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Forward detector block:
      COMMON /ODFIPA/ MIFDET,
     + JFSOUR,JFDTI1,JFDTI2,JFPAD1,JFPAD2
      COMMON /ODFRPA/ MRFDET,
     + JFE   ,JFDE  ,JFTHET,JFDTHE,JFPHI ,JFDPHI,
     + JFEPRE,JFEFK ,JFTFK ,JFPHFK,JFBKM
      PARAMETER(NIFDET= 5, NRFDET=11,NWFDET=11)
      INTEGER IFIPAR(NIFDET),IFRPAR(NRFDET)
      EQUIVALENCE(IFIPAR(1),JFSOUR),(IFRPAR(1),JFE)
      SAVE /ODFIPA/,/ODFRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Vertex Block:
      COMMON /ODVIPA/ MIVRTX,
     + JVTYPE,JVALGO,JVNCTR
      COMMON /ODVRPA/ MRVRTX,
     + JVCSRP,JVD0  ,JVFLEN,JVSD0 ,JVCSVP,JVDXY ,
     + JVDZ  ,JVPSC2,JVMEE ,JVMPP ,JVMPRP,JVMPPR
      PARAMETER(NIVRTX=3,NRVRTX=12,NWVRTX=12)
      INTEGER IVIPAR(NIVRTX),IVRPAR(NRVRTX)
      EQUIVALENCE(IVIPAR(1),JVTYPE),(IVRPAR(1),JVCSRP)
      SAVE /ODVIPA/,/ODVRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Alias track block:
      COMMON /ODAIPA/ MIATRK,
     + JAIVT1,JAIVT2,JAICTR
      COMMON /ODARPA/ MRATRK,
     + JAPX  ,JAPY  ,JAPZ  ,JAQ   ,JAKAPP,JAPHI0,
     + JAD0  ,JATLAM,JAZ0  ,JACHIR,JACHIZ,JAEM11,
     + JAEM21,JAEM22,JAEM31,JAEM32,JAEM33,JAEM44,
     + JAEM54,JAEM55,JAVX  ,JAVY  ,JAVZ
      PARAMETER(NIATRK=3,NRATRK=23,NWATRK=23)
      INTEGER IAIPAR(NIATRK),IARPAR(NRATRK)
      EQUIVALENCE(IAIPAR(1),JAIVT1),(IARPAR(1),JAPX)
      SAVE /ODAIPA/,/ODARPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Silicon tungsten calorimeter block:
      COMMON /ODSIPA/ MISIW,
     + JSSOUR
      COMMON /ODSRPA/ MRSIW,
     + JSE   ,JSTHET,JSPHI ,JSR   ,JSDR  ,JSLSHD
      PARAMETER(NISIW= 1, NRSIW= 6,NWSIW= 6)
      INTEGER ISIPAR(NISIW),ISRPAR(NRSIW)
      EQUIVALENCE(ISIPAR(1),JSSOUR),(ISRPAR(1),JSE)
      SAVE /ODSIPA/,/ODSRPA/
* Don't forget to update NIBMAX and NRBMAX!!
* Detector Tile Endcap block (only integers so far)
      COMMON /ODDIPA/ MIDTE,
     + JDITH, JDIPH, JDICAP, JDIADC, JDITD0, JDITDW, JDNOTP
      PARAMETER(NIDTE= 7, NRDTE= 0, NWDTE= 7)
* This reserves the variable name but avoids the 'unused' warnings
      PARAMETER(MRDTE= 0)
      INTEGER IDIPAR(NIDTE)
      EQUIVALENCE(IDIPAR(1),JDITH)
      SAVE /ODDIPA/
* Largest possible block dimensions:
      PARAMETER(NIBMAX=88,NRBMAX=79,NWBMAX=88)
* Detector masks:
      PARAMETER(
     + MSKCV=    1,MSKCJ=    2,MSKCZ=    4,
     + MSKCD=MSKCV+MSKCJ+MSKCZ,
     + MSKTB=    8,MSKPB=   16,MSKPE=   32,MSKEB=  128,MSKEE=  256,
     + MSKEC=MSKTB+MSKPB+MSKPE+MSKEB+MSKEE,
     + MSKHB=  512,MSKHE= 1024,MSKHP= 2048,
     + MSKHC=MSKHB+MSKHE+MSKHP,
     + MSKMB= 8192,MSKME= 16384,
     + MSKMU=MSKMB+MSKME,MSKFD=65536,MSKSW=524288)
* Link to ODCS, ODSI and ODCE banks from ODGNRL
      INTEGER LLODCS,LLODCE,LLODSI,LLODSL,LLODTR
      PARAMETER    (LLODCS=1,LLODCE=2,LLODSI=3,LLODSL=4,LLODTR=5)
      CHARACTER*132 CHREP
      COMMON/RCREP/CHREP
      INTEGER        NTRAIN,NBUNCH,IFIBUN,IROBUN,ITRAIN, IETRAI,IPTRAI
      REAL           RBUNTZ(8,8),ROBTZ
      LOGICAL        LBUNMO,LFIBUT,LFIBUS,LROBUT,LROBUS, LLEPVA
      COMMON /ROBUN/ NTRAIN,NBUNCH,IROBUN,IFIBUN,ITRAIN, IETRAI,IPTRAI,
     +               RBUNTZ,ROBTZ,
     +               LBUNMO,LFIBUT,LFIBUS,LROBUT,LROBUS, LLEPVA
*
      REAL RG(NRGNRL),RF(NRFDET),SUMEF,EVIS,EMISS,EBEAM, BZ,HFAX(5),HFAY
     +(5),AFAX(5),AFAY(5)
      INTEGER IG(NIGNRL),NIMOV,NRMOV,IF(NIFDET),I,JTIME
      INTEGER IFLAG,IHDSEG
      INTEGER IERROR,LSCRA,IDET,ITRG,LGNCT,LMAGF
      CHARACTER*80 REVT
      CHARACTER*4  CSTAT
      CHARACTER*2  CNAME(16)
      INTEGER  GRSTDC,GRSTRE,GRSTNX,GRSTGI,JBIT,JBYT
      EXTERNAL GRSTDC,GRSTRE,GRSTNX,GRSTGI,JBIT,JBYT
      DATA CNAME/'CV','CJ','CZ','TB','PB','EB','PE','EE','HT','HS', 'HP'
     +,'MB','ME','FD','SI','SW'/
      DATA HFAX/-880.,700.,700.,-880.,-880./
      DATA HFAY/ 760.,760.,890., 890., 760./
      DATA AFAX/-900.,900.,900.,-900.,-900./
      DATA AFAY/-900.,-900.,900.,900.,-900./
*
      IF(GRSTGI('Axes    ').NE.0) I=GRSTDC('Axes    ')
      IF(GRSTGI('Scale   ').NE.0) I=GRSTDC('Scale   ')
      IHDSEG=GRSTGI('Header  ')
      IF(IHDSEG.LE.0) THEN
         IHDSEG=GRSTNX('Header  ')
      ELSE
         IFLAG=GRSTRE(IHDSEG,'Header  ')
      ENDIF
      CALL PSVWI(JVWIHD)
      CALL GRSNT(JTNRHD)
      CALL PRES(1,2)
      CALL GRSFAT('Background     ',IERROR)
      CALL PFA(5,AFAX,AFAY)
*
*     gaudy backgrounds if requested
*
      CALL PSVWI(JVWIEV)
      CALL GRSNT(JTNREV)
      IF(LHXY) CALL GRBACK('XY')
      IF(LHSIDE) CALL GRBACK('SI')
      CALL PSVWI(JVWIHD)
      CALL GRSNT(JTNRHD)
*
*     draw a box into which the event will be drawn (optionally)
*
      CALL GRSPLT('HeaderLine     ',IERROR)
      IF(LHHEAB) THEN
         CALL GRSTXT('BigHeaderText  ',IERROR)
      ELSE
         CALL GRSTXT('HeaderText     ',IERROR)
      ENDIF
      IF(LBOX) THEN
         CALL GROBL2(-810.,-720.,450.,540.)
      ENDIF
*
      CALL PSPKID(1000)
      IF(.NOT.LHHEAD) GO TO 80
      IF(COLOUR) THEN
         CALL GRSFAT('HeaderBox      ',IERROR)
         CALL PFA(5,HFAX,HFAY)
      ENDIF
      CALL GROBL2(-880.,760.,700.,890.)
      CALL GROBL2(-881.,759.,699.,889.)
      CALL GROBL2(-879.,761.,701.,891.)
      CALL GROBL2(-882.,758.,698.,888.)
      CALL GROBL2(-878.,762.,702.,892.)
*  ARGUMENTS ARE XMIN,YMIN,  XMAX,YMAX
      CALL PSTXAL(PALEFT,PAVNOR)
      CALL PSCHUP(0.,1.)
      CALL VZERO(IG,NIGNRL)
      CALL VZERO(RG,NRGNRL)
      SUMEF = 0.
      IF(LQ(LOD-LLODGL).LE.0) GO TO 20
      CALL ODFBLK('GNRL',1,NIGNRL,IG,NIMOV,NRGNRL,RG,NRMOV)
      IF(NIMOV.LT.NIGNRL .OR. NRMOV.LT.NRGNRL) THEN
         CHREP='Not all GNRL words found: header data may be rubbish'
         CALL REPORT('GRHEAD',1,'W')
      ENDIF
      DO 10 I=1,IG(JGNFDE)
         CALL ODFBLK('FDET',I,NIFDET,IF,NIMOV,NRFDET,RF,NRMOV)
         IF(JBIT(IF(JFSOUR),5).EQ.1) SUMEF=SUMEF+RF(JFE)
   10 CONTINUE
   20 CONTINUE
      EBEAM = IUHEAD(IIEBEA)*0.001
      IF(EBEAM.GT.999. .OR. EBEAM.LT.0.) EBEAM=0.
      EVIS=RG(JGEVIS)
      EMISS=2.*EBEAM-EVIS
      IF(LQ(LOD-LLODGL).LE.0) THEN
         WRITE(REVT,1000,ERR=30) IUHEAD(IIRUN),IUHEAD(IIEVT),
     +   mod( IUHEAD(IIDATE),1 000 000),IUHEAD(IITIME)
      ELSE
         JTIME=IG(JGTIME)
         IF(JTIME.GE.1000000) JTIME=JTIME/100
         WRITE(REVT,1000,ERR=30) IG(JGIRUN),IG(JGIEVT),
     +   mod( IG(JGDATE),1 000 000),JTIME

      ENDIF
   30 IF(LHHEAB) THEN
         CALL PTX(-870.,840.,REVT(1:22))
      ELSE
         CALL PTX(-870.,850.,REVT)
      ENDIF
      IF(LHHEAB) THEN
         WRITE(REVT,1015,ERR=40) EBEAM,RG(JGVX),RG(JGVY), RG(JGVZ)
      ELSE
         WRITE(REVT,1010,ERR=40) EBEAM,EVIS,EMISS,RG(JGVX),RG(JGVY),
     +                           RG(JGVZ)
      ENDIF
   40 IF(LHHEAB) THEN
         CALL PTX(-870.,780.,REVT)
      ELSE
         CALL PTX(-870.,810.,REVT)
      ENDIF
* Get Mag field.  Could be in the GNRL block of the DST
      BZ=RG(JGBZ)
* Else it could be found in the MAGF bank (only for MC at present).
      IF(LDAC.GT.0) THEN
         LGNCT=LQ(LDAC-LLGNCT)
         IF(LGNCT.GT.0) THEN
            LMAGF=LQ(LGNCT-LLMAGF)
            IF(LMAGF.GT.0) THEN
               IF(Q(LMAGF+IMEANB).GT.0) BZ=Q(LMAGF+IMEANB)
            ENDIF
         ENDIF
      ENDIF
* OR (real data) Bz should be in LSCRA+3 in units 0.1G
      IF(LDA.GT.0) THEN
         LSCRA=LQ(LDA-LLSCRA)
         IF(LSCRA.GT.0) BZ=0.0001*IQ(LSCRA+3)
      ENDIF
      WRITE(REVT,1040,ERR=50)  BZ,IROBUN,NBUNCH,
     +    RG(JGTHRU),RG(JGAPLA),RG(JGOBLA),RG(JGSPHE)
   50 IF(.NOT.LHHEAB) CALL PTX(-870.,770.,REVT)
      CALL PSTXAL(PARITE,PAVNOR)
      IF(LHHEAB) THEN
         WRITE(REVT,1025,ERR=60) IG(JGNCTR),RG(JGSPCT),IG(JGNECA),
     +                           RG(JGSECA)
      ELSE
         WRITE(REVT,1020,ERR=60) IG(JGNCTR),RG(JGSPCT),IG(JGNECA),
     +                           RG(JGSECA),IG(JGNHCA),RG(JGSHCA)
      ENDIF
   60 IF(LHHEAB) THEN
         CALL PTX( 700.,840.,REVT(2:46))
      ELSE
         CALL PTX( 700.,850.,REVT(2:69))
      ENDIF
      IF(LHHEAB) THEN
         WRITE(REVT,1035,ERR=70) IG(JGNHCA),RG(JGSHCA),IG(JGNMUO),
     +                           IG(JGNFDE),SUMEF
      ELSE
         WRITE(REVT,1030,ERR=70) IG(JGNMUO),IG(JGNVTX),IG(JGNFDE),SUMEF
      ENDIF
   70 IF(LHHEAB) THEN
         CALL PTX( 700.,780.,REVT(2:34))
      ELSE
         CALL PTX( 700.,810.,REVT(2:49))
      ENDIF
   80 CONTINUE
   85 CONTINUE
*
*     Status info
*
      IF(.NOT.LHSTAT) GO TO 100
      CALL GRSPLT('HeaderLine     ',IERROR)
      CALL GRSTXT('StatusText     ',IERROR)
      CALL PSTXAL(PARITE,PAVNOR)
      CALL PTX(890.,680.,'Status')
      CALL PTX(890.,650.,'Det Tr')
      DO 90 I=1,16
         IDET=0
         ITRG=0
         IDET=JBYT(IQ(LREV+IIDETS),I*2-1,2)
         ITRG=JBYT(IQ(LREV+IITRGS),I*2-1,2)
         WRITE(CSTAT,'(2I2)') IDET,ITRG
         CALL PTX(890.,630.-25.*I,CNAME(I)//CSTAT)
   90 CONTINUE
*
  100 IF(LHLOGO) CALL GRLOGO(800.,800.,90.)
      CALL GRSTCL
      CALL PPOST(KWIDGR,IHDSEG,0)
      CALL GRAXES
      IF(MODE.EQ.MTHDIM) THEN
         CALL PPOST(KWIDGR,GRSTGI('Axes    '),0)
         CALL PPOST(KWIDGR,GRSTGI('Scale   '),0)
      ENDIF
      RETURN
 1000 FORMAT(' Run:event ',I5,':',I6, ' Date ',I6.6,' Time ',I6.6)

 1010 FORMAT(' Ebeam',F7.2,' Evis',F6.1,' Emiss',F6.1, ' Vtx (',F7.2,','
     +,F7.2,',',F7.2,')')
 1015 FORMAT(' Ebeam',F7.2, ' Vtx (',F5.2,',',F5.2,',',F5.2,')')
 1020 FORMAT(' Ctrk(N=',I3,' Sump=',F5.1,')' ,' Ecal(N=',I3,' SumE=',F5.
     +1,')' ,' Hcal(N=',I2,' SumE=',F5.1,')' )

 1025 FORMAT(' Ctrk(N=',I3,' Sump=',F5.1,')' ,' Ecal(N=',I3,' SumE=',F5.
     +1,')' )

 1030 FORMAT(' Muon(N=',I3, ')' ,' Sec Vtx(N=',I2, ')' ,' Fdet(N=',I2,
     +' SumE=',F5.1,')' )
 1035 FORMAT(' Hcal(N=',I2,' SumE=',F5.1,')',' Muon(N=',I2, ')' ,
     +' Fdet(N=',I2,' SumE=',F5.1,')' )


 1040 FORMAT(' Bz=',F5.3,' Bunchlet',I2,'/',I1,
     +'  Thrust=',F6.4,' Aplan=',F6.4,' Oblat=',F6.4,' Spher=',F6.4)
      END
CDECK  ID>, GRMETA.
      SUBROUTINE GRMETA
*.
*...GRMETA   Send the current view to the Metafile
*.
*. INPUT     :
*. OUTPUT    :
*.
*. SEQUENCE  : DECLAR GRCOLO GRDATA GRMETA GRMODE GRODAT GRVIEW PENUM.
*. SEQUENCE  : ROBANK ROCPAR
*. CALLS     : KUEXEC KUGETC KUPROC PCLWK  PEVMM3 PEVOM3 POPWK  PPOST
*. CALLS     : PQCR   PQPOST GRSCR   PSVWR3 PUWK   RQSYST
*. CALLED    : GRUPDV GRPICK <Kuip>
*.
*. REPORT CONDITIONS
*.
*. AUTHOR    : D.R.Ward
*. VERSION   : 1.00
*. CREATED   :  1-Mar-89
*. LAST MOD  : 10-Jul-95
*.
*. Modification Log.
*. 10-Jul-95   D.R.Ward  Fix spurios "showpage" problem?
*.  5-Jul-95   D.R.Ward  Add filename argument
*. 21-Sep-94   D.R.Ward  Try to fix metafiles on HP
*. 12-Aug-94   D.R.Ward  Fix for 2D
*. 26-Apr-94   D.R.Ward  Introduce IMETA/RCSYST
*. 29-Nov-93   D.R.Ward  Try to rationalize use of colour
*. 15-Jul-93   D.R.Ward  Allow META for HIGZ to work in GOSIP version
*.  5-Mar-93   D.R.Ward  Fix for GOSIP/VAX
*. 23-Sep-92   J.Banks   Fix for GPHIGS V2 (UNIX)
*. 11-Jun-92   D.R.Ward  Fix metafile opening on VAX for GOSIP version
*. 27-Apr-92   D.R.Ward  DATA statement corectly positioned
*. 21-Apr-92   J.Banks   Remove IOFF clash
*. 15-Apr-92   J.Banks   Metafiles for GOSIP/GPHIGS
*. 26-Sep-89   D.R.Ward  Remove PSCR
*. 24-Jul-89   D.R.Ward  Use GRMOPE to open/close metafile
*. 23-Jun-89   D.R.Ward  Temporary circumvention of metafile problems
*.
*.**********************************************************************
*.
      IMPLICIT NONE
*
      INTEGER IMETA
      INTEGER LIOHD,LIOME,IER
      INTEGER ICOL,KW,KUNPAR
      EXTERNAL KUNPAR
      INTEGER N,NPOST,STRID
      REAL    RED,BLUE,GREEN
      REAL    PRIORT
      CHARACTER*8 CMTYP,COK
      CHARACTER*40 CFNAME
      LOGICAL COLMET,COLSAV
*     Receive the content of DGEO, DHIT, DREC data cards - defining the
*     default drawing options for the run.
      INTEGER NDGEO,LDGEO,NDHIT,LDHIT,NDREC,LDREC,MODE,FSTPAS,IGRFIL,
     +IGRISI,IGRFED,IPVTX
      REAL    DSCALE
      LOGICAL GOFLAG
      LOGICAL LBOX,LHSTAT,LHAXES,LHHEAD,LHLOGO,LHSCAL,LHFILE,LHHEAB
      LOGICAL LAUTDZ,LAUTDX,LAUTTF,LAUTSI,LAUTSW,LAUTLE,LHXY,LHSIDE
      CHARACTER*4 CVIEW1,CVIEW2,CVIEW3
      COMMON/GRODAT/NDGEO,LDGEO(40),NDHIT,LDHIT(40),NDREC,LDREC(40),
     +GOFLAG,DSCALE,MODE,FSTPAS,LBOX,LHSTAT,IGRFIL,IGRISI,IGRFED,
     +LHAXES,LHHEAD,LHLOGO,LHSCAL,LHFILE,IPVTX,
     +LAUTDZ,LAUTDX,LAUTTF,LAUTSI,LAUTSW,LAUTLE,LHHEAB,LHXY,LHSIDE
      COMMON/GRODAC/CVIEW1,CVIEW2,CVIEW3
C
C         Archive state
C
C   archive closed , archive opened
      INTEGER  PARCL  , PAROP
      PARAMETER (PARCL = 0 , PAROP  = 1)
C
C         Attribute identifier
C
      INTEGER PLN , PLWSC , PPLCI , PMK , PMKSC , PPMCI, PTXFN , PTXPR ,
     +PCHXP , PCHSP , PTXCI , PIS , PISI , PICI , PEDFG , PEDTY ,
     +PEWSC , PEDCI

      PARAMETER (PLN= 0, PLWSC= 1, PPLCI= 2, PMK= 3, PMKSC= 4, PPMCI= 5,
     +PTXFN= 6, PTXPR= 7, PCHXP= 8, PCHSP= 9, PTXCI=10, PIS =11, PISI
     +=12, PICI =13, PEDFG=14, PEDTY=15, PEWSC=16, PEDCI=17)
C
C         Aspect source flag
C
C   bundled individual
      INTEGER  PBUNDL       , PINDIV
      PARAMETER (PBUNDL=0     , PINDIV =1)
C
C         Clear control flag
C
C   conditionally   always
      INTEGER  PCONDI  , PALWAY
      PARAMETER (PCONDI=0 , PALWAY = 1)
C
C         Clipping indicator
C
C   noclip    clip
      INTEGER  PNCLIP  , PCLIP
      PARAMETER (PNCLIP=0 , PCLIP  = 1)
C
C         Colour available
C
C   monochrome   colour
      INTEGER  PMONOC  , PCOLOR
      PARAMETER (PMONOC=0 , PCOLOR = 1)
C
C         Composition type
C
C    preconcatenate   postconcatenate   replace
      INTEGER   PCPRE  ,  PCPOST    , PCREPL
      PARAMETER ( PCPRE=0 ,  PCPOST=1    , PCREPL=2 )
C
C         Conflict resolution
C
C   maintain , abandon    , update
      INTEGER  PCRMNT  , PCRABA    , PCRUPD
      PARAMETER (PCRMNT=0 , PCRABA =1    , PCRUPD=2)
C
C         Deferral mode
C
C   ASAP    , BNIG     , BNIL  , ASTI     , WAIT
      INTEGER  PASAP    , PBNIG    , PBNIL  , PASTI    , PWAITD
      PARAMETER (PASAP =0  , PBNIG =1 , PBNIL =2 , PASTI =3 , PWAITD=4)
C
C         Device coordinate units
C
C   metres      other
      INTEGER  PMETRE    , POTHU
      PARAMETER (PMETRE=0  , POTHU  =1)
C
C         Display surface empty
C
C   notempty  , empty
      INTEGER  PNEMPT    , PEMPTY
      PARAMETER (PNEMPT=0  , PEMPTY =1)
C
C         Dynamic modification
C
C   IRG      IMM    CBS
      INTEGER  PIRG    , PIMM  , PCBS
      PARAMETER (PIRG  =0  , PIMM   =1  , PCBS  =2)
C
C         Echo switch
C
C   noecho       echo
      INTEGER  PNECHO     , PECHO
      PARAMETER (PNECHO=0   , PECHO  =1)
C
C       Edit mode
C
C    insert      replace
      INTEGER   PINSRT    , PREPLC
      PARAMETER ( PINSRT=0  , PREPLC=1 )
C
C       Element Type
C
      INTEGER PEALL , PENIL , PEPL3 , PEPL , PEPM3 , PEPM , PETX3 ,
     +PETX , PEATR3 , PEATR , PEFA3 , PEFA , PEFAS3 , PEFAS , PECA3 ,
     +PECA , PEGDP3 , PEGDP , PEPLI , PEPMI , PETXI , PEII , PEEDI ,
     +PELN , PELWSC , PEPLCI , PEMK , PEMKSC , PEPMCI , PETXFN ,
     +PETXPR , PECHXP , PECHSP , PETXCI , PECHH , PECHUP

      INTEGER PETXP , PETXAL , PEATCH , PEATCU , PEATP , PEATAL ,
     +PEANST , PEIS , PEISI , PEICI , PEEDFG , PEEDT , PEEWSC , PEEDCI ,
     +PEPA , PEPRPV , PEPARF , PEADS , PERES , PEIASF , PEHRID ,
     +PELMT3 , PELMT , PEGMT3 , PEGMT , PEMCV3 , PEMCV , PEMCLI ,
     +PERMCL , PEVWI , PEEXST , PELB , PEAP , PEGSE , PEPKID
C
      PARAMETER ( PEALL = 00, PENIL = 01, PEPL3 = 02, PEPL = 03, PEPM3 =
     +04, PEPM = 05, PETX3 = 06, PETX = 07, PEATR3= 08, PEATR = 09,
     +PEFA3 = 10, PEFA = 11, PEFAS3= 12, PEFAS = 13, PECA3 = 14, PECA =
     +15, PEGDP3= 16, PEGDP = 17, PEPLI = 18, PEPMI = 19, PETXI = 20,
     +PEII = 21, PEEDI = 22, PELN = 23, PELWSC= 24, PEPLCI= 25, PEMK =
     +26, PEMKSC= 27, PEPMCI= 28, PETXFN= 29, PETXPR= 30, PECHXP= 31,
     +PECHSP= 32, PETXCI= 33, PECHH = 34, PECHUP=35)

      PARAMETER ( PETXP = 36, PETXAL= 37, PEATCH= 38, PEATCU= 39, PEATP
     += 40, PEATAL= 41, PEANST= 42, PEIS = 43, PEISI = 44, PEICI = 45,
     +PEEDFG= 46, PEEDT = 47, PEEWSC= 48, PEEDCI= 49, PEPA = 50, PEPRPV=
     +51, PEPARF= 52, PEADS = 53, PERES = 54, PEIASF= 55, PEHRID= 56,
     +PELMT3= 57, PELMT = 58, PEGMT3= 59, PEGMT = 60, PEMCV3= 61, PEMCV
     += 62, PEMCLI= 63, PERMCL= 64, PEVWI = 65, PEEXST= 66, PELB = 67,
     +PEAP = 68, PEGSE = 69, PEPKID=70)
C
C       Search success indicator
C
C   failure    , success
      INTEGER  PFAIL     , PSUCC
      PARAMETER (PFAIL =0  , PSUCC =1 )
C
C       Input device status
C
C   none     , ok      , nopick  , nochoice
      INTEGER  PNONE     , POK     , PNPICK  , PNCHOI
      PARAMETER (PNONE =0  , POK  =1 , PNPICK=2 , PNCHOI= 2)
C
C       Interior style
C
C    hollow   , solid    , pattern  , hatch    , empty
      INTEGER   PHOLLO   , PSOLID   , PPATTR  , PHATCH   , PISEMP
      PARAMETER ( PHOLLO=0 , PSOLID=1 , PPATTR=2 , PHATCH=3 , PISEMP=4)
C
C       Input class
C
C   none   ,locator ,stroke  ,valuator,choice  ,pick ,
C   string
      INTEGER PNCLAS ,PLOCAT ,PSTROK ,PVALUA ,PCHOIC ,PPICK, PSTRIN ,
     +PEXPOS ,PRSIZE
      PARAMETER (PNCLAS =0,PLOCAT=1,PSTROK=2,PVALUA=3,PCHOIC=4,PPICK=5,
     +PSTRIN=6,PEXPOS=10,PRSIZE=11)
C
C       Modification mode
C
C   NIVE     , UWOR     , UQUM
      INTEGER  PNIVE     , PUWOR    , PUQUM
      PARAMETER (PNIVE =0  , PUWOR =1 , PUQUM =2)
C
C      Off/on switch for edge flag and error handling mode
C
C   off       on
      INTEGER  POFF     , PON      ,PACT
      PARAMETER (POFF =0  , PON   =1 ,PACT   =2)
C
C       Open - Structure Status
C
C    none       open
      INTEGER   PNONST    , POPNST
      PARAMETER ( PNONST=0  , POPNST=1 )
C
C       Operating mode
C
C   request    , sample , event
      INTEGER  PREQU     , PSAMPL , PEVENT
      PARAMETER (PREQU =0  , PSAMPL=1 , PEVENT=2)
C
C       Path order
C
C   top first  , bottom first
      INTEGER  PPOTOP     , PPOBOT
      PARAMETER (PPOTOP =0  , PPOBOT=1)
C
C       Presence of invalid values
C
C   absent     , present
      INTEGER  PABSNT     , PPRSNT
      PARAMETER (PABSNT=0   , PPRSNT=1)
C
C       Reference handling flag
C
C   delete     , keep
      INTEGER  PDELE     , PKEEP
      PARAMETER (PDELE =0  , PKEEP =1)
C
C       regeneration flag
C
C   postpone   , perform
      INTEGER  PPOSTP     , PPERFO
      PARAMETER (PPOSTP =0  , PPERFO=1)
C
C       relative input priority
C
C   higher     , lower
      INTEGER  PHIGHR     , PLOWER
      PARAMETER (PHIGHR =0  , PLOWER=1)
C
C       search direction
C
C   backward   , forward
      INTEGER  PBWD     , PFWD
      PARAMETER (PBWD =0  , PFWD  =1)
C
C       simultaneous events flag
C
C   nomore     , more
      INTEGER  PNMORE     , PMORE
      PARAMETER (PNMORE =0  , PMORE =1)
C
C       state of visual representation
C
C   correct    , deferred , simulated
      INTEGER  PVROK     , PVRDFR , PVRSIM
      PARAMETER (PVROK =0  , PVRDFR=1 , PVRSIM=2)
C
C       structure network source
C
C   CSS     , archive file
      INTEGER  PCSS     , PARCHV
      PARAMETER (PCSS =0  , PARCHV=1)
C
C       Structure State Value
C
C    STCL      STOP
      INTEGER   PSTCL    , PSTOP
      PARAMETER ( PSTCL=0  , PSTOP=1 )
C
C       structure status indicator
C
C   non-existent, empty  , non-empty
      INTEGER  PSNOEX      , PSEMPT  , PSNEMP
      PARAMETER (PSNOEX =0   , PSEMPT=1  , PSNEMP=2)
C
C
C        System State Value
C
C    PHCL      PHOP
      INTEGER   PPHCL    , PPHOP
      PARAMETER ( PPHCL=0  , PPHOP=1 )
C
C       text alignment horizontal
C
C   normal     , left , center  , right
      INTEGER  PAHNOR     , PALEFT , PACENT  , PARITE
      PARAMETER (PAHNOR =0  , PALEFT=1 , PACENT=2, PARITE=3)
C
C       text alignment vertical
C
C   normal   ,top    ,cap    ,half    ,base    ,bottom
      INTEGER  PAVNOR   ,PATOP   ,PACAP  ,PAHALF  ,PABASE  ,PABOTT
      PARAMETER (PAVNOR =0,PATOP =1,PACAP=2,PAHALF=3,PABASE=4,PABOTT=5)
C
C       text path
C
C   right     , left , up   , down
      INTEGER  PRIGHT     , PLEFT , PUP   , PDOWN
      PARAMETER (PRIGHT =0  , PLEFT =1 , PUP=2   , PDOWN=3)
C
C       text precision
C
C   string     , character , stroke
      INTEGER  PSTRP     , PCHARP , PSTRKP
      PARAMETER (PSTRP =0  , PCHARP=1 , PSTRKP=2)
C
C       type of returned values
C
C   set     , realized
      INTEGER  PSET     , PREALI
      PARAMETER (PSET =0  , PREALI=1)
C
C       update state
C
C   notpending , pending
      INTEGER  PNPEND     , PPEND
      PARAMETER (PNPEND =0  , PPEND =1)
C
C       vector/raster/other type
C
C   vector     , raster , other
      INTEGER  PVECTR     , PRASTR , POTHWK
      PARAMETER (PVECTR =0  , PRASTR=1 , POTHWK=2)
C
C    viewtype
C
C   parallel   , perspective
      INTEGER  PPARL     , PPERS
      PARAMETER (PPARL =0  , PPERS =1)
C
C       workstation category
C
C   OUTPUT     , INPUT , OUTIN   , MO   , MI
      INTEGER  POUTPT     , PINPUT , POUTIN  , PMO   , PMI
      PARAMETER (POUTPT =0  , PINPUT=1 , POUTIN=2, PMO=3 , PMI=4)
C
C   workstation dependency indicator
C
C   workstation independent, workstation dependent ,
      INTEGER  PWKI   , PWKD
      PARAMETER (PWKI = 0  , PWKD=1)
C
C       workstation state
C
C   closed     , open
      INTEGER  PWKCL     , PWKOP
      PARAMETER (PWKCL =0  , PWKOP =1)
C
C       list of GDP
C
C     attributes polyline  , polymarker, text  , interior , edge
      INTEGER  PPLBND    , PPMBND    , PTXBND  , PINBND   , PEDBND
      PARAMETER (PPLBND =0 , PPMBND=1  , PTXBND=2, PINBND=3 , PEDBND=4)
C
C   linetype
C
C   solid     , dash , dot    , dash-dot
      INTEGER  PLSOLI     , PLDASH , PLDOT    , PLDASD
      PARAMETER (PLSOLI =1  , PLDASH=2 , PLDOT=3  , PLDASD=4)
C
C       marker type
C               "."        "+"       "*"      "o"       "x"
      INTEGER  PPOINT     , PPLUS , PAST  , POMARK  , PXMARK
      PARAMETER (PPOINT =1  , PPLUS =2 , PAST=3 , POMARK=4, PXMARK=5)
C
C       annotation style
C   unconnected, lead line using current
C         polyline attributes
      INTEGER  PUNCON     , PLDLN
      PARAMETER (PUNCON =1  , PLDLN =2)
C
C       colour model
C
C   RGB     , CIE , HSV   , HLS
      INTEGER  PRGB     , PCIE , PHSV   , PHLS
      PARAMETER (PRGB =1  , PCIE  =2 , PHSV=3  , PHLS=4)
C
C       modelling clipping operator
C
C   replace      intersect
      INTEGER  PMCREP     , PMCINT
      PARAMETER (PMCREP =1  , PMCINT=2)
C
C       polyline/fill area control flag
C
C   polyline     fill area , fill area set
      INTEGER  PPLINE     , PFILLA , PFILAS
      PARAMETER (PPLINE =0  , PFILLA=1 , PFILAS=2)
C
C       Additional in the FORTRAN binding, to be used with
C       PHIGS inquiry functions that return both Current
C   and Requested values
C
C   current      requested
      INTEGER  PCURVL     , PRQSVL
      PARAMETER (PCURVL =0  , PRQSVL=1)
C
C
C        Names used for Error Handling
C
      INTEGER  EOPPH    ,ECLPH     ,EOPWK  ,ECLWK     ,ERST
      INTEGER  EUWK    ,ESDUS     ,EMSG  ,EPL3     ,EPL
      INTEGER  EPM3    ,EPM       ,ETX3  ,ETX     ,EATR3
      INTEGER  EATR    ,EFA3      ,EFA  ,EFAS3     ,EFAS
      INTEGER  ECA3    ,ECA       ,EGDP3  ,EGDP     ,ESPLI
      INTEGER  ESPMI    ,ESTXI     ,ESII  ,ESEDI     ,ESLN
      INTEGER  ESLWSC    ,ESPLCI    ,ESMK  ,ESMKSC    ,ESPMCI
      INTEGER  ESTXFN    ,ESTXPR    ,ESCHXP  ,ESCHSP    ,ESTXCI
      INTEGER  ESCHH    ,ESCHUP    ,ESTXP  ,ESTXAL    ,ESATCH
      INTEGER  ESATCU    ,ESATP     ,ESATAL  ,ESANS     ,ESIS
      INTEGER  ESISI    ,ESICI     ,ESEDFG  ,ESEDT     ,ESEWSC
      INTEGER  ESEDCI    ,ESPA      ,ESPRPV  ,ESPARF    ,EADS
      INTEGER  ERES    ,ESIASF    ,ESPLR  ,ESPMR     ,ESTXR
      INTEGER  ESIR    ,ESEDR     ,ESPAR  ,ESCR     ,ESHLFT
      INTEGER  ESIVFT    ,ESCMD     ,ESHRID  ,ESHRM     ,ESLMT3
      INTEGER  ESLMT    ,ESGMT3    ,ESGMT  ,ESMCV3    ,ESMCV
      INTEGER  ESMCLI    ,ERMCV     ,ESVWI  ,ESVWR3    ,ESVWR
      INTEGER  ESVTIP    ,ESWKW3    ,ESWKW  ,ESWKV3    ,ESWKV
      INTEGER  EOPST    ,ECLST     ,EEXST  ,ELB     ,EAP
      INTEGER  EGSE    ,ESEDM     ,ECELST  ,ESEP     ,EOSEP
      INTEGER  ESEPLB    ,EDEL      ,EDELRA  ,EDELLB    ,EEMST
      INTEGER  EDST    ,EDSN      ,EDAS  ,ECSTID    ,ECSTRF
      INTEGER  ECSTIR    ,EPOST     ,EUPOST  ,EUPAST    ,EOPARF
      INTEGER  ECLARF    ,EARST     ,EARSN  ,EARAST    ,ESCNRS
      INTEGER  ERSID    ,EREST     ,ERESN  ,ERAST     ,ERANST
      INTEGER  ERDEST    ,EDSTAR    ,EDSNAR  ,EDASAR    ,ESPKID
      INTEGER  ESPKFT    ,EINLC3    ,EINLC  ,EINSK3    ,EINSK
      INTEGER  EINVL3    ,EINVL     ,EINCH3    ,EINCH     ,EINPK3
      INTEGER  EINPK     ,EINST3    ,EINST     ,ESLCM     ,ESSKM
      INTEGER  ESVLM     ,ESCHM     ,ESPKM     ,ESSTM     ,ERQLC3
      INTEGER  ERQLC     ,ERQSK3    ,ERQSK     ,ERQVL     ,ERQCH
      INTEGER  ERQPK     ,ERQST     ,ESMLC3    ,ESMLC     ,ESMSK3
      INTEGER  ESMSK     ,ESMVL     ,ESMCH     ,ESMPK     ,ESMST
      INTEGER  EWAIT     ,EFLUSH    ,EGTLC3    ,EGTLC     ,EGTSK3
      INTEGER  EGTSK     ,EGTVL     ,EGTCH     ,EGTPK     ,EGTST
      INTEGER  EWITM     ,EGTITM    ,ERDITM    ,EIITM     ,ESERHM
      INTEGER  EUREC     ,EPREC     ,EESC
C
      PARAMETER (EOPPH =000,ECLPH =001,EOPWK =002,ECLWK =003,ERST  =004)
      PARAMETER (EUWK  =005,ESDUS =006,EMSG  =007,EPL3 =008,EPL   =009)
      PARAMETER (EPM3  =010,EPM   =011,ETX3  =012,ETX =013,EATR3 =014)
      PARAMETER (EATR  =015,EFA3  =016,EFA   =017,EFAS3 =018,EFAS  =019)
      PARAMETER (ECA3  =020,ECA   =021,EGDP3 =022,EGDP =023,ESPLI =024)
      PARAMETER (ESPMI =025,ESTXI =026,ESII  =027,ESEDI =028,ESLN  =029)
      PARAMETER (ESLWSC=030,ESPLCI=031,ESMK  =032,ESMKSC=033,ESPMCI=034)
      PARAMETER (ESTXFN=035,ESTXPR=036,ESCHXP=037,ESCHSP=038,ESTXCI=039)
      PARAMETER (ESCHH =040,ESCHUP=041,ESTXP =042,ESTXAL=043,ESATCH=044)
      PARAMETER (ESATCU=045,ESATP =046,ESATAL=047,ESANS =048,ESIS  =049)
      PARAMETER (ESISI =050,ESICI =051,ESEDFG=052,ESEDT =053,ESEWSC=054)
      PARAMETER (ESEDCI=055,ESPA  =056,ESPRPV=057,ESPARF=058,EADS  =059)
      PARAMETER (ERES  =060,ESIASF=061,ESPLR =062,ESPMR =063,ESTXR =064)
      PARAMETER (ESIR  =065,ESEDR =066,ESPAR =067,ESCR =068,ESHLFT=069)
      PARAMETER (ESIVFT=070,ESCMD =071,ESHRID=072,ESHRM =073,ESLMT3=074)
      PARAMETER (ESLMT =075,ESGMT3=076,ESGMT =077,ESMCV3=078,ESMCV =079)
      PARAMETER (ESMCLI=080,ERMCV =081,ESVWI =082,ESVWR3=083,ESVWR =084)
      PARAMETER (ESVTIP=085,ESWKW3=086,ESWKW =087,ESWKV3=088,ESWKV =089)
      PARAMETER (EOPST =090,ECLST =091,EEXST =092,ELB =093,EAP   =094)
      PARAMETER (EGSE  =095,ESEDM =096,ECELST=097,ESEP =098,EOSEP =099)
      PARAMETER (ESEPLB=100,EDEL  =101,EDELRA=102,EDELLB=103,EEMST =104)
      PARAMETER (EDST  =105,EDSN  =106,EDAS  =107,ECSTID=108,ECSTRF=109)
      PARAMETER (ECSTIR=110,EPOST =111,EUPOST=112,EUPAST=113,EOPARF=114)
      PARAMETER (ECLARF=115,EARST =116,EARSN =117,EARAST=118,ESCNRS=119)
      PARAMETER (ERSID =120,EREST =121,ERESN =122,ERAST =123,ERANST=124)
      PARAMETER (ERDEST=125,EDSTAR=126,EDSNAR=127,EDASAR=128,ESPKID=129)
      PARAMETER (ESPKFT=130,EINLC3=131,EINLC =132,EINSK3=133,EINSK =134)
      PARAMETER (EINVL3=135,EINVL =136,EINCH3=137,EINCH =138,EINPK3=139)
      PARAMETER (EINPK =140,EINST3=141,EINST =142,ESLCM =143,ESSKM =144)
      PARAMETER (ESVLM =145,ESCHM =146,ESPKM =147,ESSTM =148,ERQLC3=149)
      PARAMETER (ERQLC =150,ERQSK3=151,ERQSK =152,ERQVL =153,ERQCH =154)
      PARAMETER (ERQPK =155,ERQST =156,ESMLC3=157,ESMLC =158,ESMSK3=159)
      PARAMETER (ESMSK =160,ESMVL =161,ESMCH =162,ESMPK =163,ESMST =164)
      PARAMETER (EWAIT =165,EFLUSH=166,EGTLC3=167,EGTLC =168,EGTSK3=169)
      PARAMETER (EGTSK =170,EGTVL =171,EGTCH =172,EGTPK =173,EGTST= 174)
      PARAMETER (EWITM =175,EGTITM=176,ERDITM=177,EIITM =178,ESERHM=179)
      PARAMETER (EUREC =180,EPREC =181,EESC  =182)
C
C
C
C  INQUIRY
C
C         Structure status indicator
C
C   not exist , not empty
      INTEGER  PNOEXS    , PNOEMP
      PARAMETER (PNOEXS=0  , PNOEMP=2)
C
C
C=====================================================================
C================ EXTENTION ==========================================
C=====================================================================
C
C     Additional Names used for Extension Error Handling
C
      INTEGER    EXAMOD    ,EXGMOD    ,EXCHLG
      PARAMETER (EXAMOD=900,EXGMOD=901,EXCHLG=909)
      INTEGER    EXQMT     ,EXQMT3
      PARAMETER (EXQMT =902,EXQMT3=903)
      INTEGER    EXSTFT    ,EXRTRP
      PARAMETER (EXSTFT=904,EXRTRP=905)
      INTEGER    EXQTLA    ,EXQTMA    ,EXQTTA
      PARAMETER (EXQTLA=906,EXQTMA=907,EXQTTA=908)
C
C
C
      INTEGER    PXMCWC  ,PXWCMC
      PARAMETER (PXMCWC=0,PXWCMC=1)
C HLHSR identifiers
C
      INTEGER    PHIDEF  , PZBON   , PZBOFF
      PARAMETER (PHIDEF=0, PZBON=1 , PZBOFF=2)
*     View index numbers
      INTEGER JVWIEV,JVWIAX,JVWIHD
      PARAMETER (JVWIEV=4,JVWIAX=2,JVWIHD=0)
      INTEGER JVWIV1,JVWIV2,JVWIV3
      PARAMETER (JVWIV1=4,JVWIV2=5,JVWIV3=3)
*
*     Transformation numbers
      INTEGER JTNREV,JTNRAX,JTNRHD
      PARAMETER (JTNREV=4,JTNRAX=5,JTNRHD=3)
*
*     Workstation types.  (MetaFile O/p)
      INTEGER KWTMFO
      PARAMETER (KWTMFO=10201)
*
*     KWTYPE (screen) set by data card/KUIP
*     MFSTAT tells whether Metafile open
*     COLOUR flags whether screen in colour or not
      INTEGER KWTYPE,MFSTAT
      LOGICAL COLOUR
*     Workstation IDs  (GRope, MetaFile, DZdoc etc.)
*             KWIDGR,KWIDMF, etc.
*     Connection  IDs  (GRope, MetaFile)
*             KONIGR,KONIMF
*
      INTEGER KWTYGR,KWTYDZ,KWTYKU,
     + KWIDGR,KWIDMF,KWIDDZ,KWIDLE,KWIDDX,KWIDSI,KWIDSW,KWIDTF,
     + KONIGR,KONIMF,
     + IPPERS
      REAL DPRP
      EQUIVALENCE (KWTYGR,KWTYPE)
      COMMON/GRDATA/KWTYGR,KWTYDZ,KWTYKU,
     +KWIDGR,KWIDMF,KWIDDZ,KWIDLE,KWIDDX,KWIDSI,KWIDSW,KWIDTF,
     +KONIGR,KONIMF,
     +MFSTAT,COLOUR,IPPERS,DPRP
      INTEGER   NLRCO ,NSRCO ,NDRCO ,NIRCO ,IORCO ,
     +          LLEXC ,LLUTC ,LLDAC ,LLCDC ,LLECC ,
     +          LLHCC ,LLMUC ,LLFOC ,LLDDC ,LLODC ,
     +          IIFEXC,IIFUTC,IIFDAC,IIFCDC,IIFECC,
     +          IIFHCC,IIFMUC,IIFFOC,IIFDDC,IIFODC
      INTEGER   NLEXC ,NSEXC ,NDEXC ,NIEXC ,IOEXC ,
     +          LLTRIC,LLMCC ,LLLEPC,
     +          IIFTRC,IIFMCC,IIFLEC
      INTEGER   NLUTC ,NSUTC ,NDUTC ,NIUTC ,IOUTC ,
     +          LLREPO,LLGRHD,LLIOHD,LLSLCT,LLMSRN
      INTEGER   NLDAC ,NSDAC ,NDDAC ,NIDAC ,IODAC ,
     +          LLCVCT,LLCJCT,LLCZCT,LLTBCT,LLPBCT,LLEBCT,LLPECT,
     +          LLEECT,LLHTCT,LLHSCT,LLHPCT,LLMBCT,LLMECT,LLFDCT,
     +          LLTRCT,LLTTCT,LLSCCT,LLFICT,LLGNCT,LLSICT,LLDXCT,
     +          LLSWCT,LLTECT,
     +          IFCVCT,IFCJCT,IFCZCT,IFTBCT,IFPBCT,IFEBCT,IFPECT,
     +          IFEECT,IFHTCT,IFHSCT,IFHPCT,IFMBCT,IFMECT,IFFDCT,
     +          IFTRCT,IFTTCT,IFSCCT,IFFICT,IFGNCT,IFSICT,IFDXCT,
     +          IFSWCT,IFTECT
      INTEGER   NLCDC ,NSCDC ,NDCDC ,NICDC ,IOCDC ,
     +          LLCVC ,LLCJC ,LLCZC ,LLCTC ,LLDXC ,LLCFC ,LLCXC ,
     +          LLSIC ,LLCSC ,LLCEC ,LLCAC ,
     +          IIFCVC,IIFCJC,IIFCZC,IIFCTC,IIFDXC,IIFCFC,IIFCXC,
     +          IIFSIC,IIFCSC,IIFCEC,IIFCAC
      INTEGER   NLECC ,NSECC ,NDECC ,NIECC ,IOECC ,
     +          LLTBC ,LLPBC ,LLEBC ,LLPEC ,LLEEC ,LLEMC ,LLTEC,
     +          IIFTBC,IIFTEC,IIFPBC,IIFEBC,IIFPEC,IIFEEC,IIFEMC
      INTEGER   NLHCC ,NSHCC ,NDHCC ,NIHCC ,IOHCC ,
     +          LLHBC ,LLHEC ,LLHPC ,LLHMC ,
     +          IIFHBC,IIFHEC,IIFHPC,IIFHMC
      INTEGER   NLMUC ,NSMUC ,NDMUC ,NIMUC ,IOMUC ,
     +          LLMBC ,LLMECO,LLMMC ,
     +          IIFMBC,IIFMEC,IIFMMC
      INTEGER   NLFOC ,NSFOC ,NDFOC ,NIFOC ,IOFOC ,
     +          LLFDCR,LLFDCL,LLSWC,
     +          IIFFDC,IIFSWC
      INTEGER   NLODC ,NSODC ,NDODC ,NIODC ,IOODC ,
     +          LLODCB,
     +          IIFODG,IIFODT,IIFODP,IIFODE,IIFODU,IIFODH,
     +          IIFODM,IIFODF,IIFODV,IIFODA,IIFODX,IIFODW,
     +          IIFODD
      INTEGER   NLIOHD,NSIOHD,NDIOHD,NIIOHD,IOIOHD,
     +          LLIOII,LLIOCI,LLIODI,LLIODO,LLIODC,LLIOOV,
     +          LLIODS,LLIODD,LLIOCA,LLIOME,LLIOBK,LLIOHB,
     +          LLIODP,LLIODG,LLIOAO,LLIONO,LLIOMS,LLIOEO
      INTEGER   NLSLCT,NSSLCT,NDSLCT,NISLCT,IOSLCT,
     +          LLSLEV,LLSLRE,LLSLGE
      INTEGER   NLIOXX,NSIOXX,NDIOXX,NIIOXX,IOIOXX,
     +          JACTIV,JSELEC,JLUN  ,JLREC ,JFCHOP,
     +          JDCHOP,JFSTAT,JFNTYP,JACMOD,JFLAGS,
     +          JDEVIC,JFKEYS,JFNAME,JFJFIL
      INTEGER   NLSLEV,NSSLEV,NDSLEV,NISLEV,IOSLEV,
     +          JRUFST,JEVFST,JRULST,JEVLST
      INTEGER   NLSLRE,NSSLRE,NDSLRE,NISLRE,IOSLRE,
     +          IREFST,IRELST,IRESTP
      INTEGER   NLSLGE,NSSLGE,NDSLGE,NISLGE,IOSLGE,
     +          IRUGET,IEVGET
      INTEGER   NLGNCT,NSGNCT,NDGNCT,NIGNCT,IOGNCT,
     +          LLMAGF,LLBEAM,LLLIFE,LLBUTZ
      INTEGER   NLMAGF,NSMAGF,NDMAGF,NIMAGF,IOMAGF,
     +          IMEANB
      INTEGER   NLBEAM,NSBEAM,NDBEAM,NIBEAM,IOBEAM,
     +          IXBEAM,IYBEAM,IZBEAM,IDXBEA,IDYBEA,IDZBEA,
     +          IEXBEA,IEYBEA,IEZBEA
      INTEGER   NLBUTZ,NSBUTZ,NDBUTZ,NIBUTZ
      INTEGER   NLLIFE,NSLIFE,NDLIFE,NILIFE,IOLIFE
      PARAMETER(NLRCO = 10,NSRCO = 10,NDRCO = 10,NIRCO = 10,IORCO =  2,
     +          LLEXC =  1,LLUTC =  2,LLDAC =  3,LLCDC =  4,LLECC =  5,
     +          LLHCC =  6,LLMUC =  7,LLFOC =  8,LLDDC =  9,LLODC = 10,
     +          IIFEXC=  1,IIFUTC=  2,IIFDAC=  3,IIFCDC=  4,IIFECC=  5,
     +          IIFHCC=  6,IIFMUC=  7,IIFFOC=  8,IIFDDC=  9,IIFODC= 10)
      PARAMETER(NLEXC =  3,NSEXC =  3,NDEXC =  3,NIEXC =  3,IOEXC =  2,
     +          LLTRIC=  1,LLMCC =  2,LLLEPC=  3,
     +          IIFTRC=  1,IIFMCC=  2,IIFLEC=  3)
      PARAMETER(NLUTC =  5,NSUTC =  5,NDUTC =  0,NIUTC =  0,IOUTC =  0,
     +          LLREPO=  1,LLGRHD=  2,LLIOHD=  3,LLSLCT=  4,LLMSRN=  5)
      PARAMETER(NLDAC = 23,NSDAC = 23,NDDAC = 23,NIDAC = 23,IODAC =  2,
     +          LLCVCT=  1,LLCJCT=  2,LLCZCT=  3,LLTBCT=  4,LLPBCT=  5,
     +          LLEBCT=  6,LLPECT=  7,LLEECT=  8,LLHTCT=  9,LLHSCT= 10,
     +          LLHPCT= 11,LLMBCT= 12,LLMECT= 13,LLFDCT= 14,LLTRCT= 15,
     +          LLTTCT= 16,LLSCCT= 17,LLFICT= 18,LLGNCT= 19,LLSICT= 20,
     +          LLDXCT= 21,LLSWCT= 22,LLTECT= 23,
     +          IFCVCT=  1,IFCJCT=  2,IFCZCT=  3,IFTBCT=  4,IFPBCT=  5,
     +          IFEBCT=  6,IFPECT=  7,IFEECT=  8,IFHTCT=  9,IFHSCT= 10,
     +          IFHPCT= 11,IFMBCT= 12,IFMECT= 13,IFFDCT= 14,IFTRCT= 15,
     +          IFTTCT= 16,IFSCCT= 17,IFFICT= 18,IFGNCT= 19,IFSICT= 20,
     +          IFDXCT= 21,IFSWCT= 22,IFTECT= 23)
      PARAMETER(NLCDC = 11,NSCDC = 11,NDCDC = 11,NICDC = 11,IOCDC =  2,
     +          LLCVC =  1,LLCJC =  2,LLCZC =  3,LLCTC =  4,LLDXC =  5,
     +          LLCFC =  6,LLCXC =  7,LLSIC =  8,LLCSC =  9,LLCEC = 10,
     +          LLCAC = 11,
     +          IIFCVC=  1,IIFCJC=  2,IIFCZC=  3,IIFCTC=  4,IIFDXC=  5,
     +          IIFCFC=  6,IIFCXC=  7,IIFSIC=  8,IIFCSC=  9,IIFCEC= 10,
     +          IIFCAC= 11)
      PARAMETER(NLECC =  7,NSECC =  7,NDECC =  7,NIECC =  7,IOECC =  2,
     +          LLTBC =  1,LLPBC =  2,LLEBC =  3,LLPEC =  4,LLEEC =  5,
     +          LLEMC =  6,LLTEC =  7,
     +          IIFTBC=  1,IIFTEC=  2,IIFPBC=  3,IIFEBC=  4,IIFPEC=  5,
     +          IIFEEC=  6,IIFEMC=  7)
      PARAMETER(NLHCC =  4,NSHCC =  4,NDHCC =  4,NIHCC =  4,IOHCC =  2,
     +          LLHBC =  1,LLHEC =  2,LLHPC =  3,LLHMC =  4,
     +          IIFHBC=  1,IIFHEC=  2,IIFHPC=  3,IIFHMC=  4)
      PARAMETER(NLMUC =  3,NSMUC =  3,NDMUC =  3,NIMUC =  3,IOMUC =  2,
     +          LLMBC =  1,LLMECO=  2,LLMMC =  3,
     +          IIFMBC=  1,IIFMEC=  2,IIFMMC=  3)
      PARAMETER(NLFOC =  3,NSFOC =  3,NDFOC =  3,NIFOC =  3,IOFOC =  2,
     +          LLFDCR=  1,LLFDCL=  2,LLSWC =  3,
     +          IIFFDC=  1,           IIFSWC=  3)
      PARAMETER(NLODC =  1,NSODC =  1,NDODC = 13,NIODC = 13,IOODC =  2,
     +          LLODCB=  1,
     +          IIFODG=  1,IIFODT=  2,IIFODP=  3,IIFODE=  4,IIFODU= 5,
     +          IIFODH=  6,IIFODM=  7,IIFODF=  8,IIFODV=  9,IIFODA= 10,
     +          IIFODX= 11,IIFODW=12,IIFODD=13)
      INTEGER   LLIODT
      PARAMETER(NLIOHD= 19,NSIOHD= 19,NDIOHD=  0,NIIOHD=  0,IOIOHD=  2,
     +          LLIOII=  1,LLIOCI=  2,LLIODI=  3,LLIODO=  4,LLIODC=  5,
     +          LLIOOV=  6,LLIODS=  7,LLIODD=  8,LLIOCA=  9,LLIOME= 10,
     +          LLIOBK= 11,LLIOHB= 12,LLIODP= 13,LLIODG= 14,LLIOAO= 15,
     +          LLIONO= 16,LLIOMS= 17,LLIOEO= 18,LLIODT= 19)
      PARAMETER(NLSLCT=  3,NSSLCT=  3,NDSLCT=  0,NISLCT=  0,IOSLCT=  2,
     +          LLSLEV=  1,LLSLRE=  2,LLSLGE=  3)
      PARAMETER(NLIOXX=  0,NSIOXX=  0,NDIOXX= 42,NIIOXX= 42,IOIOXX=  2,
     +          JACTIV=  1,JSELEC=  2,JLUN  =  3,JLREC =  4,JFCHOP=  5,
     +          JDCHOP=  6,JFSTAT=  7,JFNTYP=  8,JACMOD=  9,JFLAGS= 10,
     +          JDEVIC= 11,JFKEYS= 12,JFNAME= 22,JFJFIL= 23)
      PARAMETER(NLSLEV=  0,NSSLEV=  0,NDSLEV=  4,NISLEV=  4,IOSLEV=  2,
     +          JRUFST=  1,JEVFST=  2,JRULST=  3,JEVLST=  4)
      PARAMETER(NLSLRE=  0,NSSLRE=  0,NDSLRE=  3,NISLRE=  3,IOSLRE=  2,
     +          IREFST=  1,IRELST=  2,IRESTP=  3)
      PARAMETER(NLSLGE=  0,NSSLGE=  0,NDSLGE=  2,NISLGE=  2,IOSLGE=  2,
     +          IRUGET=  1,IEVGET=  2)
      PARAMETER(NLGNCT=  4,NSGNCT=  4,NDGNCT=  0,NIGNCT=  0,IOGNCT=  2,
     +          LLMAGF=  1,LLBEAM=  2,LLLIFE=  3,LLBUTZ=  4)
      PARAMETER(NLMAGF=  0,NSMAGF=  0,NDMAGF=  1,NIMAGF=  0,IOMAGF=  3,
     +          IMEANB=  1)
      PARAMETER(NLBEAM=  0,NSBEAM=  0,NDBEAM=  9,NIBEAM=  0,IOBEAM=  3,
     +          IXBEAM=  1,IYBEAM=  2,IZBEAM=  3,
     +          IDXBEA=  4,IDYBEA=  5,IDZBEA=  6,
     +          IEXBEA=  7,IEYBEA=  8,IEZBEA=  9)
      PARAMETER(NLLIFE=  0,NSLIFE=  0,NDLIFE= 30,NILIFE=  0,IOLIFE=  3)
      PARAMETER(NLBUTZ=  0,NSBUTZ=  0,NDBUTZ= 66,NIBUTZ=  2)
      INTEGER NRODUM
      PARAMETER (NRODUM=50)
      INTEGER  IRODIV, IROCON, IROSTA
      COMMON/ROBANK/IRODIV,IROCON,IROSTA
      INTEGER IQND(NRODUM-29),  IQNS(NRODUM-28),
     +        IQNL(NRODUM-27), IQIDH(NRODUM-26), IQIDN(NRODUM-25)
      EQUIVALENCE (  IQ(1),  IQND(2),  IQNS(3),
     +             IQNL(4), IQIDH(5), IQIDN(6))
      INTEGER LQNEXT(NRODUM-22),  LQUP(NRODUM-23), LQORIG(NRODUM-24)
      EQUIVALENCE (LQ(3), LQORIG(1),  LQUP(2), LQNEXT(3))
      INTEGER       LREV ,LRCO ,LRST ,LHEAD,LAA  ,
     +        LEX  ,LUT  ,LDA  ,LCD  ,LEC  ,LHC  ,LMU  ,LFO  ,LDD  ,
     +        LOD  ,LLEP ,LMC  ,LCV  ,LCJ  ,LCZ  ,LCT  ,LDX  ,LCF  ,
     +        LCX  ,LSI  ,LCS  ,LCE  ,LCA  ,LTB  ,LPB  ,LEB  ,LPE  ,
     +        LEE  ,LEM  ,LHB  ,LHE  ,LHP  ,LHM  ,LMB  ,LME  ,LMM  ,
     +        LFD  ,LSW  ,LUS  ,
     +        LEXC ,LUTC ,LDAC ,LCDC ,LECC ,LHCC ,LMUC ,LFOC ,LDDC ,
     +        LODC ,LLEPC,LMCC ,LCVC ,LCJC ,LCZC ,LCTC ,LDXC ,LCFC ,
     +        LCXC ,LSIC ,LCSC ,LCEC ,LCAC ,LTBC ,LPBC ,LEBC ,LPEC ,
     +        LEEC ,LEMC ,LHBC ,LHEC ,LHPC ,LHMC ,LMBC ,LMECO,LMMC ,
     +        LFDC ,LSWC ,LUSC ,
     +        LEXS ,LUTS ,LDAS ,LCDS ,LECS ,LHCS ,LMUS ,LFOS ,LDDS ,
     +        LODS ,LLEPS,LMCS ,LCVS ,LCJS ,LCZS ,LCTS ,LDXS ,LCFS ,
     +        LCXS ,LSIS ,LCSS ,LCES ,LCAS ,LTBS ,LPBS ,LEBS ,LPES ,
     +        LEES ,LEMS ,LHBS ,LHES ,LHPS ,LHMS ,LMBS ,LMES ,LMMS ,
     +        LFDS ,LSWS ,LUSS ,LTE  ,LTEC ,LTES ,LZZ
      COMMON/RCLINK/LREV ,LRCO ,LRST ,LHEAD,LAA  ,
     +        LEX  ,LUT  ,LDA  ,LCD  ,LEC  ,LHC  ,LMU  ,LFO  ,LDD  ,
     +        LOD  ,LLEP ,LMC  ,LCV  ,LCJ  ,LCZ  ,LCT  ,LDX  ,LCF  ,
     +        LCX  ,LSI  ,LCS  ,LCE  ,LCA  ,LTB  ,LPB  ,LEB  ,LPE  ,
     +        LEE  ,LEM  ,LHB  ,LHE  ,LHP  ,LHM  ,LMB  ,LME  ,LMM  ,
     +        LFD  ,LSW  ,LUS  ,
     +        LEXC ,LUTC ,LDAC ,LCDC ,LECC ,LHCC ,LMUC ,LFOC ,LDDC ,
     +        LODC ,LLEPC,LMCC ,LCVC ,LCJC ,LCZC ,LCTC ,LDXC ,LCFC ,
     +        LCXC ,LSIC ,LCSC ,LCEC ,LCAC ,LTBC ,LPBC ,LEBC ,LPEC ,
     +        LEEC ,LEMC ,LHBC ,LHEC ,LHPC ,LHMC ,LMBC ,LMECO,LMMC ,
     +        LFDC ,LSWC ,LUSC ,
     +        LEXS ,LUTS ,LDAS ,LCDS ,LECS ,LHCS ,LMUS ,LFOS ,LDDS ,
     +        LODS ,LLEPS,LMCS ,LCVS ,LCJS ,LCZS ,LCTS ,LDXS ,LCFS ,
     +        LCXS ,LSIS ,LCSS ,LCES ,LCAS ,LTBS ,LPBS ,LEBS ,LPES ,
     +        LEES ,LEMS ,LHBS ,LHES ,LHPS ,LHMS ,LMBS ,LMES ,LMMS ,
     +        LFDS ,LSWS ,LUSS ,LTE  ,LTEC ,LTES ,LZZ
      INTEGER IQ,LQ,NZEBRA,IXSTOR,IXDIV,IXCONS,LMAIN,LR1,JCG
      INTEGER KWBANK,KWWORK,IWS
      REAL GVERSN,ZVERSN,FENDQ,WS,Q
C
      PARAMETER (KWBANK=69000,KWWORK=5200)
      COMMON/GCBANK/NZEBRA,GVERSN,ZVERSN,IXSTOR,IXDIV,IXCONS,FENDQ(16)
     +             ,LMAIN,LR1,WS(KWBANK)
      DIMENSION IQ(2),Q(2),LQ(8000),IWS(2)
      EQUIVALENCE (Q(1),IQ(1),LQ(9)),(LQ(1),LMAIN),(IWS(1),WS(1))
      EQUIVALENCE (JCG,JGSTAT)
      INTEGER       JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
C
      COMMON/GCLINK/JDIGI ,JDRAW ,JHEAD ,JHITS ,JKINE ,JMATE ,JPART
     +      ,JROTM ,JRUNG ,JSET  ,JSTAK ,JGSTAT,JTMED ,JTRACK,JVERTX
     +      ,JVOLUM,JXYZ  ,JGPAR ,JGPAR2,JSKLT
C
      EQUIVALENCE (WS(1),IWS(1))
*
* DEFINES THE MODES IN WHICH THE PROGRAM CAN BE
* GENERAL 3D MODE
      INTEGER MTHDIM
      PARAMETER (MTHDIM = 300)
* 2D MODEs
      INTEGER MTWDIM
      PARAMETER (MTWDIM = 200)
      CHARACTER*80 CHMETA
      INTEGER IMFOP
      COMMON/GRMETC/CHMETA
      COMMON/GRMETI/IMFOP
*     Internal GRope arrays defining the current viewing transformation.
*These could get changed as the program runs...
      REAL VPN,VUP,UMIN,UMAX,VMIN,VMAX,FPD,BPD,PRP,VWWNLM(4)
      EQUIVALENCE (VWWNLM(1),UMIN),(VWWNLM(2),UMAX)
      EQUIVALENCE (VWWNLM(3),VMIN),(VWWNLM(4),VMAX)
      REAL RX,RY,RZ,PRVP
      INTEGER LX,LY,LZ
      COMMON/GRVIEW/VPN(3),VUP(3),UMIN,UMAX,VMIN,VMAX,FPD,BPD,PRP(3),
     +VPD,PRVP(6),RX,RY,RZ,LX,LY,LZ, VRP(3),PRP2(3),PRVP2(6), PRVPV1(6),
     +PRVPV2(6),PRVPV3(6), UMIN2,UMAX2,VMIN2,VMAX2,BPD2,FPD2,PHIT
      REAL VRP,PRP2,VPD,PHIT
      REAL PRVP2
      REAL PRVPV1,PRVPV2,PRVPV3
      REAL XV0,YV0,ZV0,XV1,YV1,ZV1
      REAL UMIN2,UMAX2,VMIN2,VMAX2,BPD2,FPD2,VWWNL2(4)
      EQUIVALENCE (VWWNL2(1),UMIN2),(VWWNL2(2),UMAX2)
      EQUIVALENCE (VWWNL2(3),VMIN2),(VWWNL2(4),VMAX2)
      EQUIVALENCE (PRVP(1),XV0),(PRVP(2),XV1),(PRVP(3),YV0), (PRVP(4),
     +YV1),(PRVP(5),ZV0),(PRVP(6),ZV1)
*
*  Stores number of available colours (as given by PQCF)
*
      REAL GRRED(0:15),GRGREE(0:15),GRBLUE(0:15)
      COMMON /GRCOLO/NCOLI,ICOLA,NPCI,ICOLOR,GRRED,GRGREE,GRBLUE
      INTEGER NCOLI,ICOLA,NPCI,ICOLOR
      INTEGER        SYSRC,LCHNOD,MAILSN,LUPHON,ITIMEO,JOBPID,JENTRY,
     +               JMODE
      LOGICAL        BNOTIF,LPHONE,PHONSA,GOTCMD,TIMSET,LPLOT,LHEPVM
      COMMON /RCSYST/SYSRC,LCHNOD,MAILSN,LUPHON,ITIMEO,JOBPID,JENTRY,
     +               JMODE,
     +               BNOTIF,LPHONE,PHONSA,GOTCMD,TIMSET,LPLOT,LHEPVM
      CHARACTER*132  SYSCOM,BCOMND
      CHARACTER*16   CHNODE,JOBNAM,SENDER,USRNAM
      CHARACTER*40   PLTOPT
      CHARACTER*5    CHENTR
      CHARACTER*20   PLTCMD,PLTTER
      CHARACTER*31   CHQUEU
      COMMON /CCSYST/SYSCOM,BCOMND,
     +               CHNODE,JOBNAM,SENDER,USRNAM,
     +               PLTOPT,
     +               CHENTR,
     +               PLTCMD,PLTTER,
     +               CHQUEU
*
*     GPHIGS version:
*     GPhigs always sends postscript output to a file called
*     OUTPUTnn (where nn is the connection id).
*     As it doesn't use FORTRAN I/O we can pick any conid
*     without clashing with ROPE.
*
      CALL KUGETC(CMTYP,IER)
      COLMET=.FALSE.
      IF (CMTYP(1:4).EQ.'POSC') COLMET=.TRUE.
      IF(KUNPAR(N).GT.1) THEN
         CALL KUGETS(CFNAME,N)
      ELSE
         IMETA=IMETA+1
         WRITE (CFNAME,'(''META_'',I3.3)') IMETA
      ENDIF
*
*     open metafile
*
      KONIMF=10
*
*   Special action if last command used HIGZ graphics
*
*drw
      IF(CHMETA(1:1).NE.' ') THEN
         COLSAV=COLOUR
         COLOUR=COLMET
         KW=KWTYKU
         KWTYKU=-111
         CALL KUEXEC(CHMETA)
         CLOSE(UNIT=KONIMF)
         KWTYKU=KW
         COLOUR=COLSAV
         GO TO 30
      ENDIF
*drw
*
      IF (COLMET) THEN
         IF(.NOT.COLOUR) THEN
            COK='Yes'
            CALL KUPROC('I need to redraw to create colour metafile '//
     +      'on a monochrome display.  Is this OK?',COK,N)
            IF(COK(1:1).EQ.'Y' .OR. COK(1:2).EQ.'OK') THEN
               COLOUR=.TRUE.
               CALL KUEXEC('DRAW')
               COLOUR=.FALSE.
            ENDIF
         ENDIF
         CALL POPWK(KWIDMF,KONIMF,80795)
      ELSE
         IF(COLOUR) THEN
            COK='Yes'
            CALL KUPROC('I need to redraw to create monochrome '//
     +      'metafile on a colour display.  Is this OK?',COK,N)
            IF(COK(1:1).EQ.'Y' .OR. COK(1:2).EQ.'OK') THEN
               COLOUR=.FALSE.
               CALL KUEXEC('DRAW')
               COLOUR=.TRUE.
            ENDIF
         ENDIF
         CALL POPWK(KWIDMF,KONIMF,80791)
      END IF
*
*     set viewing transformations
*
      IF(MODE.EQ.MTWDIM) THEN
         CALL GRSVR2(KWIDMF)
      ELSE
         CALL GRSVWR(KWIDMF,-1)
      ENDIF
*
*     set colours
*
*drw 8/7/95      CALL GRSCR(KWIDMF,0,0.0,0.0,0.0)
*drw 8/7/95      CALL GRSCR(KWIDMF,1,1.0,1.0,1.0)
      DO 10 ICOL=2,15
         IF (COLMET) THEN
            CALL GRSCR(KWIDMF,ICOL,GRRED(ICOL),GRGREE(ICOL),
     +                                         GRBLUE(ICOL))
         ELSE
            CALL GRSCR(KWIDMF,ICOL,1.0,1.0,1.0)
         END IF
   10 CONTINUE
*
*     post event to metafile
*
      CALL PQPOST(KWIDGR,1,IER,NPOST,STRID,PRIORT)
      DO 20 N=1,NPOST
         CALL PQPOST(KWIDGR,N,IER,NPOST,STRID,PRIORT)
         IF (STRID.GT.0) CALL PPOST(KWIDMF,STRID,PRIORT)
   20 CONTINUE
      CALL PUWK(KWIDMF,1)
*
*     close workstation and rename metafile if necessary
*
      CALL PCLWK(KWIDMF)
   30 CONTINUE
      IF(CHMETA(1:1).NE.' ') THEN
         SYSCOM = '/bin/mv fort.10 '//CFNAME
      ELSE
         SYSCOM = '/bin/mv fort.010 '//CFNAME
      ENDIF
      CALL RQSYST(.TRUE.)
*
*
   40 RETURN
      END
